<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2023 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

use CB\Database\Table\UserTable;
use chillerlan\QRCode\QRCode;
use chillerlan\QRCode\QROptions;
use Joomla\CMS\Component\ComponentHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Filter\InputFilter;
use Joomla\CMS\Form\Form;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Language;
use Joomla\CMS\Language\LanguageHelper;
use Joomla\CMS\Language\Multilanguage;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Table\Table;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\User\UserHelper;
use Joomla\Component\Users\Site\Model\RegistrationModel;
use Joomla\Registry\Registry;
use Joomla\Utilities\ArrayHelper;

class EventbookingHelperOverrideRegistration extends EventbookingHelperRegistration
{
	/**
	 * Check to see whether this event still accept registration
	 *
	 * @param   EventbookingTableEvent  $event
	 *
	 * @return bool
	 */
	public static function acceptRegistration($event)
	{
		$db           = Factory::getDbo();
		$query        = $db->getQuery(true);
		$user         = Factory::getUser();
		
		if (!parent::acceptRegistration($event))
		{
		    return false;
		}
        $sql = 'SELECT 1 FROM #__eb_events as ev inner join #__eb_registrants as er on er.event_id = ev.id where ev.published = 1 and er.is_group_billing=0 
        and er.published=1 and er.user_id = '.$user->id.' and  ( "' .$event->event_date. '" < if(ev.event_end_date="0000-00-00 00:00:00",DATE_ADD(ev.event_date, INTERVAL 5 HOUR),ev.event_end_date) ) 
        and (if("'.$event->event_end_date.'"="0000-00-00 00:00:00",DATE_ADD("'.$event->event_end_date.'", INTERVAL 5 HOUR),"'.$event->event_end_date.'") > ev.event_date) and ev.id != ' . $event->id . ' limit 1';
		$db->setQuery($sql);
		$otherEvent = $db->loadResult();
		if ($otherEvent)
		{
		    $event->cannot_register_reason='registered_for_other_event';
		    return false;
		}
 
		//are we the owner of a group?
		$sql = 'SELECT 1 from #__eb_registrants as er where er.event_id=' . $event->id . ' and er.group_id=0 and er.published=1 and er.user_id = '.$user->id.' and er.is_group_billing=1 limit 1';
		$db->setQuery($sql);
		$groupOwner = $db->loadResult();

		if ($groupOwner)
		{
		    $event->cannot_register_reason='group_owner';
		    return false;
		}

		return true;
	}

}
