<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2023 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

JLoader::register('EventbookingModelCommonEvents', JPATH_ADMINISTRATOR . '/components/com_eventbooking/model/common/events.php');

use Joomla\CMS\Factory;

class EventbookingModelOverrideEvents extends EventbookingModelEvents
{
    public function __construct($config = [])
	{
		parent::__construct($config);

		$this->state->insert('filter_category_id', 'int', 0)
			->insert('filter_location_id', 'int', 0)
			->insert('filter_events', 'int', 0)
			->insert('filter_upcoming_events', 'int', 0)
			->insert('filter_from_date', 'string', '')
			->insert('filter_to_date', 'string', '')
			->setDefault('filter_order', 'tbl.event_date');
 	}
	
	protected function buildQueryWhere(JDatabaseQuery $query)
	{
		$user = Factory::getUser();

		$query->where('(tbl.created_by = ' . (int) $user->id .
		' or JSON_UNQUOTE(JSON_EXTRACT(tbl.custom_fields,"$.field_leader_id1")) = '.(int) $user->id .
		' or JSON_UNQUOTE(JSON_EXTRACT(tbl.custom_fields,"$.field_leader_id2")) = '. (int) $user->id .
		' or JSON_UNQUOTE(JSON_EXTRACT(tbl.custom_fields,"$.field_leader_id3")) = '.(int) $user->id . ')' );

		return EventbookingModelCommonEvents::buildQueryWhere($query);
	}
	protected function buildQueryJoins(JDatabaseQuery $query)
	{
		$query->leftJoin('#__viewlevels AS vl ON vl.id = tbl.access')
			->leftJoin('#__eb_locations AS l ON tbl.location_id = l.id')
			->leftJoin(
				'#__eb_registrants AS rgt ON (tbl.id = rgt.event_id AND rgt.group_id = 0 AND (rgt.published in (1,4) OR (rgt.published = 0 AND rgt.payment_method LIKE "os_offline%")))'
			);

		return $this;
	}
}
