<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2023 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

JLoader::register('EventbookingModelCommonRegistrants', JPATH_ADMINISTRATOR . '/components/com_eventbooking/model/common/registrants.php');

use Joomla\CMS\Factory;


class EventbookingModelOverrideHistory extends EventbookingModelHistory
{
	protected $regId = null;
	/**
	 * Builds a WHERE clause for the query
	 *
	 * @param   JDatabaseQuery  $query
	 *
	 * @return $this
	 */
	protected function buildQueryWhere(JDatabaseQuery $query)
	{
		$db = Factory::getDbo();
		$user   = Factory::getUser($this->userId);
		$userId = $user->id;
		$name = $user->name;
		$email=$user->email;
		$config = EventbookingHelper::getConfig();
		$query->where('(tbl.published >= 1 OR tbl.payment_method LIKE "os_offline%")');
		if ($this->regId)
		{
			$sql  = 'SELECT email, user_id, first_name, last_name FROM #__eb_registrants where id='.$this->regId;
			$db->setQuery($sql);
			$reg = $db->loadObject();
			$email = $reg->email;
			$userId = $reg->user_id;
			$first_name = $reg->first_name;
			$last_name = $reg->last_name;
			$name=$first_name.' '.$last_name;
		}
		if ($userId)
	    {
		    $query->where('(tbl.user_id =' . $userId . ' OR (concat(tbl.first_name," ",tbl.last_name)  = ' . $this->getDbo()->quote($name). '))');
	    }
	    elseif ($first_name && $last_name)
	    {
		    $query->where('(tbl.first_name =' . $this->getDbo()->quote($first_name). ' AND tbl.last_name = ' . $this->getDbo()->quote($last_name) . ')');
	    }
	    elseif ($email)
	    {
		    $query->where('(tbl.email = ' . $this->getDbo()->quote($email) . ')');
	    }

		if (!$config->get('include_group_billing_in_registrants', 1))
		{
			$query->where(' tbl.is_group_billing = 0 ');
		}

		if (!$config->include_group_members_in_registrants)
		{
			$query->where(' tbl.group_id = 0 ');
		}

        $outputstr=json_encode($query->__toString());
        echo "<script>console.log(".$outputstr.")</script>"; 
       
		return $this;
	}
	/**
	 * Set ID of registration record to get registration history
	 *
	 * @param   int  $regId
	 */
	public function setRegId($regId)
	{
		if ($regId > 0)
		{
			$this->regId = $regId;
		}
	}
}
