<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2023 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\User\UserHelper;
use Joomla\Registry\Registry;
use Joomla\CMS\Log\Log;
JLoader::register('EventBookingModelRegister', JPATH_SITE . '/components/com_eventbooking/model/register.php');

class EventbookingModelOverrideRegister extends EventBookingModelRegister
{
	/**
	 * Store group members data
	 *
	 * @param   EventbookingTableRegistrant  $row
	 * @param   array                        $fees
	 */
	protected function storeGroupMembers($row, $fees)
	{
		$membersForm           = $fees['members_form'];
		$membersTotalAmount    = $fees['members_total_amount'];
		$membersDiscountAmount = $fees['members_discount_amount'];
		$membersTaxAmount      = $fees['members_tax_amount'];
		$membersLateFee        = $fees['members_late_fee'];
		$membersAmount         = $fees['members_amount'];

		for ($i = 0; $i < $row->number_registrants; $i++)
		{
			/* @var EventbookingTableRegistrant $rowMember */
			$rowMember                     = $this->getTable('Registrant');
			$rowMember->group_id           = $row->id;
			$rowMember->transaction_id     = $row->transaction_id;
			$rowMember->ticket_qrcode      = EventbookingHelperRegistration::getTicketQRCode();
			$rowMember->event_id           = $row->event_id;
			$rowMember->payment_method     = $row->payment_method;
			$rowMember->payment_status     = $row->payment_status;
			$rowMember->user_id            = $row->user_id;
			$rowMember->register_date      = $row->register_date;
			$rowMember->user_ip            = $row->user_ip;
			$rowMember->language           = $row->language;
			$rowMember->created_by         = $row->created_by;
			$rowMember->registration_code  = EventbookingHelperRegistration::getRegistrationCode();
			$rowMember->total_amount       = $membersTotalAmount[$i];
			$rowMember->discount_amount    = $membersDiscountAmount[$i];
			$rowMember->late_fee           = $membersLateFee[$i];
			$rowMember->tax_amount         = $membersTaxAmount[$i];
			$rowMember->amount             = $membersAmount[$i];
			$rowMember->number_registrants = 1;

			$rowMember->subscribe_newsletter = $row->subscribe_newsletter;
			$rowMember->agree_privacy_policy = 1;
			$rowMember->language             = $row->language;

			$membersForm[$i]->removeFieldSuffix();
			$memberData = $membersForm[$i]->getFormData();

			// Filter members
			$memberFields = $membersForm[$i]->getFields();
			$memberData   = $this->filterFormData($memberFields, $memberData);
			
			// JD get userid
        	$db = Factory::getDbo();
        	$sql = "select id from jos_users where name='".$memberData['first_name']." ".$memberData['last_name']."'";
        	$db->setQuery($sql);
        	$uid=$db->loadResult();
			if ($uid)
			{
			    $rowMember->user_id = $uid;
			}

			$rowMember->bind($memberData);
			$rowMember->store();

			//Store members data custom field
			$membersForm[$i]->storeData($rowMember->id, $memberData);
		}
	}
}
