<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2023 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

JLoader::register('EventbookingModelCommonRegistrants', JPATH_ADMINISTRATOR . '/components/com_eventbooking/model/common/registrants.php');

class EventbookingModelOverrideRegistrantlist extends EventbookingModelRegistrantlist
{
	/**
	 * Build where clause of the query
	 *
	 * @see RADModelList::buildQueryWhere()
	 */
	protected function buildQueryWhere(JDatabaseQuery $query)
	{
		$config = EventbookingHelper::getConfig();

		$includeGroupBillingRecords = $config->get(
			'include_group_billing_in_registrants_list',
			$config->get('include_group_billing_in_registrants', 1)
		);
		$includeGroupMemberRecords  = $config->get(
			'include_group_members_in_registrants_list',
			$config->get('include_group_members_in_registrants', 0)
		);

		if (!$includeGroupBillingRecords && $includeGroupMemberRecords)
		{
			$query->where(' tbl.is_group_billing = 0 ');
		}

		if (!$includeGroupMemberRecords)
		{
			$query->where(' tbl.group_id = 0 ');
		}

		if ($this->state->registrant_type == 3)
		{
			$query->where('tbl.published in (3,5)');
		}
		else
		{
			$query->where('(tbl.published in (1,4) OR (tbl.published = 0 AND tbl.payment_method LIKE "os_offline%"))');
		}

		return EventbookingModelCommonRegistrants::buildQueryWhere($query);
	}
}
