<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2023 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Multilanguage;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\PluginHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Toolbar\ToolbarHelper;
use Joomla\CMS\Uri\Uri;
use Joomla\Registry\Registry;
use Joomla\Utilities\ArrayHelper;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;

class EventbookingViewOverrideEventHtml extends EventbookingViewEventHtml
{
	/**
	 * Add toolbar buttons for submit event form
	 */
	protected function addToolbar()
	{
        $db = Factory::getDbo();
        $isSuperUser = MBWCHelper::isSuperUser();
        $hasTripReport=false;
        $msg="";
		if ($this->item->id)
		{
    		$sql = "select 1 from jos_mbwc_tripreports where event_id=".$this->item->id;
    		$db->setQuery($sql);
    		$hasTripReport = $db->loadResult();
		}
        $dateParts = explode(' ', $this->item->event_date) ;
	    $startDate = strtotime($dateParts[0]) ;
        $dateParts2 = explode(' ', $this->item->event_end_date) ;
	    $endDate = strtotime($dateParts2[0]) ;
	    if (!$endDate || $endDate == '0000-00-00 00:00:00')
	    {
	        $endDate=$startDate;
	    }
        if (!$isSuperUser && ($hasTripReport || $endDate < strtotime(date('d-m-Y'). ' - 3 days')))
        {
            $msg='You cannot edit an event after you have submitted the Trip Report or if the event was over 3 days ago.';
        }
        elseif ($this->item->published ==2)
        {                                           
            $msg='You cannot edit a Cancelled event.';
        }
        
        if ($msg)
        {
            $app = Factory::getApplication();
            $app->enqueueMessage($msg, 'Info');
         }
        else
        {
    		ToolbarHelper::apply('apply', 'JTOOLBAR_APPLY');
    		ToolbarHelper::save('save', 'JTOOLBAR_SAVE');
        }
		if ($this->item->id)
		{
			ToolbarHelper::save2copy('save2copy');
		}

		if ($this->item->id)
		{
			ToolbarHelper::cancel('cancel', 'JTOOLBAR_CLOSE');
		}
		else
		{
			ToolbarHelper::cancel('cancel', 'JTOOLBAR_CANCEL');
		}
	}
}
