<?php
/**
 * @component  J!Track Gallery (jtg) for Joomla! 2.5 and 3.x
 *
 *
 * @package     Comjtg
 * @subpackage  Frontend
 * @author      Christophe Seguinot <christophe@jtrackgallery.net>
 * @author      Pfister Michael, JoomGPStracks <info@mp-development.de>
 * @author      Christian Knorr, InJooOSM  <christianknorr@users.sourceforge.net>
 * @copyright   2015 J!TrackGallery, InJooosm and joomGPStracks teams
 *
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU/GPLv3
 * @link        http://jtrackgallery.net/
 *
 */
use Joomla\CMS\Log\Log;
use Joomla\CMS\Factory;

// No direct access
defined('_JEXEC') or die('Restricted access');
jimport('joomla.application.component.controller');
/**
 * JtgControllerFiles class for the jtg component
 *
 * @package     Comjtg
 * @subpackage  Frontend
 * @since       0.8
 */

class JtgControllerMbwc extends JtgController
{
	/**
	 * function_description
	 *
	 */
	public function __construct()
	{
		parent::__construct();
	}

   function getImages($id)
   {
       $mainframe = JFactory::getApplication(); // TODO: remove this line?
       $db = JFactory::getDBO();
       $query = "SELECT * FROM #__jtg_photos"
         . "\n WHERE trackID='" . $id . "'";
       $db->setQuery($query);
       $result = $db->loadObjectList();

       return $result;
	}
	/**
	 * function_description
	 *
	 * @param   unknown_type  $id  param_description
	 *
	 * @return return_description
	 */
	function updateFile ($id)
	{
		$app = Factory::getApplication();
		$user = Factory::getUser();
		if (!$user->authorise('core.edit', 'com_jtg') &&
          !($user->authorise('core.create', 'com_jtg') && $app->getUserState('com_jtg.newfileid') == $id))
		{
			if (!isset($this->track) || $this->track->id != $id) $this->getFile($id);
			if (!($user->authorise('core.edit.own', 'com_jtg') && $user->id == $this->track->uid))
	      {
				$app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
      	   $this->setRedirect(JRoute::_('index.php?option=com_jtg&view=jtg',false), false);
				return "Action not permitted";
			}
		}

		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		$db = JFactory::getDBO();
		$user = JFactory::getUser();

		// Get the post data
		$input = $app->input; 
		$catid = $input->get('catid', null, 'array');
		$catid = $catid ? implode(',', $catid) :  '';
		$level = $input->get('level', 0, 'integer');
		$title = $db->quote($input->get('title', '', 'string'));

		$terrain = $input->get('terrain', null, 'array');

		if ($terrain)
		{
			$terrain = $terrain ? implode(', ', $terrain) : '';
		}
		else
		{
			$terrain = '';
		}

		/* Joomla Jinput strips html tags!!
		 http://stackoverflow.com/questions/19426943/joomlas-jinput-strips-html-with-every-filter
		*/
		$desc = $db->escape(implode(' ', $input->get('description', '', 'array')));

		$access = $input->getInt('access', 0);
		$hidden = $input->getInt('hidden', 0);
		$published = $input->getInt('published', 0);

		$default_map = $input->get('default_map');

		$mappreview = $input->get('mappreview','','BASE64');
		if (!empty($mappreview)) {
			$previewdata = base64_decode($mappreview);
			$imgpath = JPATH_SITE . '/images/jtrackgallery/maps/track_' . $id . '.png';
			file_put_contents($imgpath, $previewdata);
		}

		$imagelist = $this->getImages($id);
		
		$imgpath = JPATH_SITE . '/images/jtrackgallery/uploaded_tracks_images/track_' . $id . '/';
		foreach ($imagelist as $image)
		{
			$delimage = $input->get('deleteimage_' . $image->id);
         if ($delimage !== null)
         {
            JFile::delete($imgpath . $delimage);
            JFile::delete($imgpath . 'thumbs/' . 'thumb0_' . $delimage);
            JFile::delete($imgpath . 'thumbs/' . 'thumb1_' . $delimage);
            JFile::delete($imgpath . 'thumbs/' . 'thumb2_' . $delimage);
            $query = "DELETE FROM #__jtg_photos\n WHERE id='".$image->id."'";
            $db->setQuery($query);
            $db->execute();
         }
  			// Set image title
         $img_title = $input->get('img_title_' . $image->id, '', 'string');
         if ($img_title !== null and $img_title != $image->title) {
             $query = "UPDATE #__jtg_photos SET title=".$db->quote($img_title)." WHERE id='".$image->id."'";
             $db->setQuery($query);
             $db->execute();

			}
      }

		// Images upload part
		$newimages = $input->files->get('images');
		$cfg = JtgHelper::getConfig();
		$types = explode(',', $cfg->type);
		if ($newimages)
		{
			foreach ($newimages as $newimage)
			{
				$filename = JFile::makesafe($newimage['name']);
				$ext = JFile::getExt($filename);

				if (in_array(strtolower($ext), $types))
				{
					JtgHelper::createimageandthumbs($id,$newimage['tmp_name'], $ext, $filename);
				}
			}
		}

		$query = "UPDATE #__jtg_files SET" .
				"\n catid='" . $catid . "'," .
				"\n title=" . $title . "," .
				"\n terrain='" . $terrain . "'," .
				"\n description='" . $desc . "'," .
				"\n level='" . $level . "'," .
				"\n hidden='" . $hidden . "'," .
				"\n published='" . $published . "'," .
				"\n default_map='" . $default_map . "'," .
				"\n access='" . $access . "'" .
				"\n WHERE id='" . $id . "'";

		$db->setQuery($query);
		$db->execute();

		return true;
	}

	function update()
	{
		jimport('joomla.filesystem.file');
		$user		= JFactory::getUser();
		$app = Factory::getApplication();

		if (!$user->get('id'))
		{

			$this->setRedirect(JRoute::_('index.php?option=com_jtg', false), false);
		}

		// Check for request forgeries
		JSession::checkToken() or jexit(JTEXT::_('JINVALID_TOKEN'));
		$id = $app->input->getInt('id');

		$errormsg = $this->updateFile($id);

		if ($errormsg !== true)
		{
			$app->enqueueMessage($errormsg, 'error');
		}
		else
		{
			$app->setUserState('com_jtg.newfileid',-1);
			$this->setRedirect(JRoute::_('index.php?option=com_jtg&view=track&id=' . $id, false), false);
		}
	}

	/**
	 * function_description
	 *
	 * @return integer id of new file
	 */
	function saveFile ()
	{
		$app = Factory::getApplication();
		$user = Factory::getUser();

		if (!$user->authorise('core.create', 'com_jtg')) {
			$app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			$this->setRedirect(JRoute::_('index.php?option=com_jtg&view=jtg',false), false);
			return false;
		}

		jimport('joomla.filesystem.file');
		jimport('joomla.filesystem.folder');

		$db = JFactory::getDBO();

		// Get the post data
		$input = JFactory::getApplication()->input;
		$catid = $input->get('catid', null, 'array');
		$catid = $catid ? implode(',', $catid) : '';
		$level = $input->get('level', 0, 'integer');
		$title = $input->get('title', '', 'string');
		$terrain = $input->get('terrain', null, 'array');
		$terrain = $terrain ? implode(', ', $terrain) : '';
		$desc = $db->escape(implode(' ', $input->get('description', '', 'array')));
		$file = $input->files->get('file');
		$uid = $user->id;
		$date = date("Y-m-d");
		$images = $input->files->get('images');
		$access = $input->getInt('access', 0);
		$hidden = $input->getInt('hidden', 0);
		$published = $input->getInt('published', 0);

		// Upload the file
		$upload_dir = JPATH_SITE . '/images/jtrackgallery/uploaded_tracks/';
		$filename = strtolower(JFile::makeSafe($file['name']));
		$newfile = $upload_dir . $filename;

		if (JFile::exists($newfile))
		{
			$alert_text = json_encode(JText::sprintf("COM_JTG_FILE_ALREADY_EXISTS", $filename));

			$app->enqueueMessage($alert_text, 'error');
			return false;
		}

		if (! JFile::upload($file['tmp_name'], $newfile))
		{
			$alert_text = json_encode(JText::_('COM_JTG_UPLOAD_FAILS'));
			$app->enqueueMessage($alert_text, 'error');
			die("<script type='text/javascript'>alert($alert_text);window.history.back(-1);</script>");
		}
		else
		{
			chmod($newfile, 0777);
		}

		// Get the start coordinates..

		// Default unit
		$gpsData = new GpsDataClass("kilometer");
		$gpsData = $gpsData->loadFileAndData( $newfile, $filename );
		if (strlen($title)==0) {
			$title = trim($gpsData->trackname);
		}
		if (strlen($title)==0) {
			$title = JFile::stripExt($file['name']);
		}
		$errors = $gpsData->displayErrors();

		if ($errors)
		{
			$map = "";
			$coords = "";
			$distance_float = 0;
			$distance = 0;

			// Try to delete the file
			if (JFile::exists($upload_dir . $filename))
			{
				JFile::delete($upload_dir . $filename);
			}

			$alert_text = json_encode(JText::_('COM_JTG_NO_SUPPORT') . '\n' . $errors);
			$app->enqueueMessage($alert_text, 'error');
			return false;
		}

		$start_n = $gpsData->start[1];
		$start_e = $gpsData->start[0];
		$coords = $gpsData->allCoords;
		$isTrack = $gpsData->isTrack;
		$isWaypoint = $gpsData->isWaypoint;
		$isRoute = $gpsData->isRoute;
		$isCache = $gpsData->isCache;
		$distance = $gpsData->distance;

		$query = "INSERT INTO #__jtg_files SET"
		. "\n uid=" . $uid . ","
		. "\n submitter_id=" . $uid . ","
		. "\n catid='" . $catid . "',"
		. "\n title=" . $db->quote($title) . ","
		. "\n file=" .	$db->quote($filename) . ","
		. "\n terrain='" . $terrain . "',"
		. "\n description='" . $desc . "',"
		. "\n published='" . $published . "',"
		. "\n date='" . $date . "',"
		. "\n start_n='" . $start_n . "',"
		. "\n start_e='" . $start_e . "',"
		. "\n distance='" . $distance . "',"
		. "\n ele_asc='" . round($gpsData->totalAscent, 0) . "',"
		. "\n ele_desc='" . round($gpsData->totalDescent, 0) . "',"
		. "\n level='" . $level . "',"
		. "\n access='" . $access . "',"
		. "\n hidden='" . $hidden . "',"
		. "\n istrack='" . (int)$isTrack . "',"
		. "\n iswp='" . (int)$isWaypoint . "',"
		. "\n isroute='" . (int)$isRoute . "',"
		. "\n iscache='" . (int)$isCache . "',"
		. "\n hits='0',"
		. "\n checked_out='0'";

		$db->setQuery($query);
		if (! $db->execute()) echo $db->stderr();

		$query = "SELECT id FROM #__jtg_files WHERE file='" . strtolower($filename) . "'";

		$db->setQuery($query);
		$rows = $db->loadObject();

		// Images upload part
		$cfg = JtgHelper::getConfig();
		$types = explode(',', $cfg->type);

		if (count($images) > 0)
		{
			foreach ($images as $image)
			{
				if ($image['name'] != "")
				{
					$imgfilename = JFile::makesafe($image['name']);
					$ext = JFile::getExt($imgfilename);

					if (in_array(strtolower($ext), $types))
					{
						JtgHelper::createimageandthumbs($rows->id,$image['tmp_name'], $ext, $imgfilename);
					}
				}
			}
		}

		// Notify configured user by e-mail
		$params = $app->getParams();
		if ((int) $params->get('upload_notify_uid'))
		{
			$mailer = JFactory::getMailer();
			$user = JUser::getInstance((int)  $params->get('upload_notify_uid'));
			$recipient = $user->email;
			if (strlen($recipient))
			{
				$mailer->addRecipient($recipient);
				$link = JRoute::_(JUri::base() . "index.php?option=com_jtg&view=track&layout=default&id=" . $rows->id);
				$msg = JText::_('COM_JTG_NEW_TRACK_MAIL_MSG');
				$config = JFactory::getConfig();
         	$sitename = $config->get('sitename');
				$body = sprintf($msg, $sitename, $link);
				$mailer->setSubject(JText::_('COM_JTG_NEW_TRACK_MAIL_SUBJECT'));
				$mailer->setBody($body);
				$mailer->isHtml(true);
				$senderr = $mailer->Send();
				if ( ! $senderr )
				{
					$app->enqueueMessage('Error sending notification email: ' . $senderr->__toString());
				}
			}
		}
		return $rows->id;
	}
	/**
	 * Save GPS file with information fields
	 *
	 * @return return_description
	 */
	function save()
	{
		jimport('joomla.filesystem.file');
		$app = JFactory::getApplication();

		// Check for request forgeries
		JSession::checkToken() or jexit(JTEXT::_('JINVALID_TOKEN'));
		$file = JFactory::getApplication()->input->files->get('file');

		if (!$file['name'])
		{
			$app->enqueueMessage(JText::_('COM_JTG_FILE_UPLOAD_NO_FILE'), 'error');
			exit;
		}

		$ext = JFile::getExt($file['name']);

		if ($ext == 'kml' || $ext == 'gpx' || $ext == 'tcx')
		{
		    $id=$this->saveFile();
			if (!$id)
			{
		        $app->enqueueMessage('Error uploading gpx. Check if file already exists', 'error');
			    $this->setRedirect(JRoute::_('index.php?option=com_jtg&view=track&layout=form', false), false);
			}
			else
			{
 			    $this->setRedirect(JRoute::_('index.php?option=com_jtg&view=track&layout=default&id=' . $id, false), false);
			}
		}
		else
		{
			$app->enqueueMessage($file['name'] . JText::_('COM_JTG_GPS_FILE_ERROR'), 'error');
			exit;
		}
	}

	/**
	 * Upload GPX file; goes back to form view for map rendering
	 *
	 * @return return_description
	 */
	function uploadGPX()
	{
      // Check for request forgeries
      JSession::checkToken() or jexit(JTEXT::_('JINVALID_TOKEN'));
      $file = JFactory::getApplication()->input->files->get('file');
		$app = JFactory::getApplication();

		if (!JFactory::getUser()->authorise('core.create', 'com_jtg')) {
			$app->enqueueMessage(JText::_('JERROR_ALERTNOAUTHOR'), 'error');
			$this->setRedirect(JRoute::_('index.php?option=com_jtg&view=jtg',false), false);
			return;
		}
      if (!$file['name'])
      {
		 $app->enqueueMessage(JText::_('COM_JTG_FILE_UPLOAD_NO_FILE'), 'error');
         exit;
      }

      $model = $this->getModel('track');

      $ext = JFile::getExt($file['name']);

      if ($ext == 'kml' || $ext == 'gpx' || $ext == 'tcx')
		{
			$id = $model->saveFile();
			if (!$id)
			{  
		        $app->enqueueMessage('Error uploading gpx. Check if file already exists', 'error');
			    $this->setRedirect(JRoute::_('index.php?option=com_jtg&view=track&layout=form', false), false);
			}
			else {
				JFactory::getApplication()->setUserState('com_jtg.newfileid',$id);
			    $this->setRedirect(JRoute::_('index.php?option=com_jtg&view=track&layout=form&id=' . $id, false), false);
			}
      }
      else
      {  
		 $app->enqueueMessage($file['name'] . JText::_('COM_JTG_GPS_FILE_ERROR'), 'error');
         exit;
      }
	}
}
