<?php

/**
 * @package     Joomla.Administrator
 * @subpackage  com_banners
 *
 * @copyright   (C) 2018 Open Source Matters, Inc. <https://www.joomla.org>
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;
use Joomla\CMS\Component\Router\RouterFactoryInterface;
use Joomla\CMS\Dispatcher\ComponentDispatcherFactoryInterface;
use Joomla\CMS\Extension\ComponentInterface;
use Joomla\CMS\Extension\MVCComponent;
use Joomla\CMS\Extension\Service\Provider\ComponentDispatcherFactory;
use Joomla\CMS\Extension\Service\Provider\MVCFactory;
use Joomla\CMS\Extension\Service\Provider\CategoryFactory;
use Joomla\CMS\Extension\Service\Provider\RouterFactory;
use Joomla\CMS\MVC\Factory\MVCFactoryInterface;
use Joomla\DI\Container;
use Joomla\DI\ServiceProviderInterface;
use MBWC\Component\MBWC\Administrator\Extension\MBWCComponent;

return new class() implements ServiceProviderInterface
{

public function register(Container $container) 
{
  $container->registerServiceProvider(new CategoryFactory('\\MBWC\\Component\\MBWC'));  
  $container->registerServiceProvider(new MVCFactory('\\MBWC\\Component\\MBWC'));
  $container->registerServiceProvider(new ComponentDispatcherFactory('\\MBWC\\Component\\MBWC'));
  $container->registerServiceProvider(new RouterFactory('\\MBWC\\Component\\MBWC'));
  $container->set(
   ComponentInterface::class,
    function (Container $container) 
    {
       $component = new MBWCComponent($container->get(ComponentDispatcherFactoryInterface::class));
       $component->setMVCFactory($container->get(MVCFactoryInterface::class));
       $component->setRouterFactory($container->get(RouterFactoryInterface::class));

       return $component;
    }
    );
 }
};
?>