<?php
namespace MBWC\Component\MBWC\Site\Controller;

use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Factory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Log\Log;

require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

class EventController extends BaseController
{
    public function send_registrants_mail()
    {
		$app = Factory::getApplication() ;
		$config = \EventbookingHelper::getConfig();	
		$eventId = $app->input->getInt('event_id') ;
		$subject = $app->input->getVar('subject') ;
		$emails = explode(",",$app->input->getVar('emails')) ;
		$content = $app->input->get('content', '', 'raw'); 
		$Itemid = $app->input->getVar('Itemid') ;
		$return = $app->input->getVar('return') ;
		$tmpl = $app->input->getVar('tmpl') ;
		$user = Factory::getUser();
		$waitlist = $app->input->getVar('waitlist') ;
		if ($config->from_email)
		{
			$fromEmail = $config->from_email;
		}			
		else
		{
            $fromEmail = $app->getCfg('mailfrom');
		}			
	    $db = Factory::getDbo();
		$sql = "SELECT *, JSON_UNQUOTE(json_extract(custom_fields,'$.field_leader_id1')) as field_leader_id1 FROM #__eb_events WHERE id=".$eventId ;
		$db->setQuery($sql);
		$rowEvent = $db->loadObject() ;

		$sql = "select name as leader_name, email as leader_email from #__users where id = ".$rowEvent->field_leader_id1;
     	$db->setQuery($sql) ;
		$row = $db->loadObject();
		
		$replyName = $row->leader_name;
		$replyEmail = $row->leader_email;
        if ($waitlist == 1)
        {
            $published="3";
        }
        else
        {
            $published="1";
        }
		
		if ($emails)
		{ 
 			if (MBWCHelper::sendMail($replyEmail, $subject, $content, 1, null, $emails, null, $replyEmail, $replyName))
			{
 		        $msg = "Mail sent successfully.";
 		        if ($return=="events")
			    {
                    $url = \EventbookingHelperRoute::getViewRoute('events', $Itemid);	
			    }
 		        elseif ($return=="event")
			    {
 		            $url = "index.php?option=com_eventbooking&view=event&id=".$eventId."&Itemid=".$Itemid;
			    }
			    else
			    {
			        $url = "index.php?option=com_mbwc&view=registrantlist&id=".$eventId."&tmpl=component&waitlist=".$waitlist;
			    }
			}
			else
			{
			    $url = "index.php?option=com_mbwc&view=mailregistrants&event_id=".$eventId."&Itemid=".$Itemid."&waitlist=".$waitlist."&return=".$return;
			    if ($tmpl === "component")
			    {
			        $url=$url."&tmpl=component";
			    }
			    $msg= "Error sending mail";
			}
		}	
		else
		{
		    $msg= "No one to email.";
			$url = "index.php?option=com_mbwc&view=mailregistrants&event_id=".$eventId."&Itemid=".$Itemid."&waitlist=".$waitlist."&return=".$return;
		    if ($tmpl === "component")
		    {
		        $url=$url."&tmpl=component";
		    }
		}    
        Log::add($user->get('name').' Send email to registrants:'.json_encode($emails).' msg='.$msg, Log::INFO, 'com_mbwc');
		$url=Route::_($url,false);
        $this->setRedirect($url,$msg);
    }
    public function send_leader_mail()
    {
		$config = \EventbookingHelper::getConfig();	
		$app = Factory::getApplication() ;
		$eventId = $app->input->getInt('event_id') ;
		$emails = $app->input->getVar('emails') ;
		$title = $app->input->getVar('title') ;
		$content =  $app->input->get('content', '', 'raw'); 
		$ItemId = $app->input->getVar('ItemId') ;
		if ($emails)
		{
			//send mail
			$user = Factory::getUser();
			
			$replyName = $user->get('name');
			if ($replyName)
			{
			    $replyStr=" by ".$replyName;
			}
			$replyEmail = $user->get('email');
			$ccEmail = $replyEmail;
			if ($emails === $ccEmail) 
			{
			    $ccEmail=null;
			}
			
			if (MBWCHelper::sendMail($emails, "Mail Leader button pressed" . $replyStr." for event ".$title , $content, 1, $ccEmail, null, null, $replyEmail, $replyName))
			{
 		        $msg = "Mail sent successfully.";
 		        $url = Route::_(\EventbookingHelperRoute::getEventRoute($eventId, 0, $Itemid));
			}
			else
			{
			    $url = Route::_("index.php?option=com_eventbooking&view=mailleader&event_id=".$eventId."&Itemid=".$Itemid,false);
			    $msg= "Error sending mail";
			}
		}	
		else
		{
		    $msg= "No one to email.";
			$url = Route::_("index.php?option=com_mbwc&view=mailleader&event_id=".$eventId."&Itemid=".$Itemid, false);
		}    
        $this->setRedirect($url,$msg);
    }
	public function cancel($id, $reason) {
		$db = Factory::getDbo();
		$sql = " UPDATE #__eb_events SET published=2, custom_fields=JSON_SET(custom_fields, '$.field_cancel_reason',".$db->quote($reason,true).") WHERE id=$id";
		$db->setQuery($sql) ;
		if (!$db->execute())
			return false;
		return true ;
	}
	public function uncancel($id,$reason) {
		$db = Factory::getDbo();
		$sql = " UPDATE #__eb_events SET published=1, custom_fields=JSON_SET(custom_fields, '$.field_cancel_reason',".$db->quote($reason,true).") WHERE id=$id";
		$db->setQuery($sql) ;
		if (!$db->execute())
			return false;
		return true ;
	}
	public function cancel_event()
    {
		$app = Factory::getApplication() ;
		$db = Factory::getDbo();
		$user = Factory::getUser() ;
		$id = $app->input->getInt('event_id', 0);
        $reason = $app->input->getVar('reason') ;
		$config = \EventbookingHelper::getConfig();
		$return =  $app->input->getVar('return') ;

		//Get the event object
		$sql = "SELECT *, JSON_UNQUOTE(json_extract(custom_fields,'$.field_leader_id1')) as field_leader_id1 FROM #__eb_events WHERE id=".$id ;
		$db->setQuery($sql);
		$rowEvent = $db->loadObject() ;

        Log::add($user->get('name').' Cancel Event:'.$rowEvent->title, Log::INFO, 'com_mbwc');
        
		$ret =  $this->cancel($id, $reason);
        if (!$ret)
        {
			$msg = "Error Cancelling Event";
		}
		else
		{
    		$sql = "select name as leader_name, email as leader_email from #__users where id = ".$rowEvent->field_leader_id1;
         	$db->setQuery($sql) ;
    		$row = $db->loadObject();

    		$replyName = $row->leader_name;
    		$replyEmail = $row->leader_email;

			// also email people on waitlist and pending visitors and the activity convenor
			$sql = 'SELECT distinct email FROM #__eb_registrants WHERE (published=1 or published=3 or published=4 or published=5) and is_group_billing=0 and event_id='.$id.' and email != "'. $replyEmail.'" and email is not null and email != ""
                    union select distinct b.email from jos_comprofiler as a, jos_users as b where a.user_id = b.id and replace(replace(a.cb_eventcoordinatorrole,"*|",""),"|",",") regexp CONCAT("^",(select GROUP_CONCAT(REPLACE(REGEXP_REPLACE(d.name, "[0-9]+", ""), " ", "") SEPARATOR "|")  from jos_eb_event_categories as c inner join jos_eb_categories as d on d.id = c.category_id and c.event_id='.$id.' and email != "'. $replyEmail.'" group by c.event_id),"$")
			        and exists (select 1 from jos_eb_events where id='.$id.' and DAYOFWEEK(event_date) not in (1,7)) 
			        union select distinct b.email from jos_comprofiler as a, jos_users as b where a.user_id = b.id and a.cb_eventcoordinatorrole like "%Sunday%" and exists (select 1 from jos_eb_events where id='.$id.' and DAYOFWEEK(event_date) =1)    	    
			        union select distinct b.email from jos_comprofiler as a, jos_users as b where a.user_id = b.id and a.cb_eventcoordinatorrole like "%Saturday%" and exists (select 1 from jos_eb_events where id='.$id.' and DAYOFWEEK(event_date) =7)';    	    
			        $db->setQuery($sql) ;
    		$emails = $db->loadColumn();

            if (strpos(strtolower($rowEvent->title),"test")===false)
            {
    		    $emails[]="tripreports@mbwc.org.au";
            }

             $content =
            "Dear Member,<br>" .
            "<br>" .
            "The Leader has had to cancel the event: " . $rowEvent->title .
            " on the " . $rowEvent->event_date . ".<br>";
            if ($reason)
            {
                $content = $content . "Reason given: ". $reason . "<br>";
            }
            $content = $content ."<br>" .
            "Please check the website again in the next 24-48h as we will endeavor to put up a replacement event.<br>".
            "Regards, <br>" .
            "MBWC Events Management";

			if (MBWCHelper::sendMail($replyEmail, "The Event ". $rowEvent->title." has been cancelled", $content, 1, null, $emails, null, $replyEmail, $replyName))
			{
 		        $msg = "Event Cancelled. Mail sent successfully.";
			}
			else
			{
		        $msg = "Event Cancelled. Error sending mail";
			}
		}
		if ($return && $return === "event")
		{
			$this->setRedirect( Route::_(
				'index.php?option=com_eventbooking&view=event&id=' . $id . '&Itemid=' . $app->input->getInt('Itemid'),
				false),$msg);
		}
		else
		{
            $this->setRedirect(Route::_(\EventbookingHelperRoute::getViewRoute('events', $app->input->getInt('Itemid')), false), $msg);	
		}
    }
    public function uncancel_event()
    {
		$app = Factory::getApplication() ;
		$db = Factory::getDbo();
		$user = Factory::getUser() ;
		$id = $app->input->getInt('event_id', 0);
        $reason = $app->input->getVar('reason') ;
		$config = \EventbookingHelper::getConfig();
		$return =  $app->input->getVar('return') ;

		//Get the event object
		$sql = "SELECT *, JSON_UNQUOTE(json_extract(custom_fields,'$.field_leader_id1')) as field_leader_id1 FROM #__eb_events WHERE id=".$id ;
		$db->setQuery($sql);
		$rowEvent = $db->loadObject() ;

        Log::add($user->get('name').' UnCancel Event:'.$rowEvent->title, Log::INFO, 'com_mbwc');
        
		$ret =  $this->uncancel($id, $reason);
        if (!$ret)
        {
			$msg = "Error UnCancelling Event";
		}
		else
		{
    		$sql = "select name as leader_name, email as leader_email from #__users where id = ".$rowEvent->field_leader_id1;
         	$db->setQuery($sql) ;
    		$row = $db->loadObject();
    		
    		$replyName = $row->leader_name;
    		$replyEmail = $row->leader_email;
			
			// also email people on waitlist
			$sql = 'SELECT distinct email FROM #__eb_registrants WHERE (published=1 or published=3 or published=4 or published=5) and is_group_billing=0 and event_id='.$id.' and email != "'. $replyEmail.'" and email is not null and email != ""';

    	    $db->setQuery($sql) ;
    		$emails = $db->loadColumn();
            if (strpos(strtolower($rowEvent->title),"test")===false)
            {
    		    $emails[]="tripreports@mbwc.org.au";
            }

            $content =
            "Dear Member,<br>" .
            "<br>" .
            "The Leader has uncancelled the event: " . $rowEvent->title .
            " on the " . $rowEvent->event_date . ".<br>";
            if ($reason)
            {
                $content = $content . "Reason given: ". $reason . "<br>";
            }
            $content = $content ."<br>" .
            "Regards, <br>" .
            "MBWC Events Management";
    		
			if (MBWCHelper::sendMail($replyEmail, "The Event ". $rowEvent->title." has been uncancelled", $content, 1, null, $emails, null, $replyEmail, $replyName))
			{
 		        $msg = "Event UnCancelled. Mail sent successfully.";
			}
			else
			{
			    $msg = "Event UnCancelled. Error sending mail";
			}
		}
		if ($return && $return === "event")
		{
			$this->setRedirect( Route::_(
				'index.php?option=com_eventbooking&view=event&id=' . $id . '&Itemid=' . $app->input->getInt('Itemid'),
				false),$msg);
		}
		else
		{
            $this->setRedirect(Route::_(\EventbookingHelperRoute::getViewRoute('events', $app->input->getInt('Itemid')), false), $msg);	
		}
 
    }
    
}
?>