<?php
namespace MBWC\Component\MBWC\Site\Controller;

use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Factory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\Log\Log;
use Joomla\CMS\Router\Route;
use stdClass;

require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

class ExportController extends BaseController
{
	public function membership_export()
    {
		$db = Factory::getDbo();
		$config = \EventbookingHelper::getConfig();
		$sql = 'select b.user_id, c.id as "other_id", concat(b.firstname," ",b.lastname) as "name", b.cb_homephone, b.cb_mobphone, a.name as "plan", DATE_FORMAT(c.expiry_date,"%e/%c/%y") as "expiry_date", b.cb_primmember as other, b.cb_joindate from jos_comprofiler as b, jos_cbsubs_plans as a, jos_cbsubs_subscriptions as c, jos_user_usergroup_map as d where b.user_id=c.user_id and c.plan_id = a.id and d.user_id = b.user_id and (d.group_id = 2 or d.group_id=21 or d.group_id=37) and c.status = "A" order by 1';

		$db->setQuery($sql) ;
		$rows  = $db->loadObjectList();
		if (count($rows) ==  0)
        {
            $app = Factory::getApplication();
            $app->enqueueMessage('Nothing to export');
            $app->redirect(Route::_('index.php'));
		}
        if (count($rows))
        {
            $UserBrowser = MBWCHelper::getBrowser();
            $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
            $filename = "membership";
            header('Content-Encoding: UTF-8');
            header('Content-Type: ' . $mime_type.' ;charset=UTF-8');
            header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
            if ($UserBrowser == 'IE')
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
            }
            else
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Pragma: no-cache');
            }
            $fp = fopen('php://output', 'w');
            fwrite($fp, "\xEF\xBB\xBF");
            $delimiter = ',';

            $fields = array();
            $fields[] = "User ID";
            $fields[] = "Other ID";
            $fields[] = "Name";
            $fields[] = "Home Phone";
            $fields[] = "Mobile Phone";
            $fields[] = "Plan";
            $fields[] = "Expiry Date";
            $fields[] = "Other Person";
            $fields[] = "Join Date";
            fputcsv($fp, $fields, $delimiter);
            foreach ($rows as $r)
            {
                
                $fields = array();
                $fields[] = $r->user_id;
                $fields[] = $r->other_id;
                $fields[] = $r->name;
                $fields[] = $r->cb_homephone;
                $fields[] = $r->cb_mobphone;
                $fields[] = $r->plan;
               if ($r->expiry_date != "0/0/00")
                {
                    $fields[] = $r->expiry_date;
                }
                else
                {
                    $fields[]=null;
                }
                $fields[] = $r->other;
                $fields[] = $r->cb_joindate;

                fputcsv($fp, $fields, $delimiter);
            }
            fclose($fp);
            Factory::getApplication()->close();
        }
	}	
	public function walks_by_leader_export()
    {
		$db = Factory::getDbo();
		$config = \EventbookingHelper::getConfig();
	    $model = $this->getModel('leaderswalks');
		$rows = $model->getAllItems();				

		if (count($rows) ==  0)
        {
            $app = Factory::getApplication();
            $app->enqueueMessage('Nothing to export');
            $app->redirect(Route::_('index.php'));
		}
		
        if (count($rows))
        {
            $UserBrowser = MBWCHelper::getBrowser();
            $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
            $filename = "walks_by_leaders";
            header('Content-Encoding: UTF-8');
            header('Content-Type: ' . $mime_type.' ;charset=UTF-8');
            header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
            if ($UserBrowser == 'IE')
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
            }
            else
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Pragma: no-cache');
            }
            $fp = fopen('php://output', 'w');
            fwrite($fp, "\xEF\xBB\xBF");
            $delimiter = ',';

            $fields = array();
            $fields[] = "Leader Name";
            $fields[] = "Number Walks Led up to Dec 2021";
            $fields[] = "Number Walks Led 2022";
            $fields[] = "Number Walks Led 2023 until today";
            $fields[] = "Total Number Walks Led";
            fputcsv($fp, $fields, $delimiter);
            foreach ($rows as $r)
            {
                
                $fields = array();
                $fields[] = $r->name;
                $fields[] = $r->num_walks;
                $fields[] = $r->num_twentytwo;
                $fields[] = $r->num_new_walks;
                $fields[] = $r->total_walks;
 
                fputcsv($fp, $fields, $delimiter);
            }
            fclose($fp);
            Factory::getApplication()->close();
       }
	}	
	public function trip_report_export()
    {
        $app = Factory::getApplication();
		$db = Factory::getDbo();
		$config = \EventbookingHelper::getConfig();
		$year = $app->input->getInt('year') ;
		$month = $app->input->getInt('month') ;
		$eventId = $app->input->getInt('event_id') ;
		$sql="SELECT a.published, DAYNAME(IFNULL(e.event_date,a.event_date)) as day, DATE_FORMAT(IFNULL(e.event_date,a.event_date),'%e/%c/%y') as event_date, DATE_FORMAT(IFNULL(e.event_end_date,a.event_end_date),'%e/%c/%y') as event_end_date, ifnull(e.event_name,a.title) as title, a.custom_fields,  
ifnull(e.num_members,'Unsubmitted') as trip_report_num_members, count(distinct if(b.is_group_billing=0 AND b.published=1 and b.user_id is not null and b.user_id != 0, b.email, NULL)) as num_members, 
ifnull(e.num_visitors,'Unsubmitted') as trip_report_num_visitors,count(distinct if(b.is_group_billing=0 AND b.published=1 and b.user_id = 0, b.email, NULL)) as num_visitors, 
ifnull(e.num_cancellations, 'Unsubmitted') as trip_report_num_cancellations,count(distinct if (b.is_group_billing=0 AND b.published=2,b.email,NULL)) as num_cancellations, 
COALESCE(e.leader,concat_ws(',',
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id3'))))) as leader,
 COALESCE(e.actual_distance,substr(a.custom_fields,position('field_distance=' in a.custom_fields)+16,position('\"' in substr(a.custom_fields,position('field_distance=' in a.custom_fields)+16))-1)) as distance, 
 ifnull(e.grade,x.category) as category,
 if(e.id,'Submitted','Unsubmitted') as trip_report_status,
 json_extract(a.custom_fields,'$.field_cancel_reason') as cancel_reason
 from jos_eb_events as a 
 left join jos_eb_registrants as b on a.id = b.event_id 
 left join jos_mbwc_tripreports as e on e.event_id = a.id
 left join (select c.event_id, group_concat(d.name separator ',') as category from jos_eb_event_categories as c inner join 
 jos_eb_categories as d on d.id = c.category_id group by c.event_id) as x on x.event_id = a.id where a.published > 0 and year(IFNULL(e.event_date,a.event_date)) = ".$year." and month(IFNULL(e.event_date,a.event_date)) = ".$month." group by a.id order by IFNULL(e.event_date,a.event_date)";

		$db->setQuery($sql) ;
		$rows  = $db->loadObjectList();
		if (count($rows) ==  0)
        {
            $app->enqueueMessage('Nothing to export');
            $app->redirect(Route::_('index.php'));
		}
		
        if (count($rows))
        {
            $UserBrowser = MBWCHelper::getBrowser();
            $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
            $filename = "trip_report";
            header('Content-Encoding: UTF-8');
            header('Content-Type: ' . $mime_type.' ;charset=UTF-8');
            header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
            if ($UserBrowser == 'IE')
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
            }
            else
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Pragma: no-cache');
            }
            $fp = fopen('php://output', 'w');
            fwrite($fp, "\xEF\xBB\xBF");
            $delimiter = ',';

            $fields = array();
            $fields[] = "Day";
            $fields[] = "Start Date";
            $fields[] = "End Date";
            $fields[] = "Activity Name";
            $fields[] = "Act Dist kms";
            $fields[] = "Category";
            $fields[] = "Trip Report Members";
            $fields[] = "Event Members";
            $fields[] = "Trip Report Visitors";
            $fields[] = "Event Visitors";
            $fields[] = "Trip Report Cancellations";
            $fields[] = "Event Cancellations";
            $fields[] = "Leader";
            $fields[] = "Trip Report Status";
            $fields[] = "Event Cancellation Reason";
            fputcsv($fp, $fields, $delimiter);
            foreach ($rows as $r)
            {
                
                $fields = array();
                $fields[] = $r->day;
                $fields[] = $r->event_date;
                if ($r->event_end_date != "0/0/00" && $r->event_end_date != $r->event_date)
                {
                    $fields[] = $r->event_end_date;
                }
                else
                {
                    $fields[]="";
                }
                $fields[] = $r->title;
                $fields[] = preg_replace("/[^0-9.]/", "", $r->distance);
                $fields[] = $r->category;
                if ($r->published == 2)
                {
                    $fields[] = "Cancelled";
                    $fields[] = "Cancelled";
                }
                else
                {
                    $fields[] = $r->trip_report_num_members;
                    $fields[] = $r->num_members;
                }
                if ($r->published == 2)
                {
                    $fields[] = "Cancelled";
                    $fields[] = "Cancelled";
                }
                else
                {
                    $fields[] = $r->trip_report_num_visitors;
                    $fields[] = $r->num_visitors;
                }
                if ($r->published == 2)
                {
                    $fields[] = "Cancelled";
                    $fields[] = "Cancelled";
                }
                else
                {
                    $fields[] = $r->trip_report_num_cancellations;
                    $fields[] = $r->num_cancellations;
                }
                $fields[] = $r->leader;
                $fields[] = $r->trip_report_status;
                $fields[] = $r->cancel_reason;
                fputcsv($fp, $fields, $delimiter);
            }
            fclose($fp);
            Factory::getApplication()->close();
        }
	}

	public function generate_committee_export()
    {
        $app = Factory::getApplication();
		$db = Factory::getDbo();
		$config = \EventbookingHelper::getConfig();
		$start_date = $app->input->getVar('date') ;
		$end_date = $app->input->getVar('end_date') ;
        
        $sql= "select user_id, concat(first_name, ' ', last_name) as name, suburb, submit_date, committee_approved from jos_mbwc_membership where submit_date between '".$start_date."' and '".$end_date."' order by submit_date asc";
		$db->setQuery($sql) ;
		$contacts  = $db->loadObjectList();
				
        foreach ($contacts as $key => $object) 
    	{	
        	$sql = "select b.title, date(b.event_date) as event_date,concat_ws(',',
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id3')))) as leader from jos_eb_registrants as a join jos_eb_events as b on b.id=a.event_id 
        where b.published=1 and (a.user_id = 0 or a.user_id is null) and a.is_group_billing=0 and a.published=1 and 
        		lower(concat(trim(both ' ' from a.first_name),' ',trim(both ' ' from a.last_name)))=lower('".str_replace("'", "\'", $object->name)."') and date(event_date) <= date('".$object->submit_date."') and event_date >= DATE_SUB(NOW(),INTERVAL 1 YEAR) order by b.event_date asc";
			$db->setQuery($sql) ;
			$object->walks = $db->loadObjectList();
			if ($object->walks)
			{
   		        $object->first_walk_date=$object->walks[0]->event_date;
			}
    	}
        $contacts = array_values($contacts);    	
		if (count($contacts) ==  0)
        {
            $app->enqueueMessage('Nothing to export');
            $app->redirect(Route::_('index.php'));
		}
        $sql= "select a.name, a.rate, count(distinct b.user_id) as num from jos_cbsubs_plans as a join jos_cbsubs_subscriptions as b on b.plan_id=a.id join jos_comprofiler as c on b.user_id=c.user_id where a.published=1 and a.name != 'Test Users' and b.status='A' and c.cb_status='Current' group by a.id order by a.name";
		$db->setQuery($sql) ;
		$memberships  = $db->loadObjectList();
		$totalRegistered=0;
		$totalNonRegistered=0;
        foreach ($memberships as $key => $object)
        {
            if ($object->name === "Honorary Associate" || $object->name === "Honorary Associate (with mailed Footnotes)" || $object->name === "Business")
            {
                $totalNonRegistered=$totalNonRegistered+$object->num;
            }
            else
            {
                $totalRegistered=$totalRegistered+$object->num;
                
            }
        }
        $object = new stdClass();
        $object->name = "Total Members who can login";
        $object->rate = null;
        $object->num =$totalRegistered; 
        $memberships[] = $object;
        $object1 = new stdClass();
        $object1->name = "Total Members who cannot login";
        $object1->rate = null;
        $object1->num =$totalNonRegistered; 
        $memberships[] = $object1;
        $object2 = new stdClass();
        $object2->name = "Total";
        $object2->rate = null;
        $object2->num =$totalRegistered+$totalNonRegistered; 
        $memberships[] = $object2;
        $sql="select b.name from jos_cbsubs_subscriptions as a join jos_users as b on a.user_id=b.id join jos_cbsubs_plans as c on a.plan_id=c.id where c.name='Business' and a.status='A'";
		$db->setQuery($sql) ;
		$businesses  = $db->loadObjectList();
        $sql="select b.name from jos_cbsubs_subscriptions as a join jos_users as b on a.user_id=b.id join jos_cbsubs_plans as c on a.plan_id=c.id where c.name='Honorary Associate' and a.status='A'";
		$db->setQuery($sql) ;
		$associates  = $db->loadObjectList();
        if (count($contacts))
        { 
            $UserBrowser = MBWCHelper::getBrowser();
            $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
            $filename = "committee";
            header('Content-Encoding: UTF-8');
            header('Content-Type: ' . $mime_type.' ;charset=UTF-8');
            header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
            if ($UserBrowser == 'IE')
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
            }
            else
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Pragma: no-cache');
            }
            $fp = fopen('php://output', 'w');
            fwrite($fp, "\xEF\xBB\xBF");
            $delimiter = ',';
            $fields = array();
            $fields[] = "Name";
            $fields[] = "Suburb";
            $fields[] = "Submit Date";
            $fields[] = "Qualifying Walk 1 Date";
            $fields[] = "Leader";
            $fields[] = "Qualifying Walk 2 Date";
            $fields[] = "Leader";
            $fields[] = "Committee Approved Date";
            fputcsv($fp, $fields, $delimiter);
            foreach ($contacts as $r)
            {
                $fields = array();
                $fields[] = $r->name;
                $fields[] = $r->suburb;
                $fields[] = $r->submit_date;
                if ($r->walks && $r->walks[0])
                {
                    $fields[] = $r->walks[0]->event_date;
                    $fields[] = $r->walks[0]->leader;
                }
                else
                {
                    $fields[]="";
                    $fields[]="";
                }
                if ($r->walks && $r->walks[1])
                {
                    $fields[] = $r->walks[1]->event_date;
                    $fields[] = $r->walks[1]->leader;
                }
                else
                {
                    $fields[]="";
                    $fields[]="";
                }
                $fields[] = $r->committee_approved;
                fputcsv($fp, $fields, $delimiter);
            }
            $fields = array();
            fputcsv($fp, $fields, $delimiter);
            $fields[] = "Membership Type";
            $fields[] = "Yearly Fee";
            $fields[] = "Number of Members";
            fputcsv($fp, $fields, $delimiter);
            foreach ($memberships as $r)
            {
                $fields = array();
                $fields[] = $r->name;
                if ($r->rate)
                {
                    $fields[] = $r->rate;
                }
                $fields[] = $r->num;
                fputcsv($fp, $fields, $delimiter);
            }
            $fields = array();
            fputcsv($fp, $fields, $delimiter);
            $fields = array();
            $fields[]="Businesses";
            fputcsv($fp, $fields, $delimiter);
            foreach ($businesses as $r)
            {
                $fields = array();
                $fields[] = $r->name;
                fputcsv($fp, $fields, $delimiter);
            }
            $fields = array();
            fputcsv($fp, $fields, $delimiter);
            $fields[]="Honorary Associates";
            fputcsv($fp, $fields, $delimiter);
            foreach ($associates as $r)
            {
                $fields = array();
                $fields[] = $r->name;
                fputcsv($fp, $fields, $delimiter);
            }

            fclose($fp);
        }
        Factory::getApplication()->close();
    }
    public function mailednewsletters_export()
    {
		$db = Factory::getDbo();
		$app = Factory::getApplication();
		$config = \EventbookingHelper::getConfig();
		$start_date =  $app->getInput()->getVar('date') ;
		$end_date =  $app->getInput()->getVar('end_date') ;
		$sql = "select firstname, lastname, cb_address1, cb_address2, cb_suburbtown, cb_state, cb_postcode, ifnull(cb_complimentary_footnotes,0) as cb_complimentary_footnotes, p.name from jos_comprofiler as c join jos_cbsubs_subscriptions as s on c.user_id=s.user_id join jos_cbsubs_plans as p on s.plan_id=p.id where ((cb_subscription like '%mailed%' and cb_status = 'Current') or cb_complimentary_footnotes=1) and s.status = 'A' 
		union select firstname, lastname, cb_address1, cb_address2, cb_suburbtown, cb_state, cb_postcode, ifnull(cb_complimentary_footnotes,0) as cb_complimentary_footnotes, concat('Merchandise. Order date: ',DATE_FORMAT(FROM_UNIXTIME(o.order_modified), '%e %b %Y')) from jos_comprofiler as c join jos_hikashop_user as u on u.user_cms_id=c.user_id join jos_hikashop_order as o on o.order_user_id=u.user_id join jos_hikashop_order_product as op on op.order_id=o.order_id join jos_hikashop_product as p on op.product_id=p.product_id where o.order_status='confirmed' and p.product_alias = 'mailed-footnotes' and FROM_UNIXTIME(o.order_modified) > DATE_SUB(NOW(),INTERVAL 1 YEAR) order by 2";

		$db->setQuery($sql) ;
		$rows  = $db->loadObjectList();
		if (count($rows) ==  0)
        {
            $app->enqueueMessage('Nothing to export');
            $app->redirect(Route::_('index.php'));
		}
		else
		{
            $UserBrowser = MBWCHelper::getBrowser();
            $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
            $filename = "mailed_newsletters";
            header('Content-Encoding: UTF-8');
            header('Content-Type: ' . $mime_type.' ;charset=UTF-8');
            header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
            if ($UserBrowser == 'IE')
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
            }
            else
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Pragma: no-cache');
            }
            $fp = fopen('php://output', 'w');
            fwrite($fp, "\xEF\xBB\xBF");
            $delimiter = ',';
            $fields = array();
            $fields[] = "Name";
            $fields[] = "Address";
            $fields[] = "Complimentary";
            $fields[] = "Subscription";
            fputcsv($fp, $fields, $delimiter);
            foreach ($rows as $r)
            {
                $fields = array();
                $fields[] = $r->firstname. ' '.$r->lastname;
                $fields[] = $r->cb_address1. ' '.$r->cb_suburbtown . ' '. $r->cb_state . ' ' . $r->cb_postcode;
                $fields[] = $r->cb_complimentary_footnotes;
                $fields[] = $r->name;

                fputcsv($fp, $fields, $delimiter);
            }

            fclose($fp);
            Factory::getApplication()->close();      
		}
    }
    public function generate_covid_report()
    {
		$db = Factory::getDbo();
		$app = Factory::getApplication();
		$config = \EventbookingHelper::getConfig();
		$start_date = $app->getInput()->getVar('date') ;
		$end_date = $app->getInput()->getVar('end_date') ;

		$sql = "select a.title, DATE_FORMAT(a.event_date,'%d/%m/%y') as event_date, (select group_concat(d.name separator ',') from jos_eb_event_categories as c inner join 
 jos_eb_categories as d on d.id = c.category_id and c.event_id=a.id) as category,
 concat_ws(',',
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id3')))) as leader, if (a.published is not null,if(a.published=1,'ACTIVE','CANCELLED'),'') as status, 
 if(b.published is not null,if(b.user_id,'MEMBER','VISITOR'),'') as user_status, if (b.first_name is not null,concat(b.first_name,' ',b.last_name),'') as name, 
 if(b.phone is not null,b.phone,'') as home_phone, coalesce((select field_value from jos_eb_field_values where field_id=21 and registrant_id=b.id),'') as mobile, 
 if(b.first_name is not null,if(b.published=1,'ACTIVE',if(b.published=2,'CANCELLED','WAITLISTED')),'') registrant_status from jos_eb_events as a 
 left join jos_eb_registrants as b on b.event_id=a.id 
 where date(a.event_date) between '".$start_date."' and '".$end_date."' and b.is_group_billing=0 order by a.event_date,a.id";
 
		$db->setQuery($sql) ;
		$rows  = $db->loadObjectList();
		
		if (count($rows) ==  0)
        {
            $app->enqueueMessage('Nothing to export');
            $app->redirect(Route::_('index.php'));
		}
        else
        {
            $UserBrowser = MBWCHelper::getBrowser();
            $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
            $filename = "event_participants_lists";
            header('Content-Encoding: UTF-8');
            header('Content-Type: ' . $mime_type.' ;charset=UTF-8');
            header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
            if ($UserBrowser == 'IE')
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
            }
            else
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Pragma: no-cache');
            }
            $fp = fopen('php://output', 'w');
            fwrite($fp, "\xEF\xBB\xBF");
            $delimiter = ',';

            $fields = array();
            $fields[] = "Event Name";
            $fields[] = "Event Date";
            $fields[] = "Event Category";
            $fields[] = "Event Leader";
            $fields[] = "Event Status";
            $fields[] = "Registrant Member Status";
            $fields[] = "Registrant Name";
            $fields[] = "Registrant Home Phone";
            $fields[] = "Registrant Mobile";
            $fields[] = "Registrant Event Status";
            fputcsv($fp, $fields, $delimiter);
            foreach ($rows as $r)
            {
                $fields = array();
                $fields[] = $r->title;
                $fields[] = $r->event_date;
                $fields[] = $r->category;
                $fields[] = $r->leader;
                $fields[] = $r->status;
                $fields[] = $r->user_status;
                $fields[] = $r->name;
                $fields[] = $r->home_phone;
                $fields[] = $r->mobile;
                $fields[] = $r->registrant_status;
                fputcsv($fp, $fields, $delimiter);
            }
            fclose($fp);
            Factory::getApplication()->close();
        }
    }
	public function generate_incident_export()
    {
		$app = Factory::getApplication();
		$db = Factory::getDbo();
		$config = \EventbookingHelper::getConfig();
		$start_date = $app->getInput()->getVar('date') ;
		$end_date = $app->getInput()->getVar('end_date') ;
		$sql = "select name, person_phone, address, person_email, DATE_FORMAT(date,'%d/%m/%y') as date, leader_name, leader_phone, location, conditions, what, where_happened, injury, treatment, 
		emergency_called, whoattended, witness1_name, witness1_phone, witness1_address, witness2_name, witness2_phone, witness2_address, treatment_required, hazard, hazard_controlled, submit_date, 
		claim_number, claim_lodged_date, cancelled, reason from jos_mbwc_incident where date(`date`) between '".$start_date."' and '".$end_date."' order by id";

		$db->setQuery($sql) ;
		$rows  = $db->loadObjectList();
		if (count($rows) ==  0)
        {
            $app->enqueueMessage('Nothing to export');
            $app->redirect(Route::_('index.php'));
		}
		else
		{
            $db = Factory::getDbo();
            $nullDate = $db->getNullDate();
            $UserBrowser = MBWCHelper::getBrowser();
            $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
            $filename = "incidents";
            header('Content-Encoding: UTF-8');
            header('Content-Type: ' . $mime_type.' ;charset=UTF-8');
            header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
            if ($UserBrowser == 'IE')
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
            }
            else
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Pragma: no-cache');
            }
            $fp = fopen('php://output', 'w');
            fwrite($fp, "\xEF\xBB\xBF");
            $delimiter = ',';

            $fields = array();
            $fields[] = "Claim Lodged Date";
            $fields[] = "Claim Number";
            $fields[] = "Cancelled";
            $fields[] = "Person involved";
            $fields[] = "Person Phone";
            $fields[] = "Person Address";
            $fields[] = "Person Email";
            $fields[] = "Incident Date";
            $fields[] = "Leader";
            $fields[] = "Leader Phone";
            $fields[] = "Location";
            $fields[] = "Conditions";
            $fields[] = "What Happened";
            $fields[] = "Where it Happened";
            $fields[] = "Injury";
            $fields[] = "Treatment at location";
            $fields[] = "Emergency Called";
            $fields[] = "Who Attended";
            $fields[] = "Witness 1 Name";
            $fields[] = "Witness 1 Phone";
            $fields[] = "Witness 1 Address";
            $fields[] = "Witness 2 Name";
            $fields[] = "Witness 2 Phone";
            $fields[] = "Witness 2 Address";
            $fields[] = "Ongoing Treatment";
            $fields[] = "Hazard?";
            $fields[] = "Hazard Controlled";
            $fields[] = "Submit Date";
            $fields[] = "Cancelled Reason";
            fputcsv($fp, $fields, $delimiter);
            foreach ($rows as $r)
            {
                $fields = array();
                if ($r->claim_lodged_date == $nullDate)
                {
                    $fields[]= "";
                }
                else
                {
                    $fields[] = $r->claim_lodged_date; 
                }
                $fields[] = $r->claim_number; 
                $fields[] = $r->cancelled; 
                $fields[] = $r->name;
                $fields[] = $r->person_phone;
                $fields[] = $r->address;
                $fields[] = $r->person_email;
                $fields[] = $r->date; 
                $fields[] = $r->leader_name;
                $fields[] = $r->leader_phone; 
                $fields[] = $r->location;
                $fields[] = $r->conditions; 
                $fields[] = $r->what;
                $fields[] = $r->where_happened;
                $fields[] = $r->injury; 
                $fields[] = $r->treatment;
                $fields[] = $r->emergency_called;
                $fields[] = $r->whoattended;
                $fields[] = $r->witness1_name;
                $fields[] = $r->witness1_phone;
                $fields[] = $r->witness1_address;
                $fields[] = $r->witness2_name;
                $fields[] = $r->witness2_phone; 
                $fields[] = $r->witness2_address;
                $fields[] = $r->treatment_required; 
                $fields[] = $r->hazard; 
                $fields[] = $r->hazard_controlled;;
                $fields[] = $r->submit_date;
                $fields[] = $r->reason;
                fputcsv($fp, $fields, $delimiter);
            }
            fclose($fp);
            Factory::getApplication()->close();
		}
    }
    public static function sort_info($a, $b)
    {
        if($a->contact_date !== null && $b->contact_date !== null)
            return strtotime($a->contact_date) > strtotime($b->contact_date) ? 1 : -1;
        else if ($a->contact_date !== null && $b->contact_date == null)
            return strtotime($a->contact_date) > strtotime($b->first_walk_date) ? 1: -1;
        else if ($a->contact_date == null && $b->contact_date !== null)
            return strtotime($a->first_walk_date) > strtotime($b->contact_date) ? 1: -1;
        else    
            return strtotime($a->first_walk_date) > strtotime($b->first_walk_date) ? 1 : -1;
    }
	public function generate_info_export()
    {
		$app = Factory::getApplication();
		$db = Factory::getDbo();
		$config = \EventbookingHelper::getConfig();
		$start_date = $app->getInput()->getVar('date') ;
		$end_date = $app->getInput()->getVar('end_date') ;
        
        $sql= "select 'Yes' as info_contact, t1.date as contact_date,
trim(both '\"' from substring_index(substring_index(replace(replace(fields,'[',''),']',''),',',3),',',-1)) as name,
trim(both '\"' from substring_index(substring_index(replace(replace(fields,'[',''),']',''),',',6),',',-1)) as email, 
replace(trim(both '\"' from substring_index(substring_index(replace(replace(fields,'[',''),']',''),',',9),',',-1)),' ','') as phone
from jos_foxcontact_enquiries as t1 join
(select
trim(both '\"' from substring_index(substring_index(replace(replace(fields,'[',''),']',''),',',3),',',-1)) as name, min(id) as id FROM jos_foxcontact_enquiries where date(date) between '".$start_date."' and '".$end_date."' and form_id=-128 and fields not like '%\u0%' group by 1) as t2
on t1.id = t2.id order by contact_date";
		$db->setQuery($sql) ;
		$info_contacts  = $db->loadObjectList();
				
	    $sql = "select 
concat(trim(both ' ' from first_name),' ',trim(both ' ' from last_name)) as name, 'No' as info_contact, null as contact_date,
max(a.email) as email, max(replace(a.phone,' ','')) as phone
from jos_eb_registrants as a 
join jos_eb_events as b on a.event_id = b.id 
where a.published =1 and b.published=1 and (a.user_id = 0 or a.user_id is null) and a.is_group_billing=0 and event_date between '".$start_date."' and '".$end_date."' and event_date <= CURDATE() 
group by 1,2";
    	$db->setQuery($sql) ;
    	$visitor_walkers  = $db->loadObjectList();
        foreach ($info_contacts as $key1 => $object1) 
    	{
    		foreach ($visitor_walkers as $key2 => $object2)
    		{
    			if (strtolower($object1->name) === strtolower($object2->name) || strtolower($object1->email) === strtolower($object2->email))
    			{
    				unset($visitor_walkers[$key2]);
    			}
    		}
    	}
    	$info_contacts = array_merge($info_contacts,$visitor_walkers);
        foreach ($info_contacts as $key => $object) 
    	{	
    		$ignore=false;
    		if ($object->phone)
    	    {
                if (substr($object->phone, 0, 2) == "61") {
                    $object->phone = "0".substr($object->phone, 2);
                }     	    
                if (substr($object->phone, 0, 3) == "+61") {
                    $object->phone = "0".substr($object->phone, 3);
                }     	    
    	    }
    		if ($object->email && $object->email !== '')
    		{
    		    $sql = "select b.registerDate from jos_users as b join jos_comprofiler as c on c.user_id=b.id where (lower(b.email)=lower('".$object->email."') or lower(b.name)=lower('".str_replace("'", "\'", $object->name)."')) and c.cb_status='Current' limit 1"; 
    		}
    		else
    		{
    		    $sql = "select b.registerDate from jos_users as b join jos_comprofiler as c on c.user_id=b.id where (lower(b.name)=lower('".str_replace("'", "\'", $object->name)."')) and c.cb_status='Current' limit 1"; 
    		}
    		$db->setQuery($sql) ;
    		$registerDate = $db->loadResult();
    		if ($registerDate)
    		{
    			if ($registerDate < $start_date)
    			{
    				// Remove info contacts who have been members before the query period
    				unset($info_contacts[$key]);
    				$ignore=true;
    			}
    			else
    			{
    				// Add if they are a current member
    				$object->member=true;
    			}
    		}
    		else
    		{
    			$object->member=false;
    		}
    		if (!$ignore)
    		{
        		if ($object->email && $object->email !== '')
        		{
        			$sql = "select b.title, b.event_date, concat_ws(',',
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(b.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(b.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(b.custom_fields,'$.field_leader_id3')))) as leader from jos_eb_registrants as a join jos_eb_events as b on b.id=a.event_id
                where b.published=1 and a.published=1 and (a.user_id = 0 or a.user_id is null) and a.is_group_billing=0 and 
        		(lower(a.email)='".strtolower($object->email)."' or lower(concat(trim(both ' ' from a.first_name),' ',trim(both ' ' from a.last_name)))=lower('".str_replace("'", "\'", $object->name)."')) and event_date <= NOW() and event_date >= DATE_SUB(NOW(),INTERVAL 1 YEAR) order by b.event_date";
        		}
        		else
        		{
        			$sql = "select b.title, b.event_date, concat_ws(',',
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(b.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(b.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(b.custom_fields,'$.field_leader_id3')))) as leader from jos_eb_registrants as a join jos_eb_events as b on b.id=a.event_id 
                where b.published=1 and (a.user_id = 0 or a.user_id is null) and a.is_group_billing=0 and a.published=1 and 
        		lower(concat(trim(both ' ' from a.first_name),' ',trim(both ' ' from a.last_name)))=lower('".str_replace("'", "\'", $object->name)."') and event_date <= NOW() and event_date >= DATE_SUB(NOW(),INTERVAL 1 YEAR) order by b.event_date";
        		}
    			$db->setQuery($sql) ;
    			$object->walks = $db->loadObjectList();
   			    $object->num_visitor_walks=count($object->walks);
    			if ($object->walks)
    			{
    			    $object->first_walk_date=$object->walks[0]->event_date;
    			}
    			else
    			{
    			    $object->first_walk_date=null;
    			}
    		}
    	}
        $info_contacts = array_values($info_contacts);    	 
		if (count($info_contacts) ==  0)
        {
            $app->enqueueMessage('Nothing to export');
            $app->redirect(Route::_('index.php'));
		}
		usort($info_contacts,array($this,'sort_info'));
        if (count($info_contacts))
        {
            $UserBrowser = MBWCHelper::getBrowser();
            $mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
            $filename = "info_mails";
            header('Content-Encoding: UTF-8');
            header('Content-Type: ' . $mime_type.' ;charset=UTF-8');
            header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
            if ($UserBrowser == 'IE')
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                header('Pragma: public');
            }
            else
            {
                header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
                header('Pragma: no-cache');
            }
            $fp = fopen('php://output', 'w');
            fwrite($fp, "\xEF\xBB\xBF");
            $delimiter = ',';
            $fields = array();
            $fields[] = "Info Contact";
            $fields[] = "Contact Date";
            $fields[] = "Person Name";
            $fields[] = "Person Email";
            $fields[] = "Person Phone Number";
            $fields[] = "Current Member";
            $fields[] = "Number of Visitor walks";
            $fields[] = "Walk 1 Date";
            $fields[] = "Walk 1 Title";
            $fields[] = "Walk 1 Leader";
            $fields[] = "Walk 2 Date";
            $fields[] = "Walk 2 Title";
            $fields[] = "Walk 2 Leader";
            fputcsv($fp, $fields, $delimiter);
            foreach ($info_contacts as $r)
            {
                $fields = array();
                $fields[] = $r->info_contact;
                $fields[] = $r->contact_date;
                $fields[] = $r->name;
                $fields[] = $r->email;
                if ($r->phone)
                {
                    $fields[] = '"'.$r->phone.'"';
                }
                else
                {
                    $fields[] = $r->phone;
                }
                if ($r->member)
                {
                    $fields[] = 'Yes';
                }
                else
                {
                    $fields[] = 'No';
                }
                $fields[] = $r->num_visitor_walks;
                if ($r->walks && $r->walks[0])
                {
                    $fields[] = $r->walks[0]->event_date;
                    $fields[] = $r->walks[0]->title;
                    $fields[] = $r->walks[0]->leader;
                }
                else
                {
                    $fields[]="";
                    $fields[]="";
                    $fields[]="";
                }
                if ($r->walks && $r->num_visitor_walks > 1 && $r->walks[1])
                {
                    $fields[] = $r->walks[1]->event_date;
                    $fields[] = $r->walks[1]->title;
                    $fields[] = $r->walks[1]->leader;
                }
                else
                {
                    $fields[]="";
                    $fields[]="";
                    $fields[]="";
                }
                fputcsv($fp, $fields, $delimiter);
            }

            fclose($fp);
            Factory::getApplication()->close();
        }
    } 

}
?>