<?php
namespace MBWC\Component\MBWC\Site\Controller;

use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Factory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Log\Log;

require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

class IncidentController extends BaseController
{
	public function cancel_incident_report()
    {
		$app = Factory::getApplication();
		$model =  $this->getModel('incidentreport');
		$id = $app->input->getInt('id', 0);
		$reason = $app->input->getVar('reason');
		$model->cancel($id, $reason);
		$msg = "Incident Report Cancelled";		
		$return = base64_decode($this->input->getBase64('return'));
        
		if ($return && Uri::isInternal($return))
		{
			$this->setRedirect($return, $msg);
		}
        else
        {
		    $this->setRedirect(Route::_('index.php?option=com_mbwc&view=incidentreports&Itemid='.$app->input->getInt('Itemid')) , $msg);
        }
	}
	
	public function save_incident_report()
    {
		$app = Factory::getApplication() ;
		$post = $app->input->post->getArray();
		$post['temporary']=0;
		$model =  $this->getModel('incidentreport');
		$ret =  $model->save($post);
		if ($ret)
        {
			$msg = "Incident Report updated";
		}
        else
        {
			$msg = "Error updating Incident Report";
		}
		if ($return && Uri::isInternal($return))
		{
			$this->setRedirect($return, $msg);
		}
        else
        {
		    $this->setRedirect(Route::_('index.php?option=com_mbwc&view=incidentreports&Itemid='.$app->input->getInt('Itemid')) , $msg);
        }
    }
	public function store_incident_report()
    {
    	$app = Factory::getApplication() ;
		$post = $app->input->post->getArray();
		$post['temporary']=1;
		$model =  $this->getModel('incidentreport');
		$ret =  $model->save($post);
        $msg = "Incident Report saved. The latest changes have NOT been emailed out.";
 		if ($return && Uri::isInternal($return))
		{
			$this->setRedirect($return, $msg);
		}
        else
        {
		    $this->setRedirect(Route::_(\EventbookingHelperRoute::getViewRoute('events', $app->input->getInt('Itemid')), false), $msg);
        }
    }
    
	public function send_incident_report()
    {
		$app = Factory::getApplication() ;
		$db = Factory::getDbo();
		$user = Factory::getUser() ;
		$location = $app->input->getVar('location','','string');
        Log::add($user->get('name').' Incident Report:'.$location, Log::INFO, 'com_mbwc');
        
		$event_id=$app->input->getVar('event_id','','string');
		$name = $app->input->getVar('name','','string');
		$person_phone = $app->input->getVar('person_phone','','string');
		$person_email = $app->input->getVar('person_email','','string');
		$address = $app->input->getVar('address','','string');
		$date = $app->input->getVar('date','','date');
		$leader_name = $app->input->getVar('leader_name','','string');
		$leader_phone = $app->input->getVar('leader_phone','','string');
		$leader_email = $app->input->getVar('leader_email','','string');
		$conditions = $app->input->getVar('conditions','','string');
		$what = $app->input->getVar('what','','string');
		$where = $app->input->getVar('where_happened','','string');
		$injury = $app->input->getVar('injury','','string');
		$treatment = $app->input->getVar('treatment','','string');
		$emergency_called = $app->input->getVar('emergency_called','','string');
		$whoattended = $app->input->getVar('whoattended','','string');
		$witness1_name = $app->input->getVar('witness1_name','','string');
		$witness1_phone = $app->input->getVar('witness1_phone','','string');
		$witness1_address = $app->input->getVar('witness1_address','','string');
		$witness2_name = $app->input->getVar('witness2_name','','string');
		$witness2_phone = $app->input->getVar('witness2_phone','','string');
		$witness2_address = $app->input->getVar('witness2_address','','string');
		$treatment_required = $app->input->getVar('treatment_required','','string');
		$hazard = $app->input->getVar('hazard','','string');
		$hazardcontrolled = $app->input->getVar('hazard_controlled','','string');
       Log::add('hazard '. $hazard, Log::ERROR, 'my-error-category');
       Log::add('hazardcontrolled '. $hazardcontrolled, Log::ERROR, 'my-error-category');

		$post = $app->input->post->getArray();
		$post['submit_date']=date('Y-m-d H:i:s');
		$post['temporary']=0;
		$model =  $this->getModel('incidentreport');
		$ret =  $model->save($post);

		$replyName = $user->get('name');
		$replyEmail = $user->get('email');
		
		$content = 
		"<h1 style='text-align: center'>Maroondah Bushwalking Club Inc</h1>" .
		"<div style='text-align: center'>www.mbwc.org.au</div>" .
"<h2>FORM L7 INCIDENT / ACCIDENT REPORT</h2>" .
"<b style='font-size: 16px;'>Immediately phone the Secretary with details of any incident/accident that will /may require medical
treatment</b>.<br>" .
"<h2>Details of Person Involved in Incident/Accident:</h2>";

        $content = $content .
        "<table width=100% style='border: 1px solid #000000;border-collapse: collapse;'>" .
        "<tr><td width=50% style='border: 1px solid #000000;border-collapse: collapse;' ><b>Name:</b>&nbsp;" . $name . "</td><td style='border: 1px solid #000000;border-collapse: collapse;'><b>Phone:</b>&nbsp;".$person_phone."</td></tr>" .
        "<tr><td colspan=2 style='border: 1px solid #000000;border-collapse: collapse;'><b>Address:</b>&nbsp;" . $address . "</td></tr>" .
        "<tr><td colspan=2 style='border: 1px solid #000000;border-collapse: collapse;'><b>Person Email:</b>&nbsp;" . $person_email . "</td></tr>" .
        "<tr><td colspan=2 style='border: 1px solid #000000;border-collapse: collapse;'><b>Date of Walk/Recce:</b>&nbsp;" . $date . "</td></tr>" .
        "<tr><td width=50% style='border: 1px solid #000000;border-collapse: collapse;'><b>Name of Leader:</b>&nbsp;" . $leader_name . "</td><td style='border: 1px solid #000000;border-collapse: collapse;'><b>Phone:</b>&nbsp;" . $leader_phone . "</td></tr>" .
        "<tr><td colspan=2 style='border: 1px solid #000000;border-collapse: collapse;' ><b>Walk/Recce Location (Include Map or Melway reference if available.)</b>&nbsp;" . $location . "</td></tr></table><br>";

        $content = $content .
        "<table width=100% style='border: 1px solid #000000;border-collapse: collapse;'>" .
        "<tr><td colspan=3 style='border: 1px solid #000000;border-collapse: collapse;' ><b>Conditions were?</b>&nbsp;" . $conditions . "</td></tr>".
        "<tr><td colspan=3 style='border: 1px solid #000000;border-collapse: collapse;' ><b>What happened?</b>&nbsp;" . $what . "</td></tr>".
        "<tr><td colspan=3 style='border: 1px solid #000000;border-collapse: collapse;' ><b>Where?</b>&nbsp;" . $where . "</td></tr>".
        "<tr><td colspan=3 style='border: 1px solid #000000;border-collapse: collapse;' ><b>Injury?</b>&nbsp;" . $injury . "</td></tr>".
        "<tr><td colspan=3 style='border: 1px solid #000000;border-collapse: collapse;' ><b>Treatment at Location?</b>&nbsp;" . $treatment . "</td></tr>".
        "<tr><td width=50% style='border: 1px solid #000000;border-collapse: collapse;'><b>Were emergency services called?<br>If so, who attended?</b>&nbsp;".$whoattended."</td><td width=25% style='border: 1px solid #000000;border-collapse: collapse;'><b>Yes</b>&nbsp;<input type='checkbox'";
        if ($emergency_called) $content = $content . " checked";
        $content = $content .
        " disabled></td><td width=25% style='border: 1px solid #000000;border-collapse: collapse;'><b>No</b>&nbsp;<input type='checkbox'";
        if (!$emergency_called ) $content = $content . " checked";
        $content = $content .
        " disabled></td></tr>" .        
        "<tr><td><b>Name and contact details of at least two witnesses:</b>&nbsp;</td></tr>".
        "<tr><td width=50% ><b>Name:</b>&nbsp;" . $witness1_name . "</td>".
        "<td><b>Address:</b>&nbsp;" . $witness1_address . "</td>" .
        "<td><b>Phone:</b>&nbsp;".$witness1_phone."</td></tr>" .
        "<tr><td width=50% ><b>Name:</b>&nbsp;" . $witness2_name . "</td>".
        "<td><b>Address:</b>&nbsp;" . $witness2_address . "</td>" .
        "<td><b>Phone:</b>&nbsp;".$witness2_phone."</td></tr>" .
        "<tr><td colspan=3 style='border: 1px solid #000000;border-collapse: collapse;' ><b>Ongoing treatment required? (if known)</b>&nbsp;" . $treatment_required . "</td></tr>".
        "<tr><td style='border: 1px solid #000000;border-collapse: collapse;'><b>Did this Incident/Accident result from a hazard?</b>;".
        "</td><td width=25% style='border: 1px solid #000000;border-collapse: collapse;'><b>Yes</b>&nbsp;<input type='checkbox'";
        if ($hazard) $content = $content . " checked";
        $content = $content .
        " disabled></td><td width=25% style='border: 1px solid #000000;border-collapse: collapse;'><b>No</b>&nbsp;<input type='checkbox'";
        if (!$hazard) $content = $content . " checked";
        $content = $content .
        " disabled></td></tr>" .        
        "<tr><td colspan=3 style='border: 1px solid #000000;border-collapse: collapse;' ><b>If so, how could the hazard be controlled in the future?</b>&nbsp;" . $hazardcontrolled . "</td></tr>".
        "</table><br>";
        $content = $content .
        "<table width=100% style='border: 1px solid #000000;border-collapse: collapse;'>" .
        "<tr><td><b>Office Use Only<b></td></tr>".
        "<tr><td><b>Secretary first notified on - Date:</b>&nbsp;".date('d/m/Y')."&nbsp;<b>Time:</b>&nbsp;".date('H:i:s').
        "</tr></table>";

        $recipients = array( 'secretary@mbwc.org.au' );
        if ($person_email && $leader_email && $person_email !== $leader_email)
        {
            $recipients[] = $person_email;
        }
        if ($leader_email)
        {
            $emailsArray=explode(",",$leader_email);
            $recipients = array_merge($recipients, $emailsArray); 
        }

		if (MBWCHelper::sendMail($recipients, "Incident Report for ".$location, $content, 1, $replyEmail, null, null, $replyEmail, $replyName))
		{
 	        $msg = "Incident Report Sent";
		}
		else
		{
		    $msg = "Error sending Incident Report";
		}
  		if ($return && Uri::isInternal($return))
		{
			$this->setRedirect($return, $msg);
		}
        else
        {
		    $this->setRedirect(Route::_(\EventbookingHelperRoute::getViewRoute('events', $app->input->getInt('Itemid')), false), $msg);
        }
    }

}
?>