<?php
namespace MBWC\Component\MBWC\Site\Controller;

use Joomla\CMS\MVC\Controller\BaseController;
use Joomla\CMS\Factory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use MBWC\Component\MBWC\Site\Helper\MBWCCaptchaHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Log\Log;
use Joomla\CMS\HTML\HTMLHelper;

require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

class MembershipController extends BaseController
{
	public function send_membership()
    { 
		$app = Factory::getApplication() ;
		$db = Factory::getDbo();
		$config = \EventbookingHelper::getConfig();
		$securityCode = $app->input->getVar('security_code', '');
        $session = Factory::getSession() ;
		$post = $app->input->post->getArray();
    	if (!$post['dob'] || $post['dob']=='0000-00-00' || !MBWCHelper::validateDate($post['dob']))
    	{
		    $msg= "Date of Birth is mandatory.";
            $app->setUserState('com_mbwc.membership.form.post', $post);
            $this->setRedirect(Route::_("index.php?option=com_mbwc&view=membership&error=1&Itemid=". $app->input->getInt('Itemid'), false), $msg);
    	}
        else if ($securityCode==$session->get('security_code'))
        {
    		$post['submit_date']=date('Y-m-d H:i:s');
    		$model =  $this->getModel('membership');
    		$ret =  $model->save($post);

    		$membership=$model->getItem($ret);

    		$sql = "select alias, rate from jos_cbsubs_plans";
    		$db->setQuery($sql);
    		$priceList=$db->loadObjectList();
            $prices=array();
            for ($i=0;$i<count($priceList);$i++)
            {
    	        $prices[$priceList[$i]->alias]=$priceList[$i]->rate;
    	    }
    
            Log::add('Membership Form submitted for '.$membership->first_name.' '.$membership->last_name, Log::INFO, 'com_mbwc');

    		$content = "<p>Thank you for submitting your application for membership, a copy of which is below. We will contact you after the Committee has considered your application.</p><br><hr style='border-top: 3px dashed #bbb'><br>";
    		$content = $content .
    		"<h1 style='text-align: center'>Maroondah Bushwalking Club Inc</h1>" .
    		"<div style='text-align: center'>www.mbwc.org.au</div>" .
    "<h1 align=center>FORM M2 MEMBERSHIP APPLICATION</h1>" .
    "<p><b>Acknowledgement of Risks and Obligations.</b> In voluntarily participating in activities organised by the Maroondah Bushwalking Club Inc (the Club), described to me by the Club’s activity leaders, I am aware that my participation in these activities may expose me to risks that could lead to injury, property loss or damage. These risks include (<i>but are not limited to</i>) slippery or uneven surfaces, loose rocks, sunburn, pits/trenches and hyperthermia.<br><br>
    To minimise these risks during activities I will:
    <ol>
    <li>Ensure activities are within my capabilities.</li>
    <li>Carry snacks, lunch, 1 litre water (more in hot weather), sunscreen, personal medication & first
    aid kit, wear protective clothing and appropriate equipment, wear strong walking boots.</li>
    <li>Inform the activity leader if I am taking medication or have physical or other limitations that might affect
    my participation.</li>
    <li>Make every effort to ensure that I will remain with the rest of the party during the activity.</li>
    <li>Accept & follow instructions given by the activity leader.</li>
    <li>Carry the club's Personal Emergency Information Form (M6) detailing any critical medical information
    and emergency contacts.</li>
    </ol></p>
    <p><b>NOTE: Bushwalking Victoria strongly recommends that all members take out personal ambulance cover with
    Ambulance Victoria.	</b></p>" .
    "<ol>
     <li>Concession Membership requires provision of a current Centrelink Pensioner/Unemployment Benefits card.</li>
     <li>Family membership includes 1 or 2 adults with or without children under 18 years or full-time students ALL living at the same address.</li>
     <li>Family Concession membership requires <b>each adult</b> to provide a current Centrelink Pensioner / Unemployment Benefits card member.</li>
     <li>Footnotes – Monthly club newsletter (full colour) is emailed to members at no cost. May also be purchased as a posted greyscale (<i>no colour</i>) printed hard copy at an extra cost to the member.</li>
     </ol>" .
    	    "<h2>Personal Information</h2>".
    	"<table style='border-collapse: collapse;'>
    		<tr>			
    			<td>
    				<b>First Name:</b>			
    			</td>
    			<td colspan=3>".$membership->first_name."
    			</td>
    		</tr>
    		<tr>
    			<td>
    				<b>Last Name:</b>		
    			</td>
    			<td colspan=3>".
    				$membership->last_name."
    			</td>
    		</tr>
    		<tr>			
    			<td>
    				<b>Gender:</b>			
    			</td>
    			<td>".$membership->gender."
    			</td>
    		</tr>
    		<tr>			
    			<td>
    				<b>Date of Birth:</b>			
    			</td>
    			<td>".
    				$membership->dob."
    			</td>
    		</tr>
    		<tr>			
    			<td>
    				<b>Email:</b>			
    			</td>
    			<td colspan=3>".$membership->email."
    			</td>
    		</tr>
    		<tr>			
    			<td>
    				<b>Street Address:</b>			
    			</td>
    			<td colspan=3>".$membership->address."
    			</td>
    		</tr>
    		<tr>			
    			<td>
    				<b>Suburb/Town:</b>			
    			</td>
    			<td>".$membership->suburb."
    			</td>
    		</tr>
    		<tr>			
    			<td>
    				<b>Postcode:</b>		
    			</td>
    			<td>".$membership->postcode."
    			</td>
    		</tr>
    		<tr>
    			<td>
    				<b>Mobile Phone:</b>		
    			</td>
    			<td>".$membership->mobile_phone."
    			</td>
    		</tr>
    		<tr>			
    			<td>
    				<b>Home Phone:</b>			
    			</td>
    			<td>".$membership->home_phone."
    			</td>
    		</tr>
		<tr>			
			<td>
    				<b>Emergency Contact or Next of Kin Name:</b>		
			</td>
			<td>".$membership->kin_name."
			</td>
		</tr>
		<tr>			
			<td>
    				<b>Emergency Contact or Next of Kin Relationship:</b>		
			</td>
			<td>".$membership->kin_relationship."
			</td>
		</tr>
			<tr>
			<td>
    				<b>Emergency Contact or Next of Kin Mobile Phone Number:</b>			
			</td>
			<td>".$membership->kin_mobile_phone."
			</td>
		</tr>
		<tr>			
			<td>
    				<b>Emergency Contact or Next of Kin Home Phone Number:	</b>
			</td>
			<td>".$membership->kin_home_phone."
			</td>
		</tr>
		<tr>			
			<td>
    				<b>Emergency Contact or Next of Kin 2 Name:	</b>		
			</td>
			<td>".$membership->kin_name_2."
		</tr>
		<tr>			
			<td>
    				<b>Emergency Contact or Next of Kin 2 Relationship:</b>		
			</td>
			<td>".$membership->kin_relationship_2."
			</td>
		</tr>
			<tr>
			<td>
    				<b>Emergency Contact or Next of Kin 2 Mobile Phone Number:</b>
			</td>
			<td>".$membership->kin_mobile_phone_2."
			</td>
		</tr>
			<tr>
			<td>
    				<b>Emergency Contact or Next of Kin 2 Home Phone Number:</b>
			</td>
			<td>".$membership->kin_home_phone_2."
			</td>
		</tr>
    		</table>";
    		
    		if ($membership->event_id1)
    		{
                $sql="select a.*, concat_ws(',',
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id3')))) as leader_name from #__eb_events as a 
		 where a.id=".$membership->event_id1;
        	    $db->setQuery($sql);
        	    $event1 = $db->loadObject();
    		}
    		if ($membership->event_id2)
    		{
                $sql="select a.*,concat_ws(',',
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as c where c.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id3')))) as leader_name from #__eb_events as a 
		where a.id=".$membership->event_id2;
        	    $db->setQuery($sql);
        	    $event2 = $db->loadObject();
    		}
    
            $total=$prices[$membership->membership_type];
            $content = $content .
    		"<h2>Details of Qualifying Activities</h2>
            <table style='border-collapse: collapse;'>
                <tr>
                    <th>Walk</th>
                    <th>Qualifying Walks</th>
                    <th></th>
                    <th>Leader Name</th>
                    <th></th>
                    <th>Date of Walk</th>
                </tr>
                <tr>
                    <td>1</td>
                    <td>".$event1->title."</td>
                    <td>&nbsp;</td>
                    <td>".$event1->leader_name."</td>
                    <td>&nbsp;</td>
                    <td>".HTMLHelper::_('date', $event1->event_date, $config->event_date_format, null)."</td>
                </tr>
                <tr>
                    <td>2</td>
                    <td>".$event2->title."</td>
                    <td>&nbsp;</td>
                    <td>".$event2->leader_name."</td>
                    <td>&nbsp;</td>
                    <td>".HTMLHelper::_('date', $event2->event_date, $config->event_date_format, null)."</td>
                </tr>
            </table>" .
            "<p>I have read and understood these requirements and risks. I still wish to join and participate in Club activities and accept that in signing this form I take responsibility for my actions.</p>".
            "<table>
             <tr><td><b>SIGNATURE</b></td><td>" . $membership->first_name . " ". $membership->last_name."</td></tr><tr><td><b>DATE</b></td><td>".HTMLHelper::_('date', $membership->submit_date, 'd-m-Y', null)."</td></tr>
                    </table>".
    		"<h2>Yearly Costs</h2>".
    	"	<table style='border-collapse: collapse;'>
    		<tr>
    		    <td style='border-bottom:1px solid black;'><b>Item</b></td>
    		    <td style='border-bottom:1px solid black;'></td>
    		    <td style='border-bottom:1px solid black;'><b>Cost</b></td>
    		</tr>";
    		$content=$content."
    		<tr>
    		    <td>".$membership->membership_type."</td>
    		    <td>&nbsp;</td>
    		    <td nowrap>  <div style='float:left; text-align:left;'>$</div>
                      <div style='float:right; text-align:right;'>".number_format($prices[$membership->membership_type],2)."</div>
    		    </td>
    		</tr>";
    		if ($membership->name_pin=="1") {
    		    $total=$total+8.5;
    		    $content=$content."
    		<tr>
    		    <td>Name Badge with Pin</td>
    		    <td>&nbsp;</td>
    		    <td nowrap>  <div style='float:left; text-align:left;'>$</div>
                      <div style='float:right; text-align:right;'>8.50</div>
                </td>
    		</tr>";
    		}
    		if ($membership->name_magnet=="1") {
    		    $total=$total+9.5;
    		    $content=$content."
    		<tr>
    		    <td>Name Badge with Magnet</td>
    		    <td>&nbsp;</td>
    		    <td nowrap>  <div style='float:left; text-align:left;'>$</div>
                      <div style='float:right; text-align:right;'>9.50</div>
                </td>
    		</tr>";
    		}
    		if ($membership->mailed_footnotes=="1") {
    		    $total=$total+46;
    		    $content=$content."
    		<tr>
    		    <td>Footnotes by post</td>
    		    <td>&nbsp;</td>
    		    <td nowrap>  <div style='float:left; text-align:left;'>$</div>
                      <div style='float:right; text-align:right;'>46.00</div>
                </td>
    		</tr>";
    		}
    		$content=$content."
    		<tr>
    		<td style='border-top:1px solid black;border-bottom:1px solid black;'><b>TOTAL</b></td>
    		<td style='border-top:1px solid black;border-bottom:1px solid black;'>&nbsp;</td>
    		    <td nowrap style='border-top:1px solid black;border-bottom:1px solid black;'>  <div style='float:left; text-align:left;'>$</div>
                      <div style='float:right; text-align:right;'>".number_format($total,2)."</div>
                </td></tr>
    		</table><br>";
    		if (strpos($membership->membership_type,'Concession')!==false)
    		{
    		    $content=$content."<p><b>Concession Number:</b>&nbsp;".$membership->concession_number."</p>";
    		}
    		$content=$content."<p><b>How did you find out about the Maroondah Bushwalking Club Inc?</b></p>
    		<table>
    		<tr>
    		    <td>";
    		    if ($membership->find_out_friend) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Friend&nbsp;</td>
    		    <td></td>
    		    <td>";
    		    if ($membership->find_out_web) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Webpage&nbsp;</td>
    		    <td></td>
    		    <td>";
    		    if ($membership->find_out_facebook) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Facebook&nbsp;</td>
    		    <td></td>
    		    <td>";
    		    if ($membership->find_out_other) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Other:&nbsp;</td><td>".$membership->find_out_other."</td>
    		</tr>
    		</table>
    		<p><b>Please indicate if you have any of the following accreditation or training:</b></p>
    		
    		<table>
    		<tr>
    		    <td>";
    		    if ($membership->first_aid) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>First Aid&nbsp;</td>
    		    <td>";
    		    if ($membership->leader) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Leader&nbsp;</td>
    		    <td>";
    		    if ($membership->navigation) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Navigation&nbsp;</td>
    		    <td>";
    		    if ($membership->search_rescue) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Search & rescue</td>
    		</tr>
            </table>
    		<p><b>Please indicate if you have any special skills that you may be able to assist the club with:</b></p>
    		<table>
    		<tr>
    		    <td>";
    		    if ($membership->computer) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Computer&nbsp;</td>
    		    <td></td>
    		    <td>";
    		    if ($membership->financial) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Financial&nbsp;</td>
    		    <td></td>
    		    <td>";
    		    if ($membership->administrative) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Administrative&nbsp;</td>
    		    <td></td>
    		    <td>";
    		    if ($membership->skill_other) {
    		        $content = $content . "☑";
    		    }
    		    else {
    		        $content = $content . "☐";
    		    }
    		    $content = $content ."</td>
    		    <td>Other:&nbsp;</td><td>".$membership->skill_other."</td>
    		</tr>
    		</table>";    

            $recipients1 = 'membsec@mbwc.org.au' ;
            $recipients2 = $membership->email;

            // send one to membership sectretary, reply to new member email
            // send one to new member, reply to as membership sec
     	     $msg = "Membership Sent";
     	     $oldconfigname=$config->from_name;
     	     $oldconfigemail=$config->from_email;
            $config->from_name="DEV MBWC Info";
            $config->from_email="info@mbwc.org.au";
    		if (!MBWCHelper::sendMail($recipients1, "Membership Form for ".$membership->first_name." ".$membership->last_name, $content, 1, null, null, null, $membership->email, $membership->first_name." ".$membership->last_name))
    		{
    		    $msg = "Error sending Membership";
    		}
    		if (!MBWCHelper::sendMail($recipients2, "Membership Form for ".$membership->first_name." ".$membership->last_name, $content, 1, null, null, null, 'membsec@mbwc.org.au', 'MBWC Membership Secretary'))
    		{
    		    $msg = "Error sending Membership";
    		}
    		$config->from_name=$oldconfigname;
    		$config->from_email=$oldconfigemail;
            $this->setRedirect(Route::_("index.php"), $msg);
        }
		else 
		{
		    $msg= "Invalid Captcha";
            $app->setUserState('com_mbwc.membership.form.post', $post);
            $this->setRedirect(Route::_("index.php?option=com_mbwc&view=membership&error=1&Itemid=".$app->input->getInt('Itemid'), false), $msg);
		}
    }     
    public function save_membership()
    {
		$app = Factory::getApplication() ;
		$db = Factory::getDbo();
		$post = $app->input->post->getArray();
		$model =  $this->getModel('membership');
		$config = \EventbookingHelper::getConfig();
		$user = Factory::getUser() ;
		$userName = $user->get('name');
		$replyEmail = $user->get('email');
		$ret =  $model->save($post);
		if ($ret)
        {
     	    $oldconfigname=$config->from_name;
     	    $oldconfigemail=$config->from_email;
            $config->from_name="DEV MBWC Membership";
            $config->from_email="membsec@mbwc.org.au";
			$msg = "Membership updated";
            $recipients = array( 'membsec@mbwc.org.au' );
			$content = "<p>Hi Membsec,</p><p>Membership has been updated for ". $post['first_name'] . " ".$post['last_name']." by $userName<p>Regards, MBWC</p>";
    		MBWCHelper::sendMail($recipients, "Membership updated for ".$name, $content, 1);
    		$config->from_name=$oldconfigname;
    		$config->from_email=$oldconfigemail;
		}
        else
        {
			$msg = "Error updating Membership";
		}

		$this->setRedirect(Route::_('index.php?option=com_mbwc&view=memberships&Itemid='.$app->input->getInt('Itemid')) , $msg);
    }
    public function check_membership()
    {
	    $db = Factory::getDbo();
	    $user = Factory::getUser();
		$app = Factory::getApplication() ;

		$config = \EventbookingHelper::getConfig();	
		$Itemid = $app->input->getInt('Itemid');						
		$first_name    = $app->input->getVar('first_name', '');	
		$last_name    = $app->input->getVar('last_name', '');	
		$email    = $app->input->getVar('email', '');	

		// check if already booked
		$query="select distinct b.id from #__eb_registrants as a left join #__eb_events as b on b.id=a.event_id where ((a.last_name='".$last_name."' and a.first_name='".$first_name."') or a.email='".$email."') 
		and b.published=1 and date(b.event_date) >= DATE_SUB(CURDATE(), INTERVAL 1 YEAR) and date(b.event_date) <= CURRENT_DATE() and a.is_group_billing=0 and a.published=1 
		and date(b.event_date) >= (select ifnull(max(reject_date),date(b.event_date)) from jos_membership as c where ((c.last_name='".$last_name."' and c.first_name='".$first_name."') or c.email='".$email."') and c.status=2)";
	    $db->setQuery($query);
	    $events = $db->loadColumn();
 		if (count($events) < 2)
        {
            $msg="Not enough qualifying walks done. Please <a href='https://www.mbwc.org.au/contact-us'>Contact Us</a> to follow up.";
			$url = Route::_("index.php?option=com_mbwc&view=membername&Itemid=".$Itemid, false);
            $this->setRedirect($url,$msg);
		}
		else
		{
			$url = Route::_("index.php?option=com_mbwc&view=membership&event_id1=".$events[0]."&event_id2=".$events[1]."&first_name=".$first_name."&last_name=".$last_name."&email=".$email."&Itemid=".$Itemid, false);
            $this->setRedirect($url);
		}
       
    }
 	public function create_user()
    {
    	global $_CB_framework, $_PLUGINS, $ueConfig;
		$app = Factory::getApplication() ;
		$db = Factory::getDbo();
		$user = Factory::getUser() ;
		$config = \EventbookingHelper::getConfig();
		$model =  $this->getModel('membership');
		$membership =  $model->getItem();
        Log::add($user->get('name').' Create User from Membership:'.$membership->first_name.' '.$membership->last_name, Log::INFO, 'com_mbwc');
        
		
    	$user	=	new \CB\Database\Table\UserTable();
    	
    	$user->set( 'username', trim(  $membership->first_name . '.' .  $membership->last_name ) );
    	$user->set( 'email', $membership->email );
    	$user->set( 'name', trim(  $membership->first_name . ' ' .  $membership->last_name ) );
    	$user->set( 'firstname', trim(  $membership->first_name) );
    	$user->set( 'lastname', trim(  $membership->last_name) );
    	$user->set( 'gids', array( (int) $_CB_framework->getCfg( 'new_usertype' ), 55 ));
    	$user->set( 'sendEmail', 0 );
    	$user->set( 'confirmed', 0 );
    	$user->set( 'approved', 1 );
    	$user->set( 'block', 0 ); 
    	$user->set( 'registerDate', $_CB_framework->getUTCDate() );
    	$user->set( 'cb_joindate', $_CB_framework->getUTCDate() );
    	$user->set( 'password', $user->hashAndSaltPassword( "Password" ) );
     	$user->set( 'cb_address1', str_replace("'", "\'", $membership->address) );
     	$user->set( 'cb_suburbtown', str_replace("'", "\'", $membership->suburb) );
     	$user->set( 'cb_state','VIC' );
     	$user->set( 'cb_postcode', $membership->postcode );
     	$user->set( 'cb_dob', $membership->dob );
     	$user->set( 'cb_homephone', $membership->home_phone );
     	$user->set( 'cb_mobphone', $membership->mobile_phone );
     	$user->set( 'cb_status', 'Current' );
     	$user->set( 'cb_subscription', str_replace("'", "\'", $membership->membership_type) );
     	$user->set( 'cb_next_of_kin_1_name', str_replace("'", "\'", $membership->kin_name) );
     	$user->set( 'cb_next_of_kin_1_relationship', $membership->kin_relationship );
     	$user->set( 'cb_next_of_kin_1_mobile', $membership->kin_mobile_phone );
     	$user->set( 'cb_next_of_kin_1_home', $membership->kin_home_phone );
     	$user->set( 'cb_next_of_kin_2_name', str_replace("'", "\'", $membership->kin_name_2) );
     	$user->set( 'cb_next_of_kin_2_relationship', $membership->kin_relationship_2 );
     	$user->set( 'cb_next_of_kin_2_mobile', $membership->kin_mobile_phone_2 );
     	$user->set( 'cb_next_of_kin_2_home', $membership->kin_home_phone_2 );
     	$user->set( 'cb_gender', $membership->gender );

     	//$_PLUGINS->trigger( 'onBeforeUserRegistration', array( &$user, &$user ) );
        if ($user->store())
        {
    	  	  if ( $user->get( 'confirmed' ) == 0 ) {
    			$user->store();
    		}
   
    		$messagesToUser		=	activateUser( $user, 1, 'UserRegistration' );
    
    		//$_PLUGINS->trigger( 'onAfterUserRegistration', array( &$user, &$user, true ) );
    
            $sql = "update #__mbwc_membership set user_id=".$user->id." where id=".$membership->id;
  		    $db->setQuery($sql) ;
    		$db->execute();	
     		$sql = "select id from jos_cbsubs_plans where alias='".$membership->membership_type."'";
    		$db->setQuery($sql) ;
    		$plan=$db->loadResult() ;
    		if ($plan)
    		{
        		$sql = "INSERT INTO `jos_cbsubs_subscriptions`(`id`, `status`, `user_id`, `plan_id`, `parent_plan`, `parent_subscription`, `replaces_plan`, `replaces_subscription`, `subscription_date`, `last_renewed_date`, `expiry_date`, `next_event_date`, `next_event_id`, `next_event_params`, `autorenew_type`, `autorecurring_type`, `regular_recurrings_total`, `regular_recurrings_used`, `previous_autorecurring_type`, `previous_recurrings_used`, `previous_expiry_date`, `previous_status`, `ip_addresses`, `integrations`)
        		VALUES (null,'A',".$user->id.",".$plan.",0,0,null,null,curdate(),curdate(),if(month(curdate()) < 4, date(concat(year(curdate()),'-03-31')),date(concat(year(date_add(curdate(), interval 12 month)),'-03-31'))),null,0,'',0,0,0,0,0,0,null,'I',null,'[]')";
 
                 $db->setQuery($sql) ;
                 $db->execute();
     		     $msg="User ".$membership->first_name.' '.$membership->last_name. " Created with ID:".$user->id. ". Subscription created:".$membership->membership_type;
   		    }
   		    else
   		    {
    		   $msg="User ".$membership->first_name.' '.$membership->last_name. " Created with ID:".$user->id. ". No subscription created as no plan found:".$membership->membership_type;
   		    }

    		$this->setRedirect(Route::_('index.php?option=com_mbwc&view=memberships&Itemid='.$app->input->getInt('Itemid')) , $msg);
        }
        else
        {
            Log::add(' Create User store failed '.$user->getError(), Log::INFO, 'com_mbwc');
    		$msg=$user->getError();
    		$this->setRedirect(Route::_('index.php?option=com_mbwc&view=memberships&Itemid='.$app->input->getInt('Itemid')) , $msg);
        }
    
    }
    public function delete_membership()
    {
        $app = Factory::getApplication() ;
        $Itemid = $app->input->getInt('Itemid') ;
        $db = Factory::getDbo();
        $user = Factory::getUser() ;
        $id = $app->input->getInt('id');
        
        Log::add($user->get('name').' Delete Membership id:'.$id, Log::INFO, 'com_mbwc');
        $model = $this->getModel('membership');
        $model->delete($id);
		$this->setRedirect(Route::_('index.php?option=com_mbwc&view=memberships&Itemid='.$app->input->getInt('Itemid')) , $msg);
    }

    public function reject_membership()
    {
        $app = Factory::getApplication() ;
        $Itemid = $app->input->getInt('Itemid') ;
        $reason = $app->input->getVar('reason') ;
        $db = Factory::getDbo();
        $user = Factory::getUser() ;
        $id = $app->input->getInt('id');
        
        Log::add($user->get('name').' Reject Membership id:'.$id.' Reason: '.$reason, Log::INFO, 'com_mbwc');
        $model = $this->getModel('membership');
        $model->reject_membership($id, $reason);
		$this->setRedirect(Route::_('index.php?option=com_mbwc&view=memberships&Itemid='.$app->input->getInt('Itemid')) , $msg);
    }
    
    public function defer_membership()
    {
        $app = Factory::getApplication() ;
        $Itemid = $app->input->getInt('Itemid') ;
        $reason = $app->input->getVar('reason') ;
        $db = Factory::getDbo();
        $user = Factory::getUser() ;
        $id = $app->input->getInt('id');
        
        Log::add($user->get('name').' Defer Membership id:'.$id.' Reason: '.$reason, Log::INFO, 'com_mbwc');
        $model = $this->getModel('membership');
        $model->defer($id, $reason);
		$this->setRedirect(Route::_('index.php?option=com_mbwc&view=memberships&Itemid='.$app->input->getInt('Itemid')) , $msg);
    }
    public function undefer_membership()
    {
        $app = Factory::getApplication() ;
        $Itemid = $app->input->getInt('Itemid') ;
        $reason = $app->input->getVar('reason') ;
        $db = Factory::getDbo();
        $user = Factory::getUser() ;
        $id = $app->input->getInt('id');
        
        Log::add($user->get('name').' UnDefer Membership id:'.$id.' Reason: '.$reason, Log::INFO, 'com_mbwc');
        $model = $this->getModel('membership');
        $model->undefer($id, $reason);
		$this->setRedirect(Route::_('index.php?option=com_mbwc&view=memberships&Itemid='.$app->input->getInt('Itemid')) , $msg);
    }
}
?>