<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined( '_JEXEC' ) or die ;
namespace MBWC\Component\MBWC\Site\View\Countsbycategory;

/**
 * HTML View class for the Event Booking component
 *
 * @static
 * @package		Joomla
 * @subpackage	Event Booking
 * @since 1.0
 */
use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Factory;

// Require library + register autoloader
class HtmlView extends BaseHtmlView
{
	function display($tpl = null)
	{	
	    $this->setLayout('default') ;
		$app = Factory::getApplication() ;			
		$user = Factory::getUser() ;			
		$db = Factory::getDbo();
		if ($user->get('guest')) {
		    $app->redirect('index.php', JText::_("EB_NO_PERMISSION")) ;
		    return ;
		}

		$Itemid = $app->input->getInt('Itemid', 0) ;			

		$sql = "select concat(a.firstname,' ',a.lastname) as name, a.*,(select count(*) from jos_eb_events as c where year(c.event_date) = year(curdate()) and month(c.event_date) = month(curdate()) and c.event_date <= now() and c.published=1 
        and (JSON_UNQUOTE(json_extract(c.custom_fields,'$.field_leader_id1'))=a.user_id or JSON_UNQUOTE(json_extract(c.custom_fields,'$.field_leader_id2'))=a.user_id or JSON_UNQUOTE(json_extract(c.custom_fields,'$.field_leader_id3'))=a.user_id) and exists (select 1 from jos_mbwc_tripreports where event_id=c.id) and exists (select 1 from jos_eb_event_categories as d join jos_eb_categories as e on d.category_id=e.id join jos_mbwc_categoryextras as f on e.id=f.category_id where d.event_id=c.id and f.counts_as_trip=1)) as num_walks       
        from jos_comprofiler as a  where exists (select 1 from jos_user_usergroup_map as c where a.user_id = c.user_id and c.group_id=9) and a.cb_status='Current' order by num_walks desc limit 10";
		$db->setQuery($sql);
		$this->topTenThisMonth = $db->loadObjectList();

		$sql = "select distinct a.* from jos_users as a join jos_user_usergroup_map as b where (b.group_id=9 or b.group_id=25) and b.user_id=a.id order by a.name";
		$db->setQuery($sql);
		$this->leaders = $db->loadObjectList();
		
		$sql = "select e.* from jos_eb_categories as e join jos_mbwc_categoryextras as f on e.id=f.category_id where f.counts_as_trip=1 and published=1 order by ordering";
		$db->setQuery($sql);
		$this->categories = $db->loadObjectList();
 
	    $state = $this->get('State');
		$option    = 'com_mbwc' ;   
		$this->Itemid = $Itemid ;
		parent::display($tpl) ;				
	}
}