<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2023 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

namespace MBWC\Component\MBWC\Site\View\History;

use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Factory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Pagination\Pagination;
use Joomla\String\StringHelper;

// Require library + register autoloader
require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';


class HtmlView extends BaseHtmlView
{
	/**
	 * @var RADModelState
	 */
	protected $state;

	/**
	 * Registration history data
	 *
	 * @var array
	 */
	protected $items;

	/**
	 * Pagination
	 *
	 * @var Pagination
	 */
	protected $pagination;

	/**
	 * Filter dropdown array
	 *
	 * @var array
	 */
	protected $lists;

	/**
	 * Online payment plugins
	 *
	 * @var array
	 */
	protected $onlinePaymentPlugins;

	/**
	 * Component config
	 *
	 * @var RADConfig
	 */
	protected $config;

	/**
	 * Flag to determine if due amount column should be shown
	 *
	 * @var bool
	 */
	protected $showDueAmountColumn;

	/**
	 * Flag to determine if download certificate column should be shown
	 *
	 * @var bool
	 */
	protected $showDownloadCertificate;

	/**
	 * Flag to determine if download ticket column should be shown
	 *
	 * @var bool
	 */
	protected $showDownloadTicket;

	function display($tpl = null)
	{	
        $model = \RADModel::getTempInstance('History', 'EventbookingModel', ['table_prefix' => '#__eb_']);
		$config             = \EventbookingHelper::getConfig();
        $app = Factory::getApplication();
        $this->input=$app->input;
		$reg_id = $app->input->getInt('reg_id');
		$this->Itemid = $app->input->getInt('Itemid');
		$user = Factory::getUser();

		//Get list of events
		$fieldSuffix = \EventbookingHelper::getFieldSuffix();
		$db          = Factory::getDbo();

        $this->first_name="";
        $this->last_name="";
        if ($reg_id)
        {
			$sql  = 'SELECT first_name, last_name FROM #__eb_registrants where id='.$reg_id;
			$db->setQuery($sql);
			$reg = $db->loadObject();
			$this->first_name = $reg->first_name;
			$this->last_name = $reg->last_name;
            $model->setRegId($reg_id);
        }
		$model->populateState($this->input);
		$items = $model->getData();
		$state              = $model->getState();
		$lists['search']    = StringHelper::strtolower($state->filter_search);
		$lists['order_Dir'] = $state->filter_order_Dir;
		$lists['order']     = $state->filter_order;
 
		$this->state                   = $state;
		$this->lists                   = $lists;
		$this->items                   = $items;
		$this->pagination              = $model->getPagination();
		$this->config                  = $config;
		parent::display();

	}
}
