<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined( '_JEXEC' ) or die ;
namespace MBWC\Component\MBWC\Site\View\MailedNewsletters;

/**
 * HTML View class for the Event Booking component
 *
 * @static
 * @package		Joomla
 * @subpackage	Event Booking
 * @since 1.0
 */
use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Factory as JFactory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\HTML\HTMLHelper;

class HtmlView extends BaseHtmlView
{
	function display($tpl = null)
	{		
	    $this->setLayout('default') ;
		$mainframe = JFactory::getApplication() ;			
		$user = JFactory::getUser() ;			
		$db = JFactory::getDbo();
		if ($user->get('guest')) {
		    $mainframe->redirect('index.php', JText::_("EB_NO_PERMISSION")) ;
		    return ;
		}

		$Itemid = $mainframe->getInput()->getInt('Itemid', 0) ;			

		$sql = "select firstname, lastname, cb_address1, cb_address2, cb_suburbtown, cb_state, cb_postcode, ifnull(cb_complimentary_footnotes,0) as cb_complimentary_footnotes, p.name from jos_comprofiler as c join jos_cbsubs_subscriptions as s on c.user_id=s.user_id join jos_cbsubs_plans as p on s.plan_id=p.id where ((cb_subscription like '%mailed%' and cb_status = 'Current') or cb_complimentary_footnotes=1) and s.status = 'A' 
		union select firstname, lastname, cb_address1, cb_address2, cb_suburbtown, cb_state, cb_postcode, ifnull(cb_complimentary_footnotes,0) as cb_complimentary_footnotes, concat(op.order_product_name,', Order cost $',truncate(op.order_product_price,2),', Order date: ',DATE_FORMAT(FROM_UNIXTIME(o.order_modified), '%e %b %Y')) from jos_comprofiler as c join jos_hikashop_user as u on u.user_cms_id=c.user_id join jos_hikashop_order as o on o.order_user_id=u.user_id join jos_hikashop_order_product as op on op.order_id=o.order_id join jos_hikashop_product as p on op.product_id=p.product_id where o.order_status='confirmed' and p.product_alias = 'mailed-footnotes' and FROM_UNIXTIME(o.order_modified) > DATE_SUB(NOW(),INTERVAL 1 YEAR) order by 2";
		$db->setQuery($sql);
		$this->items = $db->loadObjectList();
		
		$this->Itemid = $Itemid ;
		parent::display($tpl) ;				
	}
}