<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
namespace MBWC\Component\MBWC\Site\View\Mailleaders;

// no direct access
defined( '_JEXEC' ) or die ;

/**
 * HTML View class for EventBooking component
 *
 * @static
 * @package		Joomla
 * @subpackage	Events Booking
 */
use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Factory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Log\Log;

require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

// Require library + register autoloader
class HtmlView extends BaseHtmlView
{
	function display($tpl = null)
	{	
 		$this->setLayout('default') ;
		$user = Factory::getUser();			    
		$app = Factory::getApplication() ;
		$option    = 'com_mbwc' ;									
        $doc= Factory::getDocument();
        $doc->setTitle("Mail Leaders");

		$jinput = $app->input;		
		$subject			=   $jinput->get('subject', '', 'string'); 
		$content			=   $jinput->get('content', '', 'raw'); 
		$leader_type		=   $jinput->get('leaderType', '', 'string'); 
		$this->content = $content;

		$config = \EventbookingHelper::getConfig();
		$Itemid = $app->getInput()->getInt('Itemid');
		$this->config = $config;
		$this->Itemid = $Itemid;
		$this->tmpl = $app->getInput()->get('tmpl');

		$replyName = $user->get('name');
		$replyEmail = $user->get('email');
		$replyId = $user->get('id');
		$emails = explode(",",$app->getInput()->getVar('emails')) ;

		$options = array();
		$options[] = HTMLHelper::_('select.option', 'all',  'All Leaders');
		$options[] = HTMLHelper::_('select.option', 'cb_tripleaderfamily',  'Family');
		$options[] = HTMLHelper::_('select.option', 'cb_tripleadereasy',  'Easy');
		$options[] = HTMLHelper::_('select.option', 'cb_tripleadereasymedium',  'Easy Medium');
		$options[] = HTMLHelper::_('select.option', 'cb_tripleadermedium',  'Medium');
		$options[] = HTMLHelper::_('select.option', 'cb_tripleadermediumhard',  'Medium Hard');
		$options[] = HTMLHelper::_('select.option', 'cb_tripleaderhard',  'Hard');
		$options[] = HTMLHelper::_('select.option', 'cb_tripleaderexperienced',  'Experienced');
		$options[] = HTMLHelper::_('select.option', 'cb_tripleaderbike',  'Bike');
		$options[] = HTMLHelper::_('select.option', 'firstaid',  'Leaders with expired first aid');
		$options[] = HTMLHelper::_('select.option', 'me',  'Send to '.$replyName.' for testing');
		$this->leader_type = HTMLHelper::_('select.genericlist', $options, 'leader_type', ' class="form-select" ', 'value', 'text', $leader_type);
   		$db = Factory::getDbo();
        for ($i=0; $i<count($options);$i++)
        {
            if ($options[$i]->value == "me")
            {
                $options[$i]->emails = $replyEmail;
                $options[$i]->names = $replyName;
            }
            elseif ($options[$i]->value == "firstaid")
            {
    			$sql = "select distinct b.email, b.name from #__comprofiler as a, #__users as b, #__user_usergroup_map as c where (a.cb_firstaidinterested is null or a.cb_firstaidinterested=1) and (a.cb_firstaid is null or a.cb_firstaid='No' or (a.cb_firstaid='Yes' and a.cb_firstaidexpirydate <= CURDATE())) and a.user_id = b.id and a.firstname != 'Demo' and b.email not like '%mbwc.org.au%' and a.user_id=c.user_id and c.group_id=9 and b.id != ".$replyId;
    	     	$db->setQuery($sql) ;
    	     	$user=$db->loadObjectList();
    			$options[$i]->emails = implode(',', array_map(function($x) { return $x->email; }, $user));
    			$options[$i]->names = implode(',', array_map(function($x) { return $x->name; }, $user));
            }
            elseif ($options[$i]->value == "all")
            {
                $sql = "select distinct b.email, b.name from jos_comprofiler as a, jos_users as b, jos_user_usergroup_map as c where a.user_id = b.id and a.firstname != 'Demo' and b.email not like '%mbwc.org.au%' and a.user_id=c.user_id and c.group_id=9 and b.id != ".$replyId." 
                union select distinct b.email, b.name from jos_comprofiler as a, jos_users as b where a.user_id=b.id and a.cb_eventcoordinatorrole is not null and a.cb_eventcoordinatorrole != ''";
     	     	$db->setQuery($sql) ;
   	     	    $user=$db->loadObjectList();
    			$options[$i]->emails = implode(',', array_map(function($x) { return $x->email; }, $user));
    			$options[$i]->names = implode(',', array_map(function($x) { return $x->name; }, $user));
            }
            else
            {
    			$sql = 'select distinct b.email, b.name from #__comprofiler as a, #__users as b, #__user_usergroup_map as c where a.'. $options[$i]->value . '="Yes" and a.user_id = b.id and a.firstname != "Demo" and b.email not like "%mbwc.org.au%" and a.user_id=c.user_id and c.group_id=9 and b.id != '.$replyId . '
    			union select distinct b.email, b.name from jos_comprofiler as a, jos_users as b where a.user_id = b.id and (a.cb_eventcoordinatorrole like "%'.str_replace(' ', '', $options[$i]->text).'%" or  a.cb_eventcoordinatorrole like "%Saturday%" or a.cb_eventcoordinatorrole like "%Sunday%") and b.id != '.$replyId;
    	     	$db->setQuery($sql) ;
    	     	$user=$db->loadObjectList();
    			$options[$i]->emails = implode(',', array_map(function($x) { return $x->email; }, $user));
    			$options[$i]->names = implode(',', array_map(function($x) { return $x->name; }, $user));
            }
        }

        $this->options=$options;
		if($subject)
		{

			if (MBWCHelper::sendMail($replyEmail, $subject, $content, 1, null, $emails, null, $replyEmail, $replyName))
			{ 
			    $user = Factory::getUser();
                Log::add($user->get('name').' Send email to leaders: '.implode(',',$emails).' subject='.$subject.' msg='.$content, Log::INFO, 'com_mbwc');
    	        $emailsForPrint = implode(', ',$emails);
 		        echo wordwrap("Mail sent bcc successfully to $emailsForPrint", 120, "<br />\n");
			}
			else
			{
    	        $emailsForPrint = implode(', ',$emails);
 		        echo wordwrap("Mail sent bcc unsuccessfully to $emailsForPrint", 120, "<br />\n");
			} 
		}
		

		parent::display($tpl);				
	}
}
