<?php
/**
 * @version		1.0
 * @package		MBWC
 * @subpackage	MBWC
 * @author  Jeff Dun
 * @copyright	Copyright (C) 2023
 * @license		GNU/GPL, see LICENSE.php
 */
namespace Mbwc\Component\Mbwc\Site\View\Membership;
// No direct access
defined('_JEXEC') or die;
require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use \Joomla\CMS\Factory;
use \Joomla\CMS\Language\Text;
use stdClass;

/**
 * HTML View class for EventBooking component
 *
 * @static
 * @package		Joomla
 * @subpackage	Events Booking
 */
class HtmlView extends BaseHtmlView
{
	function display($tpl = null)
	{	
		$this->setLayout('default') ;
		$user = Factory::getUser();			    
		$app = Factory::getApplication() ;

		$db = Factory::getDbo();
		$this->nullDate = substr($db->getNullDate(),0,10);
		$this->config = \EventbookingHelper::getConfig();	
		
		$sql = "select alias, rate from jos_cbsubs_plans";
		$db->setQuery($sql);
		$prices=$db->loadObjectList();
        $this->prices=array();
        for ($i=0;$i<count($prices);$i++)
        {
	        $this->prices[$prices[$i]->alias]=$prices[$i]->rate;
	    }

		if ($app->input->getInt('error', 0) == 1)
		{
		    $this->membership	= (object) $app->getUserState('com_mbwc.membership.form.post','data');
		    $this->edit=false;
		}
		else
		{
            $id = $app->input->getInt('id', 0);
    		if ($id)
    		{
    		    $this->membership = $this->get('Item');
        		$this->edit=true;
    		}
    		else
    		{
                $eventId1 = $app->input->getInt('event_id1', 0);
                $eventId2 = $app->input->getInt('event_id2', 0);
                $first_name = $app->input->getVar('first_name');
                $last_name = $app->input->getVar('last_name');
                $email = $app->input->getVar('email');
    		    $this->membership = new stdClass();
    		    $this->membership->first_name=$first_name;
    		    $this->membership->last_name=$last_name;
    		    $this->membership->email=$email;
    		    $this->membership->event_id1=$eventId1;
    		    $this->membership->event_id2=$eventId2;
    		    $this->membership->gender="";
    		    $this->membership->dob="";
    		    $this->membership->membership_type="";
    		    $this->membership->address="";
    		    $this->membership->suburb="";
    		    $this->membership->postcode="";
    		    $this->membership->home_phone="";
    		    $this->membership->mobile_phone="";
    		    $this->membership->mailed_footnotes="";
    		    $this->membership->name_pin="";
    		    $this->membership->name_magnet="";
    		    $this->membership->concession_number="";
    		    $this->membership->find_out_web="";
    		    $this->membership->find_out_friend="";
    		    $this->membership->find_out_facebook="";
    		    $this->membership->find_out_other="";
    		    $this->membership->first_aid="";
    		    $this->membership->leader="";
    		    $this->membership->navigation="";
    		    $this->membership->search_rescue="";
    		    $this->membership->computer="";
    		    $this->membership->financial="";
    		    $this->membership->administrative="";
    		    $this->membership->skill_other="";
    		    $this->membership->user_id="";
    		    $this->membership->amount_paid="";
    		    $this->membership->payment_received="";
    		    $this->membership->paypal="";
    		    $this->membership->direct_credit="";
    		    $this->membership->committee_approved="";
    		    $this->membership->submit_date="";
    		    $this->membership->kin_name="";
    		    $this->membership->kin_relationship="";
    		    $this->membership->kin_home_phone="";
    		    $this->membership->kin_mobile_phone="";
    		    $this->membership->kin_name_2="";
    		    $this->membership->kin_relationship_2="";
    		    $this->membership->kin_home_phone_2="";
    		    $this->membership->kin_mobile_phone_2="";
    		    $this->edit=false;
    		}
        }

		$Itemid =$app->input->getInt('Itemid');						
		$this->Itemid = $Itemid;
		$this->tmpl    = $app->input->getVar('tmpl', '');		

		parent::display($tpl);				
	}
}