<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
namespace MBWC\Component\MBWC\Site\View\Monthlytripreport;

// no direct access
defined( '_JEXEC' ) or die ;

/**
 * HTML View class for EventBooking component
 *
 * @static
 * @package		Joomla
 * @subpackage	Events Booking
 */
use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Factory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\HTML\HTMLHelper;

require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

// Require library + register autoloader
class HtmlView extends BaseHtmlView
{
	function display($tpl = null)
	{	
		$this->setLayout('default') ;
		$user = Factory::getUser();			    
		$app = Factory::getApplication() ;

		$Itemid = $app->getInput()->getInt('Itemid');						
		$this->Itemid = $Itemid;
		$this->tmpl = $app->getInput()->getVar('tmpl', '');	
		
		$listMonth = array(
			'January', 
			'February', 
			'March', 
			'April', 
			'May', 
			'June', 
			'July', 
			'August', 
			'September', 
			'October', 
			'November', 
			'December');
		$options = array();
		foreach ($listMonth as $key => $monthName)
		{
			if ($key < 9)
			{
				$value = "0" . ($key + 1);
			}
			else
			{
				$value = $key + 1;
			}
			$options[] = HTMLHelper::_('select.option', $value, $monthName);
		}
		$this->searchMonth = HTMLHelper::_('select.genericlist', $options, 'month', 'class="input-medium" ', 'value', 'text', date("m", strtotime("first day of previous month")));
		$options = array();
		$db = Factory::getDbo();
        $query="select distinct year(event_date) from #__eb_events where published=1 and event_date > '2000-00-00' order by 1 asc";
		$db->setQuery($query);
		$listYear = $db->loadColumn();

		$options = array();
		foreach ($listYear as $key => $yearName)
		{
			$options[] = HTMLHelper::_('select.option', $yearName, $yearName);
		}
		$this->searchYear = HTMLHelper::_('select.genericlist', $options, 'year', 'class="input-small" ', 'value', 'text', date("Y"));
		$this->Itemid = $Itemid;

		parent::display($tpl);				
	}
}