<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
namespace MBWC\Component\MBWC\Site\View\Newregistrant;

// no direct access
defined( '_JEXEC' ) or die ;

/**
 * HTML View class for EventBooking component
 *
 * @static
 * @package		Joomla
 * @subpackage	Events Booking
 */
use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Factory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Log\Log;

require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

// Require library + register autoloader
class HtmlView extends BaseHtmlView
{
	function display($tpl = null)
	{	
		$this->setLayout('default') ;
		$user = Factory::getUser();			    
		$app = Factory::getApplication() ;
		$option    = 'com_mbwc' ;									
		$published	= $app->getUserStateFromRequest( $option.'published', 'published', -1, 'int');												
		// search for word
		$eventId			= $app->getUserStateFromRequest( $option.'event_id',			'event_id',			0,				'int' );
		$this->waitlist = $app->input->getInt('waitlist');
		$from = $app->input->getVar('return');
		if ($this->waitlist)
		{
		    $this->published_state=3;
		}
		else
		{
		    $this->published_state=1;
		}

		$selecteduserId			=   $app->input->get('selectUser', '0', 'int'); 
		$newfirstname			=   $app->input->get('txtFirstName', '', 'string'); 
		$newlastname			=   $app->input->get('txtLastName', '', 'string'); 
		$newemail				=   $app->input->get('txtEmail', '', 'string'); 
		$newphone				=   $app->input->get('txtPhone', '', 'string'); 
		$newmobile				=   $app->input->get('txtMobile', '', 'string'); 
		
		$chknewuser = "";
		if ($newfirstname)
		{
		  $chknewuser				=   "NewUser";
		}
		//Get list of events
		$config = \EventbookingHelper::getConfig() ;
		$db = Factory::getDbo();

		$sql = 'SELECT date(event_date) FROM #__eb_events WHERE id='.$eventId;
		$db->setQuery($sql) ;
		$this->event_date=$db->loadResult();

		$Itemid = $app->input->getInt('Itemid');						
		$this->config = $config;
		$this->Itemid = $Itemid;
		$this->eventId = $eventId;
		$this->tmpl    = $app->input->getVar('tmpl', '');		
		$currentDate = gmdate('Y-m-d H:i:s');
		$sql = "SELECT a.*, (select group_concat(g.name separator ',') from jos_eb_event_categories as f inner join 
 jos_eb_categories as g on g.id = f.category_id and f.event_id=a.id) as category, IFNULL(SUM(if(b.published=1 or b.published=4,b.number_registrants,null)), 0) AS total_registrants FROM  #__eb_events AS a 
 LEFT JOIN #__eb_registrants AS b "
            . ' ON (a.id = b.event_id AND b.group_id=0) '
            . ' where a.id='.$eventId
            . ' GROUP BY a.id ';

		$db->setQuery($sql) ;
		$event=$db->loadObject();
		
        $dateParts = explode(' ', $event->event_date) ;
        $this->event=$event;
	    $startDate = strtotime($dateParts[0]) ;
        $now=strtotime(date('d-m-Y'));
		if($chknewuser == 'NewUser')
		{
            $query='select count(*) from #__eb_registrants as a join #__eb_events as b on a.event_id=b.id where a.last_name="'.$newlastname.'" and a.first_name="'.$newfirstname.'"and a.is_group_billing=0 and a.published in (1,3,4,5) and
            ( "' .$this->event->event_date. '" < if(b.event_end_date="0000-00-00 00:00:00",DATE_ADD(b.event_date, INTERVAL 5 HOUR),b.event_end_date) ) and 
            (if("'.$this->event->event_end_date.'"="0000-00-00 00:00:00",DATE_ADD("'.$this->event->event_end_date.'", INTERVAL 5 HOUR),"'.$this->event->event_end_date.'") > b.event_date) and b.published=1';
		    $db->setQuery($query);
		    $alreadyBooked = $db->loadResult();
            Log::add($user->get('name').' Add Visitor Registrant query='.$query, Log::INFO, 'com_mbwc');

            if (!$alreadyBooked)
            {
                $query="select count(*) from #__comprofiler where firstname='".$newfirstname."' and lastname= '".$newlastname."' and cb_status='Current'";
    		    $db->setQuery($query);
    		    $alreadyMember = $db->loadResult();

                if ($alreadyMember)
                {
                    $msg=$newfirstname." ".$newlastname." is a member. Please add them as such instead of as a visitor.";
                }
                else
                {
    		        // check if already booked on 3 walks in last 12 months (or booked in future) and you haven't applied as yet
            		$query="select count(*) from #__eb_registrants as a left join #__eb_events as b on b.id=a.event_id where ((a.last_name='".str_replace("'", "\'", $newlastname)."' and a.first_name='".$newfirstname."')) and b.published=1 and date(b.event_date) > now() - INTERVAL 12 month and a.is_group_billing=0 and a.published in (1,3,4,5) and b.id !=".$eventId." and not exists (select 1 from jos_membership as c where c.status=0 and ((c.last_name='".str_replace("'", "\'", $newlastname)."' and c.first_name='".$newfirstname."')))";

            		$db->setQuery($query);
            		$howManyBooked = $db->loadResult();
            		$now=date("Y-m-d H:i:s");
            		// allow adding visitors in the past
            		if ($howManyBooked<=2 || ($startDate < $now))
            		{
                        $user = Factory::getUser() ;
                        Log::add($user->get('name').' Add Visitor Registrant '.$newfirstname.' '.$newlastname.' for event:'.$event->title.' waitlist '.$this->waitlist, Log::INFO, 'com_mbwc');
            			$sql = "INSERT INTO #__eb_registrants (published,number_registrants, event_id, user_id, first_name, last_name, email, phone, register_date) values(".$this->published_state.", 1, ".$eventId.", 0, '" . $newfirstname ."', '" . str_replace("'", "\'", $newlastname) ."', '" .  $newemail . "', '" . $newphone . "', '" . $currentDate . "' )";
            			$db->setQuery($sql) ;
            			$db->execute();		
            
            			$newid = $db->insertid();
            			
            			if (strlen($newmobile) > 0)
            			{
                			$sql =  "INSERT INTO #__eb_field_values (registrant_id, field_id, field_value) values (" . $newid  . ", 1,'"  . $newmobile. "')";
                			$db->setQuery($sql) ;
                			$db->execute();			
            			}
            			// always mail info
                		if ($this->waitlist)
                		{
                		    $verb="waitlisted";
                		}
                		else
                		{
                		    $verb="registered";
                		}
            		    $content = "<p>Hi Information Officer,</p><p>The following Visitor has been ".$verb." for the event <b>".$event->title."</b> (".$event->category.") on <b>".date('l jS F Y', strtotime($event->event_date))."</b> by ".$user->get('name').".</p><p><b>Name:</b>&nbsp;".$newfirstname." ".$newlastname."</p><p><b>Home Phone Number:</b>&nbsp;".$newphone."</p><p><b>Mobile Phone Number:</b>&nbsp;".$newmobile."</p><p><b>Email:</b>&nbsp;".$newemail."</p>";
                        MBWCHelper::mail_info($newfirstname, $newlastname, $newemail, $event->title . '('.$event->category.')', $content);
            			$now=date("Y-m-d H:i:s");
            			// don't send mails in the past
            			if ($startDate >= $now)
            			{
                			if ($this->waitlist)
                			{
                                $app->enqueueMessage('Visitor successfully added to waitlist. Mail sent', 'info');               			    
                 			}
                			else
                			{
                                $app->enqueueMessage('Visitor successfully registered. Mail sent', 'info');               			    
                 			}
                		    $config = \EventbookingHelper::getConfig();
                    		$sql = 'SELECT * FROM #__eb_registrants WHERE id=' . $newid;
                    		$db->setQuery($sql);
                    		$row = $db->loadObject();
                    		$config->send_ics=1;
                    		// We need to remind these visitors to bring a temporary membership form
                		    MBWCHelper::sendAddMemberEmails($row, $config, $this->waitlist, 1);
            			}
            			else
            			{
                			if ($this->waitlist)
                			{
                                 $app->enqueueMessage('Visitor successfully added to waitlist in the past. NO mail sent', 'info');               			    
                 			}
                			else
                			{
                                  $app->enqueueMessage('Visitor successfully registered in the past. NO mail sent', 'info');               			    
                 			}
            			    
            			}
            		}
            		else
            		{
                         $app->enqueueMessage($newfirstname." ".$newlastname." has reached their limit of 3 bookings as a visitor in one year", 'warning');               			    
            		}
                }
            }
            else
            {
                   $app->enqueueMessage($newfirstname." ".$newlastname." has already been booked on an event at the same time", 'warning');               			    
            }
    		if ($from === "event" && $eventId)
    		{
    		   $app->redirect(Route::_(\EventbookingHelperRoute::getEventRoute($eventId, 0, $Itemid)));
    		}
    		else
    		{
    		    $app->redirect(Route::_(\EventbookingHelperRoute::getViewRoute('events', $Itemid), false));
    		}
		}	
		else if($selecteduserId == 0)
		{			
		}
		else
		{	
			if ($startDate >= $now)
			{
    			if ($this->waitlist)
    			{
                    $app->enqueueMessage('Member successfully added to waitlist. Mail sent', 'info');               			    
     			}
    			else
    			{
                     		$config->send_ics=1;
                    $app->enqueueMessage('Member successfully registered. Mail sent', 'info');               			    
     			}
    		    MBWCHelper::addUser($eventId, $selecteduserId, $this->waitlist, true);
			}
			else
			{
     		    MBWCHelper::addUser($eventId, $selecteduserId, $this->waitlist, false);
    			if ($this->waitlist)
    			{
                     $app->enqueueMessage('Member successfully added to waitlist in the past. NO mail sent', 'info');               			    
    			}
    			else
    			{
                     $app->enqueueMessage('Member successfully registered in the past. NO mail sent', 'info');               			    
      			}
			}
    		if ($from === "event" && $eventId)
    		{
    		   $app->redirect(Route::_(\EventbookingHelperRoute::getEventRoute($eventId, 0, $Itemid)));
    		}
    		else
    		{
    		    $app->redirect(Route::_(\EventbookingHelperRoute::getViewRoute('events', $Itemid), false));
    		}

		}
		
		parent::display($tpl);				
	}
}