<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2023 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

namespace MBWC\Component\MBWC\Site\View\Summary;

use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Factory;
use Joomla\CMS\Log\Log;

// Require library + register autoloader
require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';


class HtmlView extends BaseHtmlView
{
	function display($tpl = null)
	{	
		$this->setLayout('default') ;
		$app = Factory::getApplication() ;
		$option    = 'com_mbwc' ;									

		$eventId			= $app->getUserStateFromRequest( $option.'id',			'id',			0,				'int' );
		
		$db = Factory::getDbo();
		$sql = "select a.title,a.description,a.published from #__eb_events as a where a.id = ".$eventId;
	    $db->setQuery($sql) ;
		$this->item = $db->loadObject();

		// remove phone number
		$this->item->description = preg_replace('/([0-9]{3,}[\- .]?)/','',$this->item->description);
		// remove email
		$this->item->description = preg_replace('/([\w.-]+@[\w.-]+)/','',$this->item->description);
		
    	Log::addLogger(
            array(
                 // Sets file name
                'text_file' => 'visitors.log.php',
                'text_entry_format' => '{DATETIME} {CLIENTIP} {MESSAGE}'
           ),
            Log::ALL,
            array('visitors')
        );
        Log::add('Visitor viewing Visitor event description for event '.$this->item->title, Log::INFO, 'visitors');  

		parent::display($tpl);				
	}
}