<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
namespace MBWC\Component\MBWC\Site\View\Upcomingevents;

// no direct access
defined( '_JEXEC' ) or die ;

/**
 * HTML View class for EventBooking component
 *
 * @static
 * @package		Joomla
 * @subpackage	Events Booking
 */
use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Factory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\Registry\Registry;

require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

// Require library + register autoloader
class HtmlView extends BaseHtmlView
{
	function display($tpl = null)
	{
		$app = Factory::getApplication();
        $user = Factory::getUser();
		$db = Factory::getDbo();
		$nullDate = $db->getNullDate();
        $config = \EventbookingHelper::getConfig();
		$document = Factory::getDocument();
		$pathway = $app->getPathway();
        $model = $this->getModel();
        $option = "com_mbwc";
        $reset = $app->input->getInt('reset');
        $set_notme = $app->input->getInt('set_notme');
        $set_notfull = $app->input->getInt('set_notfull');
        $Itemid = $app->input->getInt('Itemid');
        $model->setState('past', 0);
        
        if ($this->getLayout() == 'footnotes')
        {
            $model->setState('filter_day', 0);
            $model->setState('filter_leader', '');
            $model->setState('filter_category', 0);
            $model->setState('filter_notme', 0);
            $model->setState('filter_notfull', 0);
            $app->setUserState('com_mbwc.upcomingevents.footnotes', 1);
        }
        else
        {
            $app->setUserState('com_mbwc.upcomingevents.footnotes', 0);
            if ($reset)
            {
                 $app->setUserState('com_mbwc.upcomingevents.filter_day', 0);
                 $app->setUserState('com_mbwc.upcomingevents.filter_leader', '');
                 $app->setUserState('com_mbwc.upcomingevents.filter_category', 0);
                 $app->setUserState('com_mbwc.upcomingevents.filter_notme', 0);
                 $app->setUserState('com_mbwc.upcomingevents.filter_notfull', 0);
            }
     
            $filter_category = $app->getUserStateFromRequest('com_mbwc.upcomingevents.filter_category', 'filter_category', '0');
    
            $filter_leader = $app->getUserStateFromRequest('com_mbwc.upcomingevents.filter_leader', 'filter_leader', '');
    
            $day = $app->getUserStateFromRequest('com_mbwc.upcomingevents.filter_day', 'filter_day', '0');
    
            $filter_notfull= $app->getUserStateFromRequest('com_mbwc.upcomingevents.filter_notfull', 'filter_notfull', '0');
    
            $filter_notme = $app->getUserStateFromRequest('com_mbwc.upcomingevents.filter_notme', 'filter_notme', '0');
     		
            if ($day)
            {
                $app->setUserState('com_mbwc.upcomingevents.filter_day', $day);
                $model->setState('filter_day', $day);
            }
            if ($filter_leader)
            {
                $app->setUserState('com_mbwc.upcomingevents.filter_leader', $filter_leader);
                $model->setState('filter_leader', $filter_leader);
            }
            if ($filter_category)
            {
                $app->setUserState('com_mbwc.upcomingevents.filter_category', $filter_category);
                $model->setState('filter_category', $filter_category);
            }
            if ($filter_notme || $set_notme)
            {
                $app->setUserState('com_mbwc.upcomingevents.filter_notme', $filter_notme);
                $model->setState('filter_notme', $filter_notme);
            }
            if ($filter_notfull || $set_notfull)
            {
                $app->setUserState('com_mbwc.upcomingevents.filter_notfull', $filter_notfull);
                $model->setState('filter_notfull', $filter_notfull);
            }
    		
    		$this->filter_day = $day;
    		$this->filter_category = $filter_category;
    		$this->filter_leader = $filter_leader;
    		$this->filter_notfull = $filter_notfull;
    		$this->filter_notme = $filter_notme;
        }

		$items = $model->getItems();
		$pagination = $model->getPagination();
        $document->setTitle("Upcoming Events");

		$sql = "select distinct b.name from #__users as b left join
		    jos_eb_events as a on json_unquote(json_extract(a.custom_fields,'$.field_leader_id1')) = b.id or json_unquote(json_extract(a.custom_fields,'$.field_leader_id2'))=b.id or json_unquote(json_extract(a.custom_fields,'$.field_leader_id3'))=b.id where a.published=1 and a.event_date > now() order by b.name";
		$db->setQuery($sql) ;
		$this->leaders = $db->loadObjectList() ;

		if ($config->event_custom_field)
		{
			for ($i = 0, $n = count($items); $i < $n; $i++)
			{
				$item = & $items[$i];
			    $item->paramData = new Registry($item->custom_fields);
			}
		}

		$userId = $user->get('id');
		$viewLevels = $user->getAuthorisedViewLevels();
		$this->viewLevels = $viewLevels;
		$this->userId = $userId;
		$this->items = $items;
		$this->pagination = $pagination;
		$this->config = $config;
		$this->config->Itemid=$Itemid;
		$this->nullDate = $nullDate;
        $this->Itemid = $Itemid;
		parent::display($tpl);
	}
}