<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
namespace MBWC\Component\MBWC\Site\View\Yearplanner;

// no direct access
defined( '_JEXEC' ) or die ;

/**
 * HTML View class for EventBooking component
 *
 * @static
 * @package		Joomla
 * @subpackage	Events Booking
 */
use Joomla\CMS\MVC\View\HtmlView as BaseHtmlView;
use Joomla\CMS\Factory;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\HTML\HTMLHelper;

require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

// Require library + register autoloader
class HtmlView extends BaseHtmlView{

	public static function getEventsByYear( $year, $filter_allmulti)
	{
	    $colors = array ("#c1af83",
            "#a9e3e5",
            "#e59f9d",
            "#a1debd",
            "#e0978c",
            "#9eb67e",
            "#fdb1a5",
            "#96c3d8",
            "#dca280",
            "#80b89c",
            "#d7a08f",
            "#e3e6ae",
            "#c9aba2",
            "#ead5a4",
            "#94b59c",
            "#e0d7c5",
            "#cfaf97",
            "#d4f1c8",
            "#eeb392",
            "#aac08a",
            "#dbbcdd",
            "#bfc08c",
            "#e4a9b7",
            "#e3bd93",
            "#c0b495");
		$app = Factory::getApplication() ;			
		$db = Factory::getDbo();
		$user = Factory::getUser() ;		
		$startDate 	= mktime( 0, 0, 0,  0,  1, $year ); 
		$endDate 	= mktime( 23, 59, 59,  11, date( 't', $startDate), $year );
		$startDate = date('Y-m-d', $startDate)." 00:00:00";
		$endDate = date('Y-m-d', $endDate)." 23:59:59";
		$where = array() ;
		$where[] = 'a.`published` = 1';
		$where[] = "(`event_date` < '$endDate' or event_end_date > '$startDate' )" ;
		$where[] = "a.access IN (".implode(',', $user->getAuthorisedViewLevels()).")" ;
		if ($filter_allmulti)
		{
		    $where[] = ' ((DATE(a.event_date) != DATE(a.Event_end_date) and a.event_end_date != "0000-00-00 00:00:00") or a.id IN (SELECT event_id FROM #__eb_event_categories WHERE category_id=53  or category_id=19))';
		}
		else
		{
	     	$where[] = '  a.id IN (SELECT event_id FROM #__eb_event_categories WHERE category_id=17 or category_id=53 or category_id=18 or category_id=19)';
		}
        $query = 'SELECT a.*, (SELECT 1 FROM #__eb_event_categories WHERE (category_id=53 or category_id=19 or category_id=18) and event_id=a.id) as is_meeting, 
        (SELECT 1 FROM #__eb_event_categories WHERE (category_id=19) and event_id=a.id) as is_committee,IFNULL(SUM(b.number_registrants), 0) AS total_registrants FROM #__eb_events AS a '
    	 . ' LEFT JOIN #__eb_registrants AS b '
    	 . ' ON (a.id = b.event_id AND b.group_id=0 AND (b.published = 1 OR b.published = 4)) '
		 .'  WHERE '.implode(' AND ', $where)
    	 . '  and (YEAR(a.event_end_date) = '.$year.' or YEAR(a.event_end_date) = '.($year+1).') group by a.id'
    	 . ' ORDER BY a.event_date ASC, a.ordering ASC';	
		$db->setQuery($query);

		if (true)
        {
		     $rows = $db->loadObjectList() ;

		     $rowEvents = array() ;
		     for ($i = 0 , $n = count($rows) ; $i < $n ; $i++)
             {
		         $row = $rows[$i] ;
		         $row->color = $colors[$i%25];
		         if ($row->is_meeting)
		         {
		             $row->color = "#FFFF00";
		         }
		         $arrDates = explode('-', $row->event_date) ;
		         if ($arrDates[0] == $year)
                 {
		         	$rowEvents[] = $row ;
		         }		         
		         $startDateParts = explode(' ', $row->event_date) ;
		         $startTime = strtotime($startDateParts[0]) ;
		         $startDateTime = strtotime($row->event_date) ;
		         $endDateParts = explode(' ', $row->event_end_date) ;
		         $endTime = strtotime($endDateParts[0]) ;
		         $count = 0 ;
		         while ($startTime < $endTime)
                 {
		             $count++ ;
		             $rowNew = clone ($row) ;
		             $rowNew->event_date = date('Y-m-d H:i:s', $startDateTime + $count*24*3600);
		             $arrDates = explode('-', $rowNew->event_date) ;
		             if ($arrDates[0] == $year)
                     {
		             	$rowEvents[] = $rowNew ;
		             }		             
		             $startTime += 24*3600 ;
		         }		         		        
		     }				     		     
		     return $rowEvents ;   
		}
        else
        {
             return $db->loadObjectList() ;		    
		}			
	}
	public static function getYMD(){

		static $data;

		if (!isset($data))
		{
		    $app = Factory::getApplication() ;			
			$datenow = Factory::getDate("+0 seconds");
            list($year, $month, $day) = explode('-', $datenow->format('Y-m-d'));
			$year	= min(2100, abs(intval($app->getInput()->getVar('year',	$year))));
			$month	= min(99, abs(intval($app->getInput()->getVar('month',	$month))));
			$day	= min(3650, abs(intval($app->getInput()->getVar('day',	$day))));
			if( $day <= '9' ) 
			{
				$day = '0' . $day;
			}
			if( $month <= '9') 
			{
				$month = '0' . $month;
			}
			$data = array();
			$data[]=$year;
			$data[]=$month;
			$data[]=$day;
		}
		return $data;
	}
    public static function transposeData($data) {
        $out = array();
        foreach ($data as $key => $subarr) {
            foreach ($subarr as $subkey => $subvalue) {
                $out[$subkey][$key] = $subvalue;
            }
        }
        return $out;
    }
    public static function getShortDayName( $dayNumber)
    {
        static $days;
        if ($days == null)
        {
            $days = array(
                "Sun",
                "Mon",
                "Tue",
                "Wed",
                "Thu",
                "Fri",
                "Sat"
            );
        }
        $i = $dayNumber % 7;
        return  $days[$i];
    }

 public static function getYearCalendarData($rows, $year){
        $rowCount = count( $rows );
        $data = array();
        $data['year'] = $year;
        $data["dates"] = array();
        $month = 1;
        //Start days
        $start = (( date( 'w', mktime( 0, 0, 0, $month, 1, $year )) - 0 + 7 ) % 7 );
        $dayCount=0;

        for( $m = 1; $m <= 12; $m++ )
        {
            $month=$m;
            if( $month <= '9' )
            {
                $month = '0' . $month;
            }

            $end = date( 't', mktime( 0, 0, 0,( $month + 1 ), 0, $year ));
            $dayCount=0;
            $dw = date( 'w', mktime( 0, 0, 0, $month, 1, $year )); // sunday = 0. Want to start from a monday, so if sunday, add 7

            if ($dw==0)
            {
                $dw=$dw+7;
            }
            $dw=$dw-1;
            // if we are not monday, add blank dates
            for ($dayCount=0;$dayCount<$dw;$dayCount++)
            {
                $data["dates"][$m][$dayCount] = array();
                $data["dates"][$m][$dayCount]["month"] = $m;
                $data["dates"][$m][$dayCount]["year"] = $year;
                $data["dates"][$m][$dayCount]["day"] = self::getShortDayName($dayCount+1);
                $data["dates"][$m][$dayCount]["d"] = 0;
            }
            for( $d = 1; $d <= $end; $d++ )
            {
                $data["dates"][$m][$dayCount] = array();
                $data["dates"][$m][$dayCount]["month"] = $m;
                $data["dates"][$m][$dayCount]["year"] = $year;
                $data["dates"][$m][$dayCount]["day"] = date('D', strtotime( $year . '-'.$month. '-'.$d));
                
                if( $d <= 9 )
                {
                    $d = '0' . $d;
                }
                $data["dates"][$m][$dayCount]['d'] = $d;
                $data["dates"][$m][$dayCount]['events'] = array();
                if( $rowCount > 0 )
                {
                    foreach ($rows as $row)
                    {
                        $date_of_event = explode('-',$row->event_date);
                        $day_of_event = (int)$date_of_event[2];
                        $month_of_event = (int)$date_of_event[1];
                        
                        if ($d == $day_of_event && $month_of_event==$m)
                        {
                            $i=count($data["dates"][$m][$dayCount]['events']);
                            $data["dates"][$m][$dayCount]['events'][$i] = $row;
                        }
                    }
                }
    
                $dayCount++;
            }
        }
        $data["dates"]=self::transposeData($data["dates"]);
        return $data;
    }

	function display($tpl = null)
	{
		$config = \EventbookingHelper::getConfig();
		$this->config = $config;
		$app = Factory::getApplication() ;

		$Itemid =  $app->getInput()->getInt('Itemid', 0);
		$year =  $app->getInput()->getInt('year');
		$this->filter_allmulti =  $app->getInput()->getInt('filter_allmulti');
		if (!$year)
		{
			$year = date("Y");
		}
		list ($year, $month, $day) = self::getYMD();
        $rows = self::getEventsByYear($year, $this->filter_allmulti);

		$this->data = self::getYearCalendarData($rows, $year);

		$this->year = $year;
		$listMonth = array(
	"Jan",
	"Feb",
	"Mar",
	"Apr",
	"May",
	"Jun",
	"Jul",	
	"Aug",
	"Sep",
	 "Oct",
	"Nov",
	"Dec");
		$options = array();
		for ($i = $year - 3; $i < ($year + 5); $i++)
		{
			$options[] = HTMLHelper::_('select.option', $i, $i);
		}
		$this->searchYear = HTMLHelper::_('select.genericlist', $options, 'year', 'class="form-select" onchange="submit();" ', 'value', 'text', $year);
		$this->Itemid = $Itemid;
		$this->listMonth = $listMonth;
				
		parent::display($tpl);
	}
}