<?php 
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Uri\Uri;

defined( '_JEXEC' ) or die ;
require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';

\EventbookingHelperModal::iframeModal('a.eb-summary', 'eb-registrant-lists-modal');
$document = Factory::getDocument();
$baseUri  = Uri::base(true);
$document->addStyleSheet(
	$baseUri . '/media/com_eventbooking/assets/css/style.min.css',
	['version' => \EventbookingHelper::getInstalledVersion()]
);

?>

<table class="table jdisplay table-striped table-bordered table-condensed eb-responsive-table">
	<thead>
		<tr>
		<th>
			Day
		</th>
		<th style="width:8%">
			<?php echo "Event&nbsp;Date"; ?>
		</th>
					<?php 
					  if (!$config->readOnly)
					  {
					?>
		<th>
			Leader
		</th>
					<?php 
					  }
					?>										
		<th class="date_col">
			Category
		</th>
		<th>
			Distance (km)
		</th>
				<th>
					Registered
				</th>	
		<th>
			Event
		</th>

					<?php 
					  if ($config->readOnly)
					  {
					?>
			<th class="center actions-col">
				Action
			</th>
			<?php	
			}
			?>		
		</tr>
	</thead>
	<tbody>
	<?php
		$db = JFactory::getDbo();

	    $user = JFactory::getUser();
		for ($i = 0 , $n = count($items) ; $i < $n; $i++) 
		{
			$item = $items[$i] ;
    		$db->setQuery("SELECT max(h.external_event) FROM #__eb_categories as a join jos_mbwc_categoryextras as h on a.id=h.category_id WHERE a. id IN (SELECT category_id FROM #__eb_event_categories WHERE event_id = $item->id)");
    		$external_event=$db->loadResult();
    		
		    $sql = 'SELECT COUNT(id) FROM #__eb_registrants WHERE user_id='.$user->id.' AND event_id='.$item->id.' AND published=1';
            $db->setQuery($sql) ;
            $user_registered = $db->loadResult() ;
            
		    $sql = 'SELECT COUNT(id) FROM #__eb_registrants WHERE user_id='.$user->id.' AND event_id='.$item->id.' AND published=3';
            $db->setQuery($sql) ;
            $user_waitlist = $db->loadResult() ;

			$canRegister = MBWCHelper::acceptRegistration($item->id) ;
		    if (($item->event_capacity > 0) && ($item->event_capacity <= $item->total_registrants)  && !$user_registered  && !$user_waitlist) 
			{
        	    $waitingList = true ;
        	    $waitinglistUrl = JRoute::_('index.php?option=com_eventbooking&view=waitinglist&event_id='.$item->id.'&Itemid='.$config->Itemid);
        	} 
        	else 
			{
        	    $waitingList = false ;
        	}					        	
		?>
			<tr>
				<td data-content="Day">
					<?php 
					    if ($item->event_date == EB_TBC_DATE) 
						{
                        	echo JText::_('EB_TBC');
                        } 
                        else 
						{
                            echo date("l", strtotime($item->event_date));
                        }
					?>										
				</td>				
				<td data-content="Event Date">	
					<?php
                    	if ($item->event_date == EB_TBC_DATE) 
						{
                        	echo JText::_('EB_TBC');
                        } 
                        else 
						{
                            echo JHtml::_('date', $item->event_date, 'd-m-Y', null);
                        }
					?>										
				</td>	
					<?php 
					  if (!$config->readOnly)
					  {
					?>
				<td data-content="Leader">
					<?php 
					
					if ($external_event)
					{
					    echo "N/A";
					}
					else
					{
     					echo $item->leader_name;
					}
					
					?>
				</td>
					<?php 
					  }
					?>										
				<td data-content="Category">
					<?php 
					$db = JFactory::getDbo();
					$db->setQuery("SELECT name FROM #__eb_categories WHERE id IN (SELECT category_id FROM #__eb_event_categories WHERE event_id = $item->id)");
					echo implode(', ', $db->loadColumn());					
					?>	
				</td>
				<td data-content="Distance (km)">
					<?php echo empty($item->paramData['field_distance'])? 'All':$item->paramData['field_distance']; ?>	
				</td>
				<td data-content="Registered">
							<?php
							$line_sep="";
							if ($config->readOnly)
							{
							    if ($item->event_capacity && $item->total_registrants >= $item->event_capacity)
							        {
							            echo "<i>Full</i>";
							        }
        							elseif ($item->registration_type == 4)
        							{
        							    echo "Email to check";
        							}
        							else
        							{
        							    if (($item->event_capacity-$item->total_registrants) > 1)
        							    {
        							      echo $item->event_capacity-$item->total_registrants . " Spots Remaining";
        							    }
        							    else
        							    {
        							      echo $item->event_capacity-$item->total_registrants . " Spot Remaining";
        							    }
        							}
							}
							else if ($external_event)
							{
							    echo "External";
							    $line_sep="<br>";
							}
							else if ($item->published == 2)
							{
							    echo "<b>Cancelled</b>";
							    $line_sep="<br>";
							}
							else
							{
							    if ($user_registered > 0)
							    {
							        echo "<b>Booked</b> ";
							        $line_sep="<br>";
							    }
							    if ($user_waitlist > 0)
							    {
							        echo "<b>Waitlisted</b> ";
							        $line_sep="<br>";
							    }
						        $numberDays = 0;
					    		if ($item->cut_off_date != $db->getNullDate())
                        		{
                        			$sql = 'SELECT ifnull(DATEDIFF(NOW(), cut_off_date),0) AS number_days FROM #__eb_events WHERE id=' . $item->id;
                            		$db->setQuery($sql);
                            		$numberDays = $db->loadResult();
                        		}
                        		if ($numberDays > 0)
                        		{
 							        echo $line_sep."<i>Passed Cut-off</i>&nbsp;";
							        $line_sep="<br>";
                        		}
							    if (!$item->event_capacity)
							    {
							        $capacity="&#8734;";
							    }
							    else
							    {
							        $capacity=$item->event_capacity;
							    }
							    if ($external_event)
							    {
							        echo "External";
							    }
							    else if ($item->registration_type == 3)
                        		{
                        		    echo $line_sep."<i>Registration Disabled</i> (". $capacity .")";
							        $line_sep="<br>";
                        		}
                        		else if ($item->registration_type == 4)
                        		{
                        		    echo $line_sep."<i>Phone Bookings</i> (". $capacity .")";
							        $line_sep="<br>";
                        		}
							    else
							    {
							        if ($item->event_capacity && $item->total_registrants >= $item->event_capacity)
							        {
							            echo $line_sep."<i>Full</i> (". $capacity .")";
							            
                             			$sql = 'SELECT SUM(number_registrants) FROM #__eb_registrants WHERE event_id='.$item->id.' AND group_id=0 AND (published = 3 or published=5)';
                        			    $db->setQuery($sql);
                                        $total_waitlist = (int) $db->loadResult();
   							            
							            if ($total_waitlist > 0)
							            {
							                echo "<br>Waitlist (".$total_waitlist.")";
							            }
							        }
							        else
							        {
                                        echo $line_sep.$item->total_registrants . "/". $capacity;
							        }
                                }
						    }

                            ?>
						</td>
				<td data-content="Event">
				<?php
					if (!$config->readOnly) 
					{
			        ?>
					<a href="<?php echo JRoute::_(EventbookingHelperRoute::getEventRoute($item->id, 0, $config->Itemid));?>" class="eb-event-link"><?php if ($item->published == 2) echo "CANCELLED - "; echo $item->title ; ?></a>
					<?php 
					  }
					  else
					  {
					      if ($item->published == 2) echo "CANCELLED - "; ?>
					    <a class="eb-summary" href="index.php?option=com_mbwc&view=summary&tmpl=component&id=<?php echo $item->id ?>" ><?php echo $item->title; ?></a>
					    <?php
					  }
					?>										
				</td>					
				

					<?php 
					  if ($config->readOnly)
					  {
					?>
					<td class="center">
					    <a class="btn btn-primary"  href="<?php echo JRoute::_('index.php?option=com_mbwc&view=visitormailleader&event_id='.$item->id.'&Itemid='.$config->Itemid) ?>" ><?php echo "Register"; ?></a>
					    </td>
					<?php	
					}
				?>

			</tr>
			<?php								
		}						
	?>		
	</tbody>
</table>