<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined( '_JEXEC' ) or die ;

Joomla\CMS\HTML\HTMLHelper::_('jquery.framework');
?>
<script language="javascript" type="text/javascript">
function tableOrdering( order, dir, task )
{
	var form = document.adminForm;

	form.filter_order.value = order;
	form.filter_order_Dir.value = dir;
	document.adminForm.submit( task );
}
jQuery(document).ready(function () {
    jQuery('.wcheader').click(function(){
        jQuery(this).nextUntil('tr.wcheader').slideToggle(100);
    });
});
</script>

<h1 class="eb-page-heading">Counts by Category by Month</h1>
<p><b>Note:&nbsp;</b>Click on a Category to see the leaders who led the walks in that category.<br>Walks with two leaders will show both leaders independantly in the counts, but the total number of walks will only include the one walk.</p>
	<table class="table jdisplay table-bordered table-considered table-striped">
                <thead>
                    <tr>
                        <th><?php echo 'Category'; ?></th>
                        <?php
                        for ($month=1, $m=date('m')+1; $month < $m; $month++)
                        {
                            $dateObj   = DateTime::createFromFormat('!m', $month);
                            $monthName = $dateObj->format('F');
                            echo "<th>".$monthName."</th>";
                        }
                        ?>
                    </tr>
                </thead>
                <tbody>
                     <?php
	            	$db = JFactory::getDbo();
                    for ($i=0, $n=count( $this->categories ); $i < $n; $i++)
                    {
                        $category = &$this->categories[$i];
                        echo '<tr class="wcheader" style="cursor:pointer;"><td><i class="icon-eye-open"></i>&nbsp;<b>'.$category->name.'</b></td>';
                        for ($month=1, $m=date('m')+1; $month < $m; $month++)
                        {
                     		$sql = "select count(*) as ct from jos_eb_events as c join jos_eb_event_categories as b on c.id = b.event_id and b.category_id=$category->id where c.published=1 and (exists (select 1 from jos_mbwc_tripreports where event_id=c.id) or exists (select 1 from jos_mbwc_tripreports as g join jos_eb_events as h on g.event_id = h.id where h.parent_id=c.id)) and year(c.event_date) = year(curdate()) and month(c.event_date)=$month";
                    		$db->setQuery($sql);
                    		$counts=$db->loadResult();
                    		echo "<td>".$counts."</td>";
                      }
                        echo "</tr>\n";
                		$sql = "select * from (select a.id, concat(a.firstname,' ',a.lastname) as name, (select count(*) from jos_eb_events as c where year(c.event_date) = year(curdate()) and month(c.event_date) <=month(curdate()) and c.event_date <= now() and c.published=1 
                        and (JSON_UNQUOTE(json_extract(c.custom_fields,'$.field_leader_id1'))=a.user_id or JSON_UNQUOTE(json_extract(c.custom_fields,'$.field_leader_id2'))=a.user_id or JSON_UNQUOTE(json_extract(c.custom_fields,'$.field_leader_id3'))=a.user_id) and (exists (select 1 from jos_mbwc_tripreports where event_id=c.id) or exists (select 1 from jos_mbwc_tripreports as g join jos_eb_events as h on g.event_id = h.id where h.parent_id=c.id)) and exists (select 1 from jos_eb_event_categories as d join jos_eb_categories as e on d.category_id=e.id join jos_mbwc_categoryextras as f on e.id=f.category_id where d.event_id=c.id and f.counts_as_trip=1) and exists (select 1 from jos_eb_event_categories as d where d.event_id=c.id and d.category_id=".$category->id.")) as num_walks       
                        from jos_comprofiler as a  where exists (select 1 from jos_user_usergroup_map as c where a.user_id = c.user_id and c.group_id=9) and a.cb_status='Current') as x where x.num_walks > 0 order by num_walks desc";
                		$db->setQuery($sql);
                		$leaders = $db->loadObjectList();
                        for ($l=0, $p=count( $leaders ); $l < $p; $l++)
                        {
                            echo "<tr style='display:none'>";
            		        echo "<td>&nbsp;&nbsp;".$leaders[$l]->name."</td>";
                            for ($month=1, $m=date('m')+1; $month < $m; $month++)
                            {
                         		$sql = "select (select count(*) from jos_eb_events as c where year(c.event_date) = year(curdate()) and month(c.event_date) =$month and c.event_date <= now() and c.published=1 
                                and (JSON_UNQUOTE(json_extract(c.custom_fields,'$.field_leader_id1'))=a.user_id or JSON_UNQUOTE(json_extract(c.custom_fields,'$.field_leader_id2'))=a.user_id or JSON_UNQUOTE(json_extract(c.custom_fields,'$.field_leader_id3'))=a.user_id) and (exists (select 1 from jos_mbwc_tripreports where event_id=c.id) or exists (select 1 from jos_mbwc_tripreports as g join jos_eb_events as h on g.event_id = h.id where h.parent_id=c.id)) and exists (select 1 from jos_eb_event_categories as d join jos_eb_categories as e on d.category_id=e.id join jos_mbwc_categoryextras as f on e.id=f.category_id where d.event_id=c.id and f.counts_as_trip=1) and exists (select 1 from jos_eb_event_categories as d where d.event_id=c.id and d.category_id=".$category->id.")) as num_walks       
                                from jos_comprofiler as a  where a.id=".$leaders[$l]->id;
                        		$db->setQuery($sql);
                        		$walks = $db->loadObject();
                          		echo "<td>".$walks->num_walks."</td>";
                           }
                           echo "</tr>";
                       }
                    }
                    ?>
                </tbody>
            </table>



<h1 class="eb-page-heading">Top 10 this month</h1>

	<table class="table jdisplay table-bordered table-considered table-striped">
                <thead>
                    <tr>
                        <th><?php echo 'Leader Name'; ?></th>
	                    <th><?php echo 'Number Walks Led'; ?></th>
                    </tr>
                </thead>
                <tbody>
                    <?php
                    for ($i=0, $n=count( $this->topTenThisMonth ); $i < $n; $i++)
                    {
                        $row = &$this->topTenThisMonth[$i];
                        ?>
                        <tr>
                            <td >
                                <?php echo $row->name; ?>
                            </td>
                            <td>
                               <?php echo $row->num_walks; ?>
                            </td>
                        </tr>
                        <?php
                    }
                    ?>
                </tbody>
            </table>

