<?php
/**
 * @version    CVS: 1.0.0
 * @package    Com_Mbwc
 * @author     Jeff Dun <jvevfvf+cc@gmail.com>
 * @copyright  2023 Jeff Dun
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */
// No direct access
defined('_JEXEC') or die;

use \Joomla\CMS\HTML\HTMLHelper;
use \Joomla\CMS\Factory;
use \Joomla\CMS\Uri\Uri;
use \Joomla\CMS\Router\Route;
use \Joomla\CMS\Language\Text;
use \MBWC\Component\MBWC\Site\Helper\MBWCHelper;

Factory::getDocument()->getWebAssetManager()->useScript('keepalive');

?>

<div id="eb-incident-report" class="eb-container row-fluid">
<h1 class="eb_title">Incident Report for event <?php echo $this->event->title?></h1>
<p>This email will be sent to secretary@mbwc.org.au, and cc'd to you as the leader.</p>
<p> <strong>Note: </strong>You can save your progress by pressing the "Save Progress" button, and return to this form by pressing "Incident Report" under the Actions Menu on the "My Submitted Events Page".</p>
<section>
   <div>
     <p>
<form action="<?php echo JRoute::_('index.php') ; ?>" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data" class="form form-horizontal">
	<table>
	    <tr>
	        <td>
	            Person involved in Incident:
	        </td>
	   <?php
		$db = Factory::getDBO();
		$query = "select ifnull(c.field_value,a.phone) mobphone,a.*,b.* from #__eb_registrants as a left join #__comprofiler as b on b.user_id=a.user_id left join jos_eb_field_values as c on c.registrant_id=a.id and c.field_id=21 where a.published=1 and a.is_group_billing=0 and a.event_id =" . $this->eventId . " order by a.id" ;
		$db->setQuery($query);

		$rows = $db->loadObjectList();

		?>
        <td>
		<select name="selectUser" class="form-select" id="selectUser" <?php if ($this->edit) echo "disabled"?> onchange="document.getElementById('person_phone').value=this.options[this.selectedIndex].getAttribute('data-phone');document.getElementById('person_email').value=this.options[this.selectedIndex].getAttribute('data-mail'); document.getElementById('address').value=this.options[this.selectedIndex].getAttribute('data-address'); document.getElementById('name').value=this.options[this.selectedIndex].value;"> 	
		<option value=""> Select Registrant</option>
		<?php
		foreach ($rows as $row) 
		{
		?>			
			<option value="<?php echo $row->first_name.' '.$row->last_name; ?>" data-phone="<?php echo $row->mobphone;?>" data-mail="<?php echo $row->email;?>" data-address="<?php echo $row->cb_address1.' '.$row->cb_suburbtown.' '.$row->cb_state.' '.$row->cb_postcode;?>"> <?php echo $row->first_name.' '.$row->last_name; ?> </option>	  
		<?php
		}
		?>
		</select>
			    <div class="form-text">Choose a registrant from the list to populate the name, phone number and email in the fields below.</div>
		</td>

	    </tr>
		<tr>
			<td style="vertical-align: middle;">
				Name of Person:	<span class="required">*</span>			
			</td>
		    <td>
			    <input  type="text" name="name" style="width:100%" id="name" class="form-control" value="<?php echo $this->incident->name?>" <?php if ($this->edit) echo "disabled"?>/>
			    <div class="form-text">Name of person who had the incident</div>
			</td>
		</tr><tr>
			<td style="vertical-align: middle;">
				Phone:	<span class="required">*</span>			
			</td>
		    <td>
			    <input  type="text" name="person_phone" style="width:100%" id="person_phone" value="<?php echo $this->incident->person_phone?>" class="form-control" <?php if ($this->edit) echo "disabled"?> onkeyup="this.value=this.value.replace(/[^0-9 +]+/,'')"/>
			    <div class="form-text">Phone number of person who had the incident</div>
			</td>
          </tr>
		<tr>			
			<td style="vertical-align: middle;">
				Person Email: 				
			</td>
			<td colspan=3>
			    <input  type="text" name="person_email" style="width:100%" id="person_email" class="form-control" value="<?php echo $this->incident->person_email?>" <?php if ($this->edit) echo "disabled"?>/>
			    <div class="form-text">If you enter this, the person will get a copy of the incident report</div>
			</td>
		</tr>
		<tr>			
			<td style="vertical-align: middle;">
				Date of Walk:<span class="required">*</span>				
			</td>
			<td colspan=3>
			    <input type="text" name="date" id="date" <?php if ($this->edit) echo "disabled"?> class="form-control" value="<?php echo $this->incident->date ?>" />
			</td>
		</tr>
		<tr>
		    <td>&nbsp;</td>
		</tr>
		<tr>
			<td style="vertical-align: middle;">
				Name of Leader:	<span class="required">*</span>			
			</td>
		    <td>
			    <input  type="text" name="leader_name" style="width:100%" id="leader_name" class="form-control" value="<?php echo $this->incident->leader_name ?>" <?php if ($this->edit) echo "disabled"?> />
			</td>
			</tr><tr>
			<td style="vertical-align: middle;">
				Phone:		<span class="required">*</span>		
			</td>
		    <td>
			    <input  type="text" name="leader_phone" style="width:100%" id="leader_phone" class="form-control" value="<?php echo $this->incident->leader_phone ?>" onkeyup="this.value=this.value.replace(/[^0-9 +]+/,'')" <?php if ($this->edit) echo "disabled"?>/>
			    <div class="form-text">Phone number of the leader</div>
			</td>
          </tr>
		<tr>			
			<td>
				Walk/Recce Location<span class="required">*</span>			
			</td>
			<td colspan="3">
			    <textarea style="width:100%" type="text" name="location" id="location" class="form-control" <?php if ($this->edit) echo "disabled"?>><?php echo $this->incident->location ?></textarea>
			    <div class="form-text">Include Map or Melway reference if available</div>
			</td>
		</tr>
		<tr>			
			<td>
				Conditions were?				
			</td>
			<td colspan="3">
			    <textarea style="width:100%" type="text" name="conditions" id="conditions" class="form-control" <?php if ($this->edit) echo "disabled"?>><?php echo $this->incident->conditions ?></textarea>
			</td>
		</tr>
		<tr>			
			<td>
				What Happened?				
			</td>
			<td colspan="3">
			    <textarea style="width:100%" type="text" name="what" id="what" class="form-control" <?php if ($this->edit) echo "disabled"?>><?php echo $this->incident->what ?></textarea>
			</td>
		</tr>
		<tr>			
			<td>
				Where?				
			</td>
			<td colspan="3">
			    <textarea style="width:100%" type="text" name="where_happened" id="where_happened" class="form-control" <?php if ($this->edit) echo "disabled"?>><?php echo $this->incident->where_happened ?></textarea>
			</td>
		</tr>
		<tr>			
			<td>
				Injury?				
			</td>
			<td colspan="3">
			    <textarea style="width:100%" type="text" name="injury" id="injury" class="form-control" <?php if ($this->edit) echo "disabled"?>><?php echo $this->incident->injury ?></textarea>
			</td>
		</tr>
		<tr>			
			<td>
				Treatment at Location?				
			</td>
			<td colspan="3">
			    <textarea style="width:100%" type="text" name="treatment" id="treatment" class="form-control" <?php if ($this->edit) echo "disabled"?>><?php echo $this->incident->treatment ?></textarea>
			</td>
		</tr>
		<tr>			
			<td>
				Were emergency services called?				
			</td>
			<td colspan="3">
                Yes <input type="radio" <?php if ($this->edit) echo "disabled"?> id="yes" name="emergency_called" value="1" onclick="document.getElementById('whoattended').disabled=false;" <?php if ($this->incident->emergency_called) echo "checked" ?>>
                No <input type="radio" <?php if ($this->edit) echo "disabled"?> id="no" name="emergency_called" value="0" onclick="document.getElementById('whoattended').disabled=true;" <?php if (!$this->incident->emergency_called) echo "checked" ?>>
			</td>
		</tr>
		<tr>			
			<td>
				If so, who attended?				
			</td>
			<td colspan="3">
			    <textarea style="width: 100%" type="text" name="whoattended" id="whoattended" <?php if (!$this->incident->emergency_called || $this->edit) echo "disabled" ?> class="form-control"><?php echo $this->incident->whoattended ?></textarea>
			</td>
		</tr>
		<tr>
		    <td>&nbsp;</td>
		</tr>
	    <tr>
	        <td>
	            Witness 1:
	        </td>
        <td>
		<select name="selectWitness1" id="selectWitness1" class="form-select" <?php if ($this->edit) echo "disabled"?> onchange="document.getElementById('witness1_phone').value=this.options[this.selectedIndex].getAttribute('data-phone'); document.getElementById('witness1_address').value=this.options[this.selectedIndex].getAttribute('data-address'); document.getElementById('witness1_name').value=this.options[this.selectedIndex].value;"> 	
		<option value=""> Select Registrant</option>
		<?php
		foreach ($rows as $row) 
		{
		?>			
			<option value="<?php echo $row->first_name.' '.$row->last_name; ?>" data-phone="<?php echo $row->mobphone;?>" data-address="<?php echo $row->cb_address1.' '.$row->cb_suburbtown.' '.$row->cb_state.' '.$row->cb_postcode;?>"> <?php echo $row->first_name.' '.$row->last_name; ?> </option>	  
		<?php
		}
		?>
		</select>
			    <div class="form-text">Choose a registrant from the list to populate the name and phone number in the fields below.</div>
		</td>
	    </tr>
		<tr>
			<td style="vertical-align: middle;">
				Witness 1 Name:		
			</td>
		    <td>
			    <input  type="text" style="width:100%" name="witness1_name" id="witness1_name" <?php if ($this->edit) echo "disabled"?> class="form-control" value="<?php echo $this->incident->witness1_name ?>"/>
			</td>
			</tr><tr>
			<td style="vertical-align: middle;">
				Phone:		
			</td>
		    <td>
			    <input  type="text" style="width:100%" name="witness1_phone" id="witness1_phone" value="<?php echo $this->incident->witness1_phone ?>" <?php if ($this->edit) echo "disabled"?> class="form-control" onkeyup="this.value=this.value.replace(/[^0-9 +]+/,'')"/>
			    <div class="form-text">Phone number of witness 1.</div>
			</td>
          </tr>
		<tr>
		    <td>&nbsp;</td>
		</tr>
	    <tr>
	        <td>
	            Witness 2:
	        </td>
        <td>
		<select name="selectWitness2" id="selectWitness2" class="form-select" <?php if ($this->edit) echo "disabled"?> onchange="document.getElementById('witness2_phone').value=this.options[this.selectedIndex].getAttribute('data-phone'); document.getElementById('witness2_address').value=this.options[this.selectedIndex].getAttribute('data-address'); document.getElementById('witness2_name').value=this.options[this.selectedIndex].value;"> 	
		<option value=""> Select Registrant</option>
		<?php
		foreach ($rows as $row) 
		{
		?>			
			<option value="<?php echo $row->first_name.' '.$row->last_name; ?>" data-phone="<?php echo $row->mobphone;?>" data-address="<?php echo $row->cb_address1.' '.$row->cb_suburbtown.' '.$row->cb_state.' '.$row->cb_postcode;?>"> <?php echo $row->first_name.' '.$row->last_name; ?> </option>	  
		<?php
		}
		?>
		</select>
			    <div class="form-text">Choose a registrant from the list to populate the name and phone number in the fields below.</div>
		</td>
	    </tr>
		<tr>
			<td style="vertical-align: middle;">
				Witness 2 Name:		
			</td>
		    <td>
			    <input  type="text" style="width:100%" name="witness2_name" id="witness2_name" <?php if ($this->edit) echo "disabled"?> class="form-control" value="<?php echo $this->incident->witness2_name ?>"/>
			</td>
			</tr><tr>
			<td style="vertical-align: middle;">
				Phone:		
			</td>
		    <td>
			    <input  type="text" style="width:100%" name="witness2_phone" id="witness2_phone" value="<?php echo $this->incident->witness2_phone ?>" <?php if ($this->edit) echo "disabled"?> class="form-control" onkeyup="this.value=this.value.replace(/[^0-9 +]+/,'')"/>
			    <div class="form-text">Phone number of witness 2.</div>
			</td>
          </tr>
		<tr>
		    <td>&nbsp;</td>
		</tr>
		
		<tr>			
			<td>
				Ongoing treatment required? (if known)		
			</td>
			<td colspan="3">
			    <textarea style="width:100%" type="text" name="treatment_required" id="treatment_required" class="form-control" <?php if ($this->edit) echo "disabled"?>><?php echo $this->incident->treatment_required ?></textarea>
			</td>
		</tr>
		<tr>			
			<td>
				Did this Incident/Accident result from a hazard?				
			</td>
			<td colspan="3">
                Yes <input type="radio" <?php if ($this->edit) echo "disabled"?> id="yes" name="hazard" value="1" <?php if ($this->incident->hazard) echo "checked" ?> onclick="document.getElementById('hazard_controlled').disabled=false;">
                No <input type="radio" <?php if ($this->edit) echo "disabled"?> id="no" name="hazard" value="0" <?php if (!$this->incident->hazard) echo "checked" ?> onclick="document.getElementById('hazard_controlled').disabled=true;">
			</td>
		</tr>
		<tr>			
			<td>
				If so, how could the hazard be controlled in the future?		
			</td>
			<td colspan="3">
			    <textarea style="width:100%" type="text" name="hazard_controlled" id="hazard_controlled" class="form-control" <?php if (!$this->incident->hazard || $this->edit) echo "disabled" ?>><?php echo $this->incident->hazard_controlled ?></textarea>
			</td>
		</tr>
		<?php if ($this->edit) { ?>
		<tr>
			<td style="vertical-align: middle;">
				Claim Number:		
			</td>
		    <td>
			    <input  type="text" name="claim_number" id="claim_number" onkeyup="document.getElementById('claim_lodged_date').disabled=!this.value;document.getElementById('claim_lodged_date_btn').disabled=!this.value;" class="form-control" value="<?php echo $this->incident->claim_number?>"/>
			</td>
        </tr>
		<tr>
			<td style="vertical-align: middle;">
				Claim Lodged Date:		
			</td>
		    <td>
			   <?php 
			   echo JHtml::_('calendar', (!$this->incident->claim_lodged_date || $this->incident->claim_lodged_date == $this->nullDate) ? '' : JHtml::_('date', $this->incident->claim_lodged_date, 'Y-m-d', null), 'claim_lodged_date', 'claim_lodged_date') ; ?>
			</td>
        </tr>
        <?php } ?>
	</table>
	    <script type="text/javascript">
         jQuery(document).ready(function () {
             <?php if (!$this->incident->claim_number && $this->edit) { ?>
               document.getElementById('claim_lodged_date').disabled=true;
               document.getElementById('claim_lodged_date_btn').disabled=true;
             <?php } ?>
         });
         </script>

			<script type="text/javascript">				
				function checkData() {
				    <?php if ($this->edit) { ?>
				      var task='save_incident_report';
				    <?php } else { ?>
				      var task='send_incident_report';
				    <?php } ?>
					var form = document.adminForm ;
					form.task=task;
					if (form.hazard.value == '1' && !form.hazard_controlled.value) {
						alert("Please enter details on how the hazard could be controlled in the future");
						form.hazard_controlled.focus();
						return ;
					}
					if (form.emergency_called.value == '1' && !form.whoattended.value) {
						alert("Please enter details on who attended the emergency");
						form.whoattended.focus();
						return ;
					}
                    if (form.name.value == '') {
 						alert("Please enter name of person who had the incident");
						form.name.focus();
						return ;
					}
                   if (form.person_phone.value == '') {
						alert("Please enter the phone number of the person who had the incident");
						form.person_phone.focus();
						return ;
					}
                    if (form.leader_name.value == '') {
						alert("Please enter the leaders name");
						form.leader_name.focus();
						return ;
					}
                    if (form.leader_phone.value == '') {
						alert("Please enter the leaders phone number");
						form.leader_phone.focus();
						return ;
					}
                    if (form.date.value == '') {
						alert("Please enter the event date");
						form.date.focus();
						return ;
					}
                    if (form.location.value == '') {
						alert("Please enter the event location");
						form.location.focus();
						return ;
					}
					if (form.person_email.value)
					{
            			var emailFilter = /^\w+[\+\.\w-]*@([\w-]+\.)*\w+[\w-]*\.([a-z]{2,4}|\d+)$/i
            			var ret = emailFilter.test(form.person_email.value);
            			if (!ret) {
            				alert('<?php echo  JText::_('EB_VALID_EMAIL'); ?>');
            				form.person_email.focus();
            				return;
            			}
					}
					
                    if (form.claim_number && form.claim_number.value && form.claim_lodged_date && form.claim_lodged_date.value=='') {
						alert("Please enter the claim lodged date");
						form.claim_lodged_date.focus();
						return ;
					}
					
					Joomla.submitform(task);
				}
					function saveData() {
					    Joomla.submitform('store_incident_report');
					}
				</script>
	<input type="hidden" name="witness1_address" id="witness1_address" value="<?php echo $this->incident->witness1_address?>">
	<input type="hidden" name="id" id="id" value="<?php echo $this->incident->id?>">
	<input type="hidden" name="witness2_address" id="witness2_address" value="<?php echo $this->incident->witness2_address?>">
	<input type="hidden" name="address" id="address" value="<?php echo $this->incident->address?>"/>
	<input type="hidden" name="event_id" id="event_id" value="<?php echo $this->eventId?>"/>
	<input type="hidden" name="option" value="com_mbwc" />	
	<input type="hidden" name="return" value="<?php echo $this->return?>" />	
	<input type="hidden" name="controller" value="incident" />	
	<input type="hidden" name="task" value="" />	
	<input type="hidden" name="Itemid" value="<?php echo $this->Itemid; ?>" />
	<input type="hidden" name="leader_email" value="<?php echo $this->emails; ?>" />
	<input type="button" class="btn btn-primary" name="btn-submit" id="btn-submit" value="<?php if ($this->edit) echo 'Save'; else echo 'Mail'?>" onclick="checkData();">
		<input type="button" name="btnSave" value="Cancel" onclick="window.history.back();" class="btn" />
	<?php if (!$this->edit) { ?>
	<input type="button" class="btn" name="btn-save" id="btn-save" value="Save Progress" onclick="saveData();">
	<?php } ?>
	<?php echo JHtml::_( 'form.token' ); ?>		
	
</form></p>
   </div>
</section>


</div>
