<?php
/**
 * @version    CVS: 1.0.0
 * @package    Com_Mbwc
 * @author     Jeff Dun <jvevfvf+cc@gmail.com>
 * @copyright  2023 Jeff Dun
 * @license    GNU General Public License version 2 or later; see LICENSE.txt
 */
// No direct access
defined('_JEXEC') or die;

use \Joomla\CMS\HTML\HTMLHelper;
use \Joomla\CMS\Factory;
use \Joomla\CMS\Uri\Uri;
use \Joomla\CMS\Router\Route;
use \Joomla\CMS\Language\Text;
use \Joomla\CMS\Layout\LayoutHelper;
use \Joomla\CMS\Session\Session;
use \Joomla\CMS\User\UserFactoryInterface;
$return=base64_encode(Uri::getInstance()->toString());

?>
<style>
    @media 
only screen and (max-width: 760px)  {

	/* Force table to not be like tables anymore */
	table.jdisplay, table.jdisplay thead, table.jdisplay tbody, table.jdisplay th, table.jdisplay td, table.jdisplay tr { 
		display: block; 
	}
	
	/* Hide table headers (but not display: none;, for accessibility) */
	table.jdisplay thead tr { 
		position: absolute;
		top: -9999px;
		left: -9999px;
	}
	
	table.jdisplay tr { border: 1px solid #ccc; }
	
	table.jdisplay td { 
		/* Behave  like a "row" */
		border: none;
		border-bottom: 1px solid #eee; 
		position: relative;
		padding-left: 50%; 
	}
	
	table.jdisplay td:before { 
		/* Now like a table header */
		position: absolute;
		/* Top/left values mimic padding */
		top: 6px;
		left: 6px;
		width: 45%; 
		padding-right: 10px; 
		white-space: nowrap;
		font-weight: bold;
	}
	/*
	Label the data
	*/
	table.jdisplay td:nth-of-type(1):before { content: "Incident Date:"; }
	table.jdisplay td:nth-of-type(2):before { content: "Location:"; }
	table.jdisplay td:nth-of-type(3):before { content: "Leader:"; }
	table.jdisplay td:nth-of-type(4):before { content: "Who:"; }
	table.jdisplay td:nth-of-type(5):before { content: "Injury:"; }
	table.jdisplay td:nth-of-type(6):before { content: "Submit Date:"; }
}
</style>
<h1 class="eb-page-heading">Incident Reports</h1>
<form method="post" name="adminForm" id="adminForm" action="<?php echo JRoute::_('index.php?option=com_mbwc&view=incidentreports&Itemid='.$this->Itemid); ?>">
	<?php
        if(count($this->items))
        {
            
          if (!$this->filter_event) {?>
		<table width="100%">
		<tr>
			<td align="left">
				<?php echo "Leader:";?>
				<select name="filter_leader" id="filter_leader" onchange="document.adminForm.submit();"> 	
		        <option value="">All</option>
        		<?php
        		foreach ($this->leaders as $row) 
        		{
        		?>			
        			<option value="<?php echo $row->leader_name;?>"<?php if ($this->filter_leader == $row->leader_name) echo " selected";?> > <?php  echo $row->leader_name; ?> </option>	  
        		<?php
        		}
        		?>
        		</select>

				<a class="btn btn-primary"  onclick="document.getElementById('filter_leader').value='';document.adminForm.submit();">Reset</a>		
			</td >	
		</tr>
	</table>	
	<?php } ?>
	<table class="table jdisplay table-bordered table-considered table-striped">
                <thead>
                    <tr>
                        <th>
                            Incident Date
                        </th>
                        <th>
                            Location
                        </th>
                        <th >
                            Leader
                        </th>
                        <th >
                            Who
                        </th>
                        <th >
                            Injury
                        </th>
                        <th>
                            Submit Date
                        </th>
                        <?php if (!$this->filter_event) { ?>
                        <th>
                            Claim Number
                        </th>
                        <th>
                            Claim Lodged Date
                        </th>
                        <th>
                            Cancelled
                        </th>
                        <th>
                             Reason
                        </th>
                        <th>
                            Actions
                        </th>
                        <?php } ?>
                    </tr>
                </thead>
                <tbody>
                    <?php
                    for ($i=0, $n=count( $this->items ); $i < $n; $i++)
                    {
                        $row = &$this->items[$i];
                        ?>
                        <tr>
                            <td >
                                <?php echo JHtml::_('date', $row->date, 'd-m-Y'); ?>
                            </td>
                            <td>
                                <?php
                                $link = JRoute::_('index.php?option=com_mbwc&view=incidentreport&id='.$row->id.'&return='.$return) ;
                                echo "<a href='".$link."'>".$row->location."</a>";      
                                ?>
                            </td>
                            <td>
                                <?php echo $row->leader_name ; ?>
                            </td>
                            <td >
                                <?php echo $row->name ; ?>
                            </td>
                            <td >
                                <?php echo $row->injury ; ?>
                            </td>
                            <td>
                                <?php echo JHtml::_('date', $row->submit_date, 'd-m-Y'); ?>
                            </td>
                       <?php if (!$this->filter_event) { ?>
                            <td >
                                <?php echo $row->claim_number ; ?>
                            </td>
                            <td >
                                <?php if ($row->claim_lodged_date && $row->claim_lodged_date != "0000-00-00 00:00:00") echo JHtml::_('date', $row->claim_lodged_date, 'd-m-Y'); ?>
                            </td>
                            <td >
                                <?php echo $row->cancelled ; ?>
                            </td>
                            <td >
                                <?php echo $row->reason ; ?>
                            </td>
                            <td>
                                <?php if (!$row->cancelled)  { ?>
                                 <a class="btn btn-primary" title="Cancel" href="javascript:cancelIncidentReport(<?php echo $row->id; ?>)"><?php echo 'Cancel' ; ?></a>
                                <?php } ?>
                            </td>
                        <?php } ?>
                        </tr>
                        <?php
                    }
                    ?>
                </tbody>
                <tfoot>
                    <tr>
                        <td colspan="6">
                            <?php echo $this->pagination->getPagesLinks(); ?>
                        </td>
                    </tr>
                </tfoot>
            </table>
        <input type="hidden" name="task" value="" />
         <input type="hidden" name="event_id" value="" />
         <input type="hidden" name="id" value="" />
         <input type="hidden" name="reason" value="" />
       <input type="hidden" name="Itemid" value="<?php echo $this->Itemid ; ?>" />
        <input type="hidden" name="option" value="com_mbwc" />
       <input type="hidden" name="return" value="<?php echo $return;?>" />

	<input type="hidden" name="controller" value="incident" />	
    <?php
    }
    ?>
</form>
<script language="javascript">
    function cancelIncidentReport(id) {
        var form = document.adminForm ;
        var pr = "";
        while (pr == "")
        {
          var pr = prompt("Please enter a Reason for cancelling this Incident Report. Press the cancel button to back out of this action.\n\nReason (Required):");
        }
        if (pr === null) {
            return false;
        }
        form.reason.value = pr;
        form.task.value = 'cancel_incident_report' ;
        form.id.value = id ;
        form.submit() ;
    }
</script>