<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined( '_JEXEC' ) or die ;
use Joomla\CMS\Editor\Editor;
use Joomla\CMS\Factory;
Factory::getDocument()->getWebAssetManager()->useScript('keepalive');

$user = Factory::getUser();
$editor = Editor::getInstance($user->getParam('editor', Factory::getConfig()->get('editor')));
require_once JPATH_ADMINISTRATOR . '/components/com_eventbooking/libraries/rad/bootstrap.php';
?>
<div id="eb-registrants-management-page" class="eb-container row-fluid">
<h1 class="eb_title">Mail Registrants for <?php echo $this->title?></h1>
<script type="text/javascript">
    		function goBack() {
			var form = document.adminForm ;
			if (form.return.value == 'event') {
				location.href = '<?php echo JRoute::_(\EventbookingHelperRoute::getEventRoute($this->eventId, 0, $this->Itemid)); ?>' ;
			}
			else if (form.return.value == 'events') {
				location.href = '<?php echo JRoute::_("index.php?option=com_eventbooking&view=events&Itemid=".$this->Itemid); ?>' ;
			} else {
				location.href = '<?php echo JRoute::_("index.php?option=com_eventbooking&view=registrantlist&id=".$this->eventId."&tmpl=component&waitlist=".$this->waitlist); ?>' ;
			}			
		}			
	function checkData() {
		var form = document.adminForm;
		if (form.subject.value == '') {
			alert("Please enter a Subject");
			form.subject.focus();
			return ;
		}				
		if (form.emails.value == '') {
			alert("Please enter emails in bcc field separated by a comma");
			form.emails.focus();
			return ;
		}
		form.submit();
	}
</script>
<section>
   <div>
     <p>
<form action="<?php JRoute::_('index.php?option=com_mbwc&Itemid='.$this->Itemid);?>" method="post" name="adminForm">
	<table width="100%">
		<tr>			
			<td>
				Mailto:				
			</td>
			<td>
			    <textarea rows=3 style="padding: 0; margin-bottom: 0;width: 540px" type="text" name="leader_email" id="leader_email" disabled class="input"><?php echo $this->leader_email ?></textarea>
		        
			</td>
			<td></td>
		</tr>
		<tr>
			<td>
				Bcc:				
			</td>
			<td>
			    <textarea rows=3 style="padding: 0; margin-bottom: 0;width: 540px" type="text" name="emails" id="emails" class="input"><?php echo implode(", ",$this->emails)?></textarea>
		        
			</td>
			<td>You can add or remove email addresses. Make sure all are comma separated. Don't add people here who are in the Mailto: section</td>
		</tr>
		<tr>			
			<td>
				Subject				
			</td>
			<td>
		        <input type="text" class="input-xxlarge" name="subject" id="subject" value="<?php echo $this->title." ".substr($this->event_date,0,10)?>" ><br>
			</td>
		</tr>
		<tr>			
			<td>
				Content				
			</td>
			<td colspan=2>
						<?php echo $editor->display( 'content',  $this->content , '100%', '250', '90', '10' ) ; ?>		
			</td>
		</tr>
	</table>
	<input type="button" value="Mail" onclick="checkData();" class="button btn btn-primary" />		
	<input type="hidden" name="Itemid" value="<?php echo $this->Itemid; ?>" />
	<input type="hidden" name="return" value="<?php echo $this->return; ?>" />
	<input type="hidden" name="waitlist" value="<?php echo $this->waitlist; ?>" />
	<input type="hidden" name="event_id" value="<?php echo $this->eventId; ?>" />
	<input type="hidden" name="controller" value="event" />
	<input type="hidden" name="task" value="send_registrants_mail" />
	<?php echo JHtml::_( 'form.token' ); ?>			
</form>
    <button class="btn" onclick="goBack();">Go Back</button>
</p>
   </div>
</section>


</div>
