<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Jeff Dun
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined( '_JEXEC' ) or die ;
use \Joomla\CMS\Factory;
use Joomla\CMS\Uri\Uri;

Factory::getDocument()->getWebAssetManager()->useScript('keepalive');
Factory::getDocument()->addScript(Uri::root(true) . '/media/com_eventbooking/assets/js/imask/imask.min.js');
?>
<script>
MBWCMaskInputs = function (form) {
    form.querySelectorAll('input[data-input-mask]').forEach(function (input) {
        var mask = input.dataset.inputMask;

        // Assume this is a regular expression
        if (mask.slice(0, 1) === '/' && mask.slice(-1) === '/') {
            mask = mask.slice(1); // Remove first character
            mask = mask.slice(0, -1); // Remove last character
            mask = new RegExp(mask);
        }

        var regExpMask = IMask(
            input,
            {
                mask: mask,
                lazy: false,
                placeholderChar: 'X',
                expose: true
            });
    });
    form.querySelectorAll('input[data-date-mask]').forEach(function (input) {
        var dateMask = IMask(input, {
          mask: Date,  // enable date mask
          placeholderChar: 'X',
          // other options are optional
          pattern: 'Y-`m-`d',  // Pattern mask with defined blocks, default is 'd{.}`m{.}`Y'
          // you can provide your own blocks definitions, default blocks for date mask are:
          blocks: {
            d: {
              mask: IMask.MaskedRange,
              from: 1,
              to: 31,
              maxLength: 2,
            },
            m: {
              mask: IMask.MaskedRange,
              from: 1,
              to: 12,
              maxLength: 2,
            },
            Y: {
              mask: IMask.MaskedRange,
              from: 1923,
              to: 2050,
            }
          },
          // define date -> str convertion
          format: function (date) {
            var day = date.getDate();
            var month = date.getMonth() + 1;
            var year = date.getFullYear();
        
            if (day < 10) day = "0" + day;
            if (month < 10) month = "0" + month;
        
            return [year, month, day].join('-');
          },
          // define str -> date convertion
          parse: function (str) {
            var yearMonthDay = str.split('-');
            return new Date(yearMonthDay[0], yearMonthDay[1] - 1, yearMonthDay[2]);
          },
        
           autofix: true,  // defaults to `false`, see details
        
          // pattern options can be set as well
          lazy: false,
        
          // and other common options
          overwrite: true  // defaults to `false`
        });
    });
}
window.onload = function(){
   MBWCMaskInputs(document.getElementById('adminForm'));
};

</script>
<div id="eb-membership" class="eb-container row-fluid">
<h1 align=center class="eb_title">MEMBERSHIP APPLICATION</h1>
<p  align=center>Please fill in all fields, and press the "Submit" button.</p><p  align=center> We will contact you on receipt of your membership application,</br> and advise you of the amount you need to pay for the current financial year plus the best method to pay the fees.</p>
<section>
<form action="<?php echo JRoute::_('index.php'); ?>" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data" class="form form-horizontal">
	<table style="margin-left: auto; margin-right: auto;">
		<tr>			
			<td>
				<b>First Name:</b><span class="required">*</span>			
			</td>
			<td>
				<input type="text" class="form-control" value="<?php echo $this->membership->first_name?>" size="50" name="first_name" />
			</td>
		</tr>
		<tr>
			<td>
				<b>Last Name:</b><span class="required">*</span>			
			</td>
			<td>
				<input type="text" class="form-control" value="<?php echo $this->membership->last_name?>" size="50" name="last_name" />
			</td>
		</tr>
		<tr>			
			<td>
				<b>Gender:</b><span class="required">*</span>			
			</td>
			<td>
				<input type="text" class="form-control" size="50" name="gender"  value="<?php echo $this->membership->gender?>"/>
			</td>
			</tr><tr>
			<td>
				<b>Date of Birth:</b><span class="required">*</span>			
			</td>
			<td>
				<input type="text" class="form-control" value="<?php echo $this->membership->dob?>" size="50" name="dob" data-date-mask id="dob"/>
				<div class="form-text">e.g. 1967-03-04 = 3rd March 1967</div>
			</td>
		</tr>
		<tr>			
			<td>
				<b>Email:</b><span class="required">*</span>			
			</td>
			<td>
				<input type="text" class="form-control" value="<?php echo $this->membership->email?>" size="50" name="email" />
			</td>
		</tr>
		<tr>			
			<td>
				<b>Street Address:</b><span class="required">*</span>			
			</td>
			<td>
				<input type="text" class="form-control" size="50" name="address" value="<?php echo $this->membership->address?>"/>
			</td>
		</tr>
		<tr>			
			<td>
				<b>Suburb/Town:</b><span class="required">*</span>			
			</td>
			<td>
				<input type="text" class="form-control" size="50" name="suburb" value="<?php echo $this->membership->suburb?>"/>
			</td>
			</tr><tr>
			<td>
				<b>Postcode:</b><span class="required">*</span>			
			</td>
			<td>
				<input type="text" class="form-control" data-input-mask="0000" size="50" name="postcode" id="postcode" value="<?php echo $this->membership->postcode?>"/>
			</td>
		</tr>
		<tr>
			<td>
				<b>Mobile Phone:</b>	
			</td>
			<td>
				<input id="mobile_phone" type="text" class="form-control" size="50" name="mobile_phone" autocomplete="mobile tel" data-input-mask="\0\400 000 000" title="mobile phone number like 04xx xxx xxx" value="<?php echo $this->membership->mobile_phone?>"/>
				<div class="form-text">Enter a mobile phone number like 04XX XXX XXX</div>
			</td>
			</tr><tr>
			<td>
				<b>Home Phone:</b>	
			</td>
			<td>
				<input type="text" class="form-control" size="50" name="home_phone" id="home_phone" autocomplete="home tel" data-input-mask="[00] `0000 0000" value="<?php echo $this->membership->home_phone?>"/>
				<div class="form-text">Press backspace at the start of the field if you want to enter area code</div>
			</td>
		</tr>
		<tr>			
			<th>
				Emergency Contact or Next of Kin Name:<span class="required">*</span>			
			</th>
			<td>
				<input type="text" class="form-control" size="50" name="kin_name" value="<?php echo $this->membership->kin_name?>"/>
			</td>
		</tr>
		<tr>			
			<th>
				Emergency Contact or Next of Kin Relationship:<span class="required">*</span>			
			</th>
			<td>
				<input type="text" class="form-control" size="50" name="kin_relationship" value="<?php echo $this->membership->kin_relationship?>"/>
			</td>
		</tr>
			<tr>
			<th>
				Emergency Contact or Next of Kin Mobile Phone Number:			
			</th>
			<td>
				<input id="kin_mobile_phone" type="text" class="form-control" value="<?php echo $this->membership->kin_mobile_phone?>" size="50" name="kin_mobile_phone" autocomplete="mobile tel" data-input-mask="\0\400 000 000" title="mobile phone number like 04xx xxx xxx" />
				<div class="form-text">Enter a mobile phone number like 04XX XXX XXX</div>
			</td>
		</tr>
		<tr>			
			<th>
				Emergency Contact or Next of Kin Home Phone Number:
			</th>
			<td>
				<input type="tel" class="form-control" value="" size="50" name="kin_home_phone" id="kin_home_phone" data-input-mask="[00] `0000 0000" value="<?php echo $this->membership->kin_home_phone?>"/>
				<div class="form-text">Press backspace at the start of the field if you want to enter area code</div>
			</td>
		</tr>
		<tr>			
			<th>
				Emergency Contact or Next of Kin 2 Name:			
			</th>
			<td>
				<input type="text" class="form-control" value="<?php echo $this->membership->kin_name_2?>" size="50" name="kin_name_2" />
			</td>
		</tr>
		<tr>			
			<th>
				Emergency Contact or Next of Kin 2 Relationship:			
			</th>
			<td>
				<input type="text" class="form-control" value="<?php echo $this->membership->kin_relationship_2?>" size="50" name="kin_relationship_2" />
			</td>
		</tr>
			<tr>
			<th>
				Emergency Contact or Next of Kin 2 Mobile Phone Number:			
			</th>
			<td>
				<input id="kin_mobile_phone_2" type="text" class="form-control" size="50" name="kin_mobile_phone_2" autocomplete="mobile tel" data-input-mask="\0\400 000 000" title="mobile phone number like 04xx xxx xxx" value="<?php echo $this->membership->kin_mobile_phone_2?>"/>
				<div class="form-text">Enter a mobile phone number like 04XX XXX XXX</div>
			</td>
		</tr>
		<tr>			
			<th>
				Emergency Contact or Next of Kin 2 Home Phone Number:			
			</th>
			<td>
				<input type="tel" class="form-control" value="<?php echo $this->membership->kin_home_phone_2?>" size="50" name="kin_home_phone_2" id="kin_home_phone_2" data-input-mask="[00] `0000 0000"/>
				<div class="form-text">Press backspace at the start of the field if you want to enter area code</div>
			</td>
		</tr>		
		</table>
        <?php 
	    $db = JFactory::getDbo();
        $sql="select a.*, concat_ws(',',
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id3')))) as leader_name from #__eb_events as a 
		where a.id=".$this->membership->event_id1;
	    $db->setQuery($sql);
	    $event1 = $db->loadObject();
        $sql="select a.*, concat_ws(',',
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id3')))) as leader_name from #__eb_events as a  
		where a.id=".$this->membership->event_id2;
	    $db->setQuery($sql);
	    $event2 = $db->loadObject();
	    ?>
		<h3 align=center>Details of Qualifying Activities</h2>
	    <p align=center>To continue undertaking club activities,<br> you must apply for membership once you have completed a minimum of <b>two (2)</b> and a maximum of <b>three (3)</b> activities in any <b>twelve (12)</b> month period.</p>
        <table class="table table-striped" border=1 style="margin-left: auto; margin-right: auto;">
            <tr>
                <th>#</th>
                <th>Qualifying Activity</th>
                <th>Leader Name</th>
                <th>Date of Activity</th>
            </tr>
            <tr>
                <td>1</td>
                <td><?php echo $event1->title;?></td>
                <td><?php echo $event1->leader_name;?></td>
                <td><?php echo JHtml::_('date', $event1->event_date, $this->config->event_date_format, null);?></td>
            </tr>
            <tr>
                <td>2</td>
                <td><?php echo $event2->title;?></td>
                <td><?php echo $event2->leader_name;?></td>
                <td><?php echo JHtml::_('date', $event2->event_date, $this->config->event_date_format, null);?></td>
            </tr>
        </table>
<h3 align=center class="eb_title">MEMBERSHIP TYPE</h1>
		<table class="table table-striped" style="margin-left: auto; margin-right: auto;" border=1>
		<tr>
		    <th>Choose</th>
		    <th>Membership Type</th>
		    <th class="text-center">Yearly Subscription</th>
		</tr>
		<tr>
		    <td><input type="radio" id="membership_type" name="membership_type" value="Adult" <?php if ($this->membership->membership_type=='Adult') echo 'checked';?>></td>
		    <td align=left>Adult</td>
		    <td align=center><?php echo "$ ".number_format($this->prices['Adult'],2) ?></td>
		</tr>
		<tr>
		    <td><input type="radio" id="membership_type" name="membership_type" value="Adult Concession" <?php if ($this->membership->membership_type=='Adult Concession') echo 'checked';?>></td>
		    <td align=left>Adult Concession</td>
		    <td align=center><?php echo "$ ".number_format($this->prices['Adult Concession'],2) ?></td>
		</tr>
		<tr><td></td><td colspan=2>
			<div class="form-text">Concession Membership requires provision of a current Centrelink Pensioner/Unemployment Benefits card.</div>
		</td></tr>
		<tr>
		    <td><input type="radio" id="membership_type" name="membership_type" value="Family" <?php if ($this->membership->membership_type=='Family') echo 'checked';?>></td>
		    <td align=left>Family</td>
		    <td align=center><?php echo "$ ".number_format($this->prices['Family'],2) ?></td>
		</tr>
		<tr><td></td><td colspan=2>
				<div class="form-text">Family membership includes 1 or 2 adults with or without children under 18 years or full-time students ALL living at the same address.</div>
		</td></tr>
		<tr>
		    <td><input type="radio" id="membership_type" name="membership_type" value="Family Concession" <?php if ($this->membership->membership_type=='Family Concession') echo 'checked';?>></td>
		    <td align=left>Family Concession</td>
		    <td align=center><?php echo "$ ".number_format($this->prices['Family Concession'],2) ?></td>
		</tr>
		<tr><td></td><td colspan=2>
				<div class="form-text">Family Concession membership requires each adult to provide a current Centrelink Pensioner / Unemployment Benefits card member.</div>
		</td></tr>
		<tr>
		    <td><input type="radio" id="membership_type" name="membership_type" value="Student" <?php if ($this->membership->membership_type=='Student') echo 'checked';?>></td>
		    <td align=left>Student</td>
		    <td align=center><?php echo "$ ".number_format($this->prices['Student'],2) ?></td>
		</tr>
		<tr>
		    <td></td><td>Concession Number:</td><td><input type="text" class="form-control" value="<?php echo $this->membership->concession_number?>" size="50" name="concession_number" />
</td>
		</tr>
		</table>
<h3 align=center class="eb_title">OPTIONAL EXTRAS</h1>
		<table class="table table-striped" style="margin-left: auto; margin-right: auto;" border=1>
		<tr>
		    <th>Choose</th>
		    <th>Extra</th>
		    <th>Cost</th>
		    <th></th>
		</tr>
		<tr>
		    <td><input type="hidden" name="name_pin" value="0" /><input class="form-check-input" type="checkbox" id="name_pin" name="name_pin" value="1" onclick="if (this.checked) document.getElementById('name_magnet').checked=false;" <?php if ($this->membership->name_pin) echo 'checked';?>></td>
            <td>Name Badge with Pin</td>
            <td>$ 8.50</td>
            <td rowspan=2><img width=150px src="/images/badge.png"></td>
	    </tr>
		<tr>
		    <td><input type="hidden" name="name_magnet" value="0" /><input class="form-check-input" type="checkbox" id="name_magnet" value="1" name="name_magnet" onclick="if (this.checked) document.getElementById('name_pin').checked=false;" <?php if ($this->membership->name_magnet) echo 'checked';?>></td>
            <td>Name Badge with Magnet</td>
            <td>$ 9.50</td>
            <td></td>
	    </tr>
	    </table>
		<h2 align=center>How did you find out about the Maroondah Bushwalking Club Inc?</h2>
		
		<table style="margin-left: auto; margin-right: auto;">
		<tr>
		    <td><input type="hidden" name="find_out_friend" value="0" /><input class="form-check-input" type="checkbox" id="find_out_friend" name="find_out_friend" value="1" <?php if ($this->membership->find_out_friend) echo 'checked';?>></td>
		    <td>Friend&nbsp;</td>
		    <td></td>
		    <td><input type="hidden" name="find_out_web" value="0" /><input class="form-check-input" type="checkbox" id="find_out_web" name="find_out_web" value="1" <?php if ($this->membership->find_out_web) echo 'checked';?>></td>
		    <td>Webpage&nbsp;</td>
		    <td></td>
		    <td><input type="hidden" name="find_out_facebook" value="0" /><input class="form-check-input" type="checkbox" id="find_out_facebook" name="find_out_facebook" value="1" <?php if ($this->membership->find_out_facebook) echo 'checked';?>></td>
		    <td>Facebook&nbsp;</td>
		    <td></td>
		    <td><input type="hidden" name="find_out_other_check" value="0" /><input class="form-check-input" type="checkbox" id="find_out_other_check" name="find_out_other_check" <?php if ($this->membership->find_out_other) echo 'checked';?>></td>
		    <td>Other&nbsp;</td>
		    <td>
				<input type="text" style="border: 3px solid #ccc" class="form-control" value="<?php echo $this->membership->find_out_other?>" size="50" name="find_out_other" onkeyup="document.getElementById('find_out_other_check').checked=this.value "/></td>
		</tr>
		</table>
		<h2 align=center>Please indicate if you have any of the following accreditation or training:</h2>
		
		<table style="margin-left: auto; margin-right: auto;">
		<tr>
		    <td><input type="hidden" name="first_aid" value="0" /><input class="form-check-input" type="checkbox" id="first_aid" name="first_aid" value="1" <?php if ($this->membership->first_aid) echo 'checked';?>></td>
		    <td>First Aid&nbsp;</td>
		    <td><input type="hidden" name="leader" value="0" /><input class="form-check-input" type="checkbox" id="leader" name="leader" value="1" <?php if ($this->membership->leader) echo 'checked';?>></td>
		    <td>Leader&nbsp;</td>
		    <td><input type="hidden" name="navigation" value="0" /><input class="form-check-input" type="checkbox" id="navigation" name="navigation" value="1" <?php if ($this->membership->navigation) echo 'checked';?>></td>
		    <td>Navigation&nbsp;</td>
		    <td><input type="hidden" name="search_rescue" value="0" /><input class="form-check-input" type="checkbox" id="search_rescue" name="search_rescue" value="1" <?php if ($this->membership->search_rescue) echo 'checked';?>></td>
		    <td>Search & rescue</td>
		</tr>
        </table>
		<h2 align=center>Please indicate if you have any special skills that you may be able to assist the club with:</h2>
		<table style="margin-left: auto; margin-right: auto;">
		<tr>
		    <td><input type="hidden" name="computer" value="0" /><input class="form-check-input" type="checkbox" id="computer" name="computer" value="1" <?php if ($this->membership->computer) echo 'checked';?>></td>
		    <td>Computer&nbsp;</td>
		    <td></td>
		    <td><input type="hidden" name="financial" value="0" /><input class="form-check-input" type="checkbox" id="financial" name="financial" value="1" <?php if ($this->membership->financial) echo 'checked';?>></td>
		    <td>Financial&nbsp;</td>
		    <td></td>
		    <td><input type="hidden" name="administrative" value="0" /><input class="form-check-input" type="checkbox" id="administrative" name="administrative" value="1" <?php if ($this->membership->administrative) echo 'checked';?>></td>
		    <td>Administrative&nbsp;</td>
		    <td></td>
		    <td><input type="hidden" name="skill_other_check" value="0" /><input class="form-check-input" type="checkbox" id="skill_other_check" name="skill_other_check" <?php if ($this->membership->skill_other) echo 'checked';?>></td>
		    <td>Other&nbsp;</td>
		    <td>
				<input type="text" style="border: 3px solid #ccc" class="form-control" value="<?php echo $this->membership->skill_other?>" size="50" name="skill_other" onkeyup="document.getElementById('skill_other_check').checked=this.value "/></td>
		</tr>
		</table>
		<?php if (!$this->edit) { ?>
		<table>
		<tr>
		  <td colspan=3>
In voluntarily participating in activities organised by the Maroondah Bushwalking Club Inc (the Club), described to me by the Club’s activity leaders, I am aware that my participation in these activities may expose me to risks that could lead to injury, property loss or damage. These risks include (<i>but are not limited to</i>) slippery or uneven surfaces, loose rocks, sunburn, pits/trenches and hyperthermia.<br><br>
To minimise these risks during activities I will:
<ol>
<li>Ensure activities are within my capabilities.</li>
<li>Carry snacks, lunch, 1 litre water (more in hot weather), sunscreen, personal medication & first
aid kit, wear protective clothing and appropriate equipment, wear strong walking boots.</li>
<li>Inform the activity leader if I am taking medication or have physical or other limitations that might affect
my participation.</li>
<li>Make every effort to ensure that I will remain with the rest of the party during the activity.</li>
<li>Accept & follow instructions given by the activity leader.</li>
<li>Carry the club's Personal Emergency Information Form (M6) detailing any critical medical information
and emergency contacts.</li>
</ol>
<p><b>NOTE: Bushwalking Victoria strongly recommends that all members take out personal ambulance cover with
Ambulance Victoria.	</b></p>
</td></tr>
		  <tr><td>&nbsp;</td>
		  </tr>	
<tr><td>
I have read and understood these requirements and risks. I still wish to join and participate in Club activities and accept that in checking the box below I take responsibility for my actions.
		  </td>
		  </tr>		
		  <tr>
		      		  <td>
				<input type="checkbox" class="form-check-input" value=""  name="acknowledgement" /><span class="required">*</span>
<b>Acknowledgement of Risks and Requirements</b>

		  </td>

		  </tr>
		  </table>
<?php } ?>
		<?php if (!$this->edit) { ?>
		  <table>
		  <tr>
			<td>
				Verification Code<span class="required">*</span>
			</td>
		      <td>
		        <input type="text" class="form-control" value="" size="50" name="security_code" />
				<img src="<?php echo JRoute::_('index.php?option=com_mbwc&task=show_captcha_image'); ?>" align="middle" id="captcha_image" />
				<a href="javascript:reloadCaptcha();"><strong>Reload</strong></a>
		      </td>
		  </tr>
		  </table>
        <?php } ?>
		<?php if ($this->edit) { ?>
		<table>
		<tr>
			<td style="vertical-align: middle;">
				User ID:		
			</td>
		    <td>
			    <?php echo $this->membership->user_id?>
			</td>
        </tr>
		<tr>
			<td style="vertical-align: middle;">
				Amount Paid:		
			</td>
		    <td>
			    <input type="text" class="form-control" name="amount_paid" id="amount_paid" value="<?php echo $this->membership->amount_paid?>"/>
			</td>
        </tr>
		<tr>
			<td style="vertical-align: middle;">
				Payment Received:		
			</td>
		    <td>
			   <?php 
			   echo JHtml::_('calendar', (!$this->membership->payment_received || $this->membership->payment_received == $this->nullDate) ? '' : JHtml::_('date', $this->membership->payment_received, 'Y-m-d', null), 'payment_received', 'payment_received') ; ?>
			</td>
        </tr>
		<tr>
			<td style="vertical-align: middle;">
				Payment Type:		
			</td>
		    <td>
			    <input type="hidden" name="paypal" value="0" /><input class="form-check-input" type="checkbox" id="paypal" value="checked" onclick="if (this.checked) document.getElementById('direct_credit').checked=false; " name="paypal" <?php if ($this->membership->paypal) echo 'checked';?>>&nbsp;Paypal&nbsp;
			    <input type="hidden" name="direct_credit" value="0" /><input class="form-check-input" type="checkbox" id="direct_credit" value="checked" onclick="if (this.checked) document.getElementById('paypal').checked=false; " name="direct_credit" <?php if ($this->membership->direct_credit) echo 'checked';?>>&nbsp;Direct Credit
			</td>
        </tr>
 		<tr>
			<td style="vertical-align: middle;">
				Committee Approved Date:		
			</td>
		    <td>
			   <?php 
			   echo JHtml::_('calendar', (!$this->membership->committee_approved || $this->membership->committee_approved == $this->nullDate) ? '' : JHtml::_('date', $this->membership->committee_approved, 'Y-m-d', null), 'committee_approved', 'committee_approved') ; ?>
			</td>
</tr>       		    
		<tr>
			<td style="vertical-align: middle;">
				Status:		
			</td>
		    <td>
			    <input class="form-control" type="text" name="status" id="status" value="<?php echo $this->membership->status?>"/>
			</td>
			<td>0 = normal, 1 = defered, 2 = rejected</td>
        </tr>
 		<tr>
			<td style="vertical-align: middle;">
				Defer Date:		
			</td>
		    <td>
			   <?php 
			   echo JHtml::_('calendar', (!$this->membership->defer_date || $this->membership->defer_date == $this->nullDate) ? '' : JHtml::_('date', $this->membership->defer_date, 'Y-m-d', null), 'defer_date', 'defer_date') ; ?>
			</td>
</tr>
 		<tr>
			<td style="vertical-align: middle;">
				Defer Reason:		
			</td>
		    <td>
			    <textarea style="padding: 0; margin-bottom: 0;width: 500px" type="text" name="defer_reason" id="defer_reason" class="form-control"><?php echo $this->membership->defer_reason;?></textarea>
			</td>
</tr>

 		<tr>
			<td style="vertical-align: middle;">
				Reject Date:		
			</td>
		    <td>
			   <?php 
			   echo JHtml::_('calendar', (!$this->membership->reject_date || $this->membership->reject_date == $this->nullDate) ? '' : JHtml::_('date', $this->membership->reject_date, 'Y-m-d', null), 'defer_date', 'reject_date') ; ?>
			</td>
</tr>       		    
 		<tr>
			<td style="vertical-align: middle;">
				Reject Reason:		
			</td>
		    <td>
			    <textarea class="form-control" style="padding: 0; margin-bottom: 0;width: 500px" type="text" name="reject_reason" id="reject_reason" class="input"><?php echo $this->membership->reject_reason;?></textarea>
			</td>
</tr>

        <?php } ?>
	</table>
			<script type="text/javascript">				
        		function reloadCaptcha() {									
        			document.getElementById('captcha_image').src = 'index.php?option=com_mbwc&task=show_captcha_image&ran=' + Math.random();			
        		}	
				function checkData() {
					var form = document.adminForm ;
        			if (form.security_code.value == "") {
        				alert("security code is required");
        				form.security_code.focus();
        				return false;
        			}						
        			if (!form.acknowledgement.checked) {
        				alert("Acknowledgement of risks is required");
        				form.acknowledgement.focus();
        				return false;
        			}						
        			if (form.first_name.value == "") {
        				alert("First Name is required");
        				form.first_name.focus();
        				return false;
        			}						
        			if (form.last_name.value == "") {
        				alert("Last Name is required");
        				form.last_name.focus();
        				return false;
        			}						
        			//if (form.dob.value == "" || form.dob.value=="0000-00-00") {
        			//	alert("Date of Birth is required");
        			//	form.dob.focus();
        			//	return false;
        			//}						
        			if (form.gender.value == "") {
        				alert("Gender is required");
        				form.gender.focus();
        				return false;
        			}						
        			if (form.address.value == "") {
        				alert("Street Address is required");
        				form.address.focus();
        				return false;
        			}						
        			if (form.postcode.value == "") {
        				alert("Postcode is required");
        				form.postcode.focus();
        				return false;
        			}						
        			if (form.suburb.value == "") {
        				alert("Suburb is required");
        				form.suburb.focus();
        				return false;
        			}						
        			if (form.home_phone.value == "" && form.mobile_phone.value == "") {
        				alert("Either Mobile Phone or Home Phone required. (Mobile prefered)");
        				form.mobile_phone.focus();
        				return;
        			}
        			var checked_membershiptype=document.querySelector('input[name="membership_type"]:checked');
        			if (!checked_membershiptype) {
        				alert("Please choose a Membership Type");
        				form.membership_type.focus();
        				return;
        			}
        			var emailFilter = /^\w+[\+\.\w-]*@([\w-]+\.)*\w+[\w-]*\.([a-z]{2,4}|\d+)$/i
        			var ret = emailFilter.test(form.email.value);
        			if (!ret) {
        				alert('<?php echo  JText::_('EB_VALID_EMAIL'); ?>');
        				form.email.focus();
        				return;
        			}
        			if (form.membership_type.value.includes('Concession') && form.concession_number.value == '')
        			{
        				alert("Please enter concession number");
        				form.concession_number.focus();
        				return;
        			}
        			if (form.kin_name.value == "") {
        				alert("Next of Kin Name is required");
        				form.kin.focus();
        				return false;
        			}						
        			if (form.kin_relationship.value == "") {
        				alert("Next of Kin Relationship is required");
        				form.relationship.focus();
        				return false;
        			}						
        			if (form.kin_mobile_phone.value == "" && form.kin_home_phone.value == "") {
        				alert("Either Next of Kin Mobile Phone or Next of Kin Home Phone required. (Mobile prefered)");
        				form.kin_mobile_phone.focus();
        				return false;
        			}						
					form.submit();
				}
				</script>
		<?php if ($this->edit) { ?>
				<input class="form-check-input" type="checkbox" name="acknowledgement" checked style="display:none"/>
				<input type="hidden" name="security_code" value="1" />
				<input type="hidden" name="id" value="<?php echo $this->membership->id?>" />
				<input type="hidden" name="submit_date" value="<?php echo $this->membership->submit_date?>" />
		<?php } ?>

	<input type="hidden" name="option" value="com_mbwc" />	
	<input type="hidden" name="controller" value="membership" />	
	<input type="hidden" name="task" value="<?php if ($this->edit) echo 'save_membership'; else echo 'send_membership'?>" />	
	<input type="hidden" name="event_id1" value="<?php echo $this->membership->event_id1?>" />	
	<input type="hidden" name="event_id2" value="<?php echo $this->membership->event_id2?>" />	
	<input type="hidden" name="Itemid" value="<?php echo $this->Itemid; ?>" />
	<input type="button" class="btn btn-primary" name="btn-submit" id="btn-submit" value="<?php if ($this->edit) echo 'Save'; else echo 'Submit'?>" onclick="checkData();">
		<input type="button" name="btnSave" value="Cancel" onclick="window.history.back();" class="btn" />
	<?php echo JHtml::_( 'form.token' ); ?>		
	
</form>
 </section>
     <table height=250px><tr><td>&nbsp;</td></tr></table>

</div>
