<?php
/**
 * @version		1.6.3
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 - 2013 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
use Joomla\CMS\Editor\Editor;
use Joomla\CMS\Factory;
Factory::getDocument()->getWebAssetManager()->useScript('keepalive');

defined( '_JEXEC' ) or die ;
$editor = Editor::getInstance(Factory::getApplication()->get('editor', 'none'));
?>
<div id="eb-trip-report" class="eb-container row-fluid">
		<?php if ($this->multi) { ?>
<h1 class="eb_title">Basecamp Trip Report</h1>
    <div class="alert alert-info"><a style="font-size: 1rem" href="images/How%20To/Basecamp Trip Report Help.pdf">Help on this page</a></div>
<?php } else { ?>
<h1 class="eb_title">Trip Report</h1>
<?php } ?>
<p style="color:red">If your walk was cancelled, <b>DO NOT USE THIS FORM</b>. On the event page, select Cancel Event under the Leaders button. On the "My Submitted Events" page, select Cancel Event under the Actions button.</p>
<p>Please <b>review</b> and <b>update</b> any fields to reflect the actual walk. Important fields are <b>Actual Distance</b>, and Number of Participants. Please also check all visitor details.</p>
<p>This email will be sent to tripreports@mbwc.org.au, and cc'd to you as the leader.</p>
<section>
   <div>
     <p>
<form action="<?php JRoute::_('index.php');?>" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data" class="form form-horizontal">
	<table>
		<tr>			
			<th style="vertical-align: middle;">
				Activity:				
			</th>
			<td colspan="<?php if ($this->multi) echo 1; else echo 3; ?>">
			    <?php echo $this->event->title ?>
			</td>
			</tr>
		<?php if ($this->multi) { ?>
		<tr>
			<th style="vertical-align: middle;">
				Event Name:	<span class="required">*</span>			
			</th>
		    <td colspan="3">
			    <input type="text" name="event_name" id="event_name" class="form-control" style="width:100%" />
			    <div class="form-text">Enter the name of the event</div>
			</td>
        </tr>
		<?php  } ?>
		<tr>
			<th style="vertical-align: middle;">
				Grade:		<span class="required">*</span>		
			</th>
			<td >
			    <?php 
			    if ($this->multi) {
			        echo $this->lists['category_id'] ;
			    }
			    else
			    {
			      echo $this->category;
			    }
			    if ($this->multi) { ?>
			    <div class="form-text">Enter the category of the event</div>
			    <?php } ?>
			</td>
		</tr>
		<tr>		
			<th style="vertical-align: middle;">
				Start Date:	<span class="required">*</span>			
			</th>
			<td>
			    <?php 
			    if (!$this->multi) {
			      echo JHtml::_('date', $this->event->event_date, $this->config->event_date_format, null);
			    }
			    else
			    {
			      echo JHtml::_('calendar', (!$this->event->event_date) ? '' : JHtml::_('date', $this->event->event_date, "%Y-%m-%d", null), 'event_date', 'event_date',"%Y-%m-%d"); 
				  echo '</td></tr><tr><th style="vertical-align: middle;" >&nbsp;Start Time: <span class="required">*</span></th><td>' . $this->lists['event_date_hour'].' '.$this->lists['event_date_minute']; 
				}
				if ($this->multi) { ?>
			    <div class="form-text">Enter the date of the event</div>
			    <?php } ?>
			</td>
			</tr>
			    <?php 
			    if ($this->multi) {
			    ?>
			<tr>
		
			<th style="vertical-align: middle;">
				End Time:	<span class="required">*</span>			
			</th>
			<td>
				<?php echo $this->lists['event_end_date_hour'].' '.$this->lists['event_end_date_minute']; 	?>
			    <div class="form-text">Enter the end time of the event</div>

			</td>
		</tr>
        <?php
			    }
		?>
		<tr>
			<th style="vertical-align: middle;">
				Leader:	<span class="required">*</span>	
			</th>
		    <td colspan="3">
		    <?php if (!$this->multi) { echo $this->leader_name; } else { ?>
                		<select name="leader_id" id="leader_id" class="form-select"> 	
		<option></option>
                		<?php
                		foreach ($this->users as $row) 
                		{
                		?>			
                			<option value="<?php echo $row->id; ?>" > <?php echo $row->name; ?> </option>	  
                		<?php
                		}
                		?>
                		</select>		    <?php } ?>
			</td>
			<td></td><td></td>
		<tr>
		    <?php if (!$this->multi) { ?>
			<th style="vertical-align: middle;">
				Listed Distance (kms):				
			</th>
		    <td>
			    <?php echo $this->distance ?>
			</td>
		    <?php } ?>
		</tr>
		    <tr>
			<th style="vertical-align: middle;">
				<b>Actual (kms):</b>	<span class="required">*</span>			
			</th>
		    <td style="align: left;">
			    <input style="width:100%" onClick="this.setSelectionRange(0, this.value.length)" step="0.1" type="number" name="distance" id="distance" class="form-control" prompt="<Please enter>" value="<?php echo $this->tripreport->actual_distance;?>"/>
			    <div class="form-text">Please fill in the actual distance of your event.</div>
			</td>
			</tr>
		<tr>			
			<th style="vertical-align: middle;">
				Number of Members:<span class="required">*</span>				
			</th>
			<td>
			    <input style="width:100%" step="1" type="number" name="num_members" id="num_members" class="form-control" value="<?php echo $this->tripreport->num_members ?>" onkeyup="onKeyUpButton()"/>
			    <div class="form-text">This is prefilled with the number of member registrations recorded by the system. You can modify this.</div>
		</td>
		</tr>
		<tr>			
			<th style="vertical-align: middle;">
				Number of Visitors:			
			</th>
			<td>
			    <input style="width:100%" step="1" type="number" name="num_visitors" id="num_visitors" class="form-control" value="<?php echo count($this->visitors) ?>" disabled /> 	
			    <div class="form-text">This is a calculated count of the number of non blank entries in the visitors table below</div>
		</td>
		</tr>
		<tr>			
			<th style="vertical-align: middle;">
				Total Number:				
			</th>
			<td>
			    <input style="width:100%" step="1" type="number" name="total_number" id="total_number" class="form-control" value="<?php echo $this->tripreport->num_members + count($this->visitors) ?>" disabled/>
		</td>
		</tr>
		<tr>			
			<th style="vertical-align: middle;">
				Number of Cancellations:<span class="required">*</span>				
			</th>
			<td >
			    <input style="width:100%" step="1" type="number" name="num_cancellations" id="num_cancellations" class="form-control" value="<?php echo $this->tripreport->num_cancellations ?>" onkeyup="this.value=this.value.replace(/[^0-9 +]+/,'')"/>
			    <div class="form-text">This is prefilled with the number of cancellations recorded by the system. You can modify this.</div>
			</td>
			</tr>
		<tr>			
			<th>
				Comment				
			</th>
			<td colspan="5">
			    <textarea style="width: 100%" type="text" name="comment" id="comment" class="form-control"><?php echo $this->tripreport->comment;?></textarea>
			</td>
		</tr>
		<tr>			
			<th>
				Any accident or incident on the activity?				
			</th>
			<td colspan="5">
                <input type="radio" id="yes" name="accident" value="Yes"> Yes
                <input type="radio" id="no" name="accident" value="No" checked> No 
			    <div class="form-text">If you select Yes, the Incident Report form will be opened after you press the Mail button</div>
			</td>
		</tr>
		<tr>			
			<th>
				Did any behaviour bother you?			
			</th>
			<td colspan="5">
			    <textarea style="width: 100%" type="text" name="behaviour" id="behaviour" class="form-control"><?php echo $this->tripreport->behaviour;?></textarea>
			    <div class="form-text">e.g. Did anyone fail to follow your directions/requests?</div>
			</td>
		</tr>
	</table>
	<br>
	<table><tr><td>Upload GPX of trip (optional)</td><td><input type="file" name="file" accept=".gpx,.kml" value="" size="30" /></td></tr></table>
			    <div class="form-text">If you upload your GPX file here, an entry will be made to the Walks Library</div>
			    <br>
	<table width="100%">
	    	<th>
				Num				
			</th>
	    	<th>
				Status				
			</th>
	    	<th>
				Visitors First Name				
			</th>
	    	<th>
				Visitors Last Name				
			</th>
	    	<th>
				Phone No <span class="required">*</span>				
			</th>
	    	<th>
				Action				
			</th>
		</tr>	
	    <?php for ($i=0; $i<count($this->visitors);$i++)
	    { ?>
	    <tr>
	    	<td>
				<?php echo $i+1?>				
			</td>
	    	<td>
				<div name="status[<?php echo $i?>]" id="status[<?php echo $i?>]"><?php if($this->visitors[$i]->published==1) echo 'Registered'; else echo 'Pending';?></div>				
			</td>
			<td >
			    <input readonly="readonly" style="color:grey;padding: 0; margin-bottom: 0;" type="text" name="first_name[<?php echo $i?>]" id="first_name[<?php echo $i?>]" class="form-control" value="<?php echo $this->visitors[$i]->first_name ?>" onkeyup="onKeyUpButton()"/>
			</td>
			<td >
			    <input readonly="readonly" style="color:grey;padding: 0; margin-bottom: 0;" type="text" name="last_name[<?php echo $i?>]" id="last_name[<?php echo $i?>]" class="form-control" value="<?php echo $this->visitors[$i]->last_name  ?>" onkeyup="onKeyUpButton()"/>
			</td>
			<td>
			    <input readonly="readonly" style="color:grey;padding: 0; margin-bottom: 0;" type="text" name="phone[<?php echo $i?>]" id="phone[<?php echo $i?>]" class="form-control" value="<?php echo $this->visitors[$i]->phone  ?>" onkeyup="onKeyUpButton()"/>
			</td>
			<td>
			    <input type="button" class="btn btn-secondary btn-sm" value="Clear" onclick="clearButton(<?php echo $i?>)">
			</td>
       </tr>
       <?php } ?>
	    <?php for ($i=count($this->visitors); $i<count($this->visitors)+5;$i++)
	    { ?>
	    <tr>
	    	<td>
				<?php echo $i+1?>				
			</td>
	    	<td>
			</td>
			<td >
			    <input style="padding: 0; margin-bottom: 0;" type="text" name="first_name[<?php echo $i?>]"  class="form-control" value="" onkeyup="onKeyUpButton()"/>
			</td>
			<td >
			    <input style="padding: 0; margin-bottom: 0;" type="text" name="last_name[<?php echo $i?>]"  class="form-control" value="" onkeyup="onKeyUpButton()"/>
			</td>
			<td>
			    <input style="padding: 0; margin-bottom: 0;" type="text" name="phone[<?php echo $i?>]" class="form-control" value="" onkeyup="onKeyUpButton()"/>
			</td>
			<td>
			    <input type="button" class="btn btn-secondary btn-sm" value="Clear" onclick="clearButton(<?php echo $i?>)">
			</td>
       </tr>
       <?php } ?>
    </table>
	<p><b>Status: </b>Approved visitors will have a Registered status. Visitors not approved will be displayed with a Pending status.</p>
	<p><b>Action</b> Click on the Clear button to delete visitor/s that did not attend your event. You can add visitor/s to your list if they are not shown.</p>
	<input type="hidden" name="option" value="com_mbwc" />	
	<input type="hidden" name="controller" value="tripreport" />	
	<input type="hidden" name="description" value="<?php echo htmlspecialchars($this->event->description); ?>" />	
	<input type="hidden" name="event_id" value="<?php echo $this->event->id; ?>" />
	<input type="hidden" name="id" value="<?php echo $this->tripreport->id; ?>" />
	<input type="hidden" name="leader" value="<?php echo $this->leader_name; ?>" />
	<input type="hidden" name="return" value="<?php echo $this->return; ?>" />
	<input type="hidden" name="task" value="send_trip_report" />	
	<input type="hidden" name="Itemid" value="<?php echo $this->Itemid; ?>" />
	<input type="hidden" name="event_end_date" value="something" />
	<?php if (!$this->multi) { ?>
	<input type="hidden" name="leader_id" value="<?php echo $this->leader_id1; ?>" />
	<input type="hidden" name="grade" value="<?php echo $this->category; ?>" />
	<input type="hidden" name="event_date" value="something" />
	<input type="hidden" name="event_name" value="something" />
	<input type="hidden" name="event_date_hour" value="something" />
	<input type="hidden" name="event_end_date_hour" value="something" />
	<?php } ?>
	<input type="button" value="Mail" class="btn btn-primary" onclick="checkData();"/>		
	<?php echo JHtml::_( 'form.token' ); ?>		
	
		<script language="javascript">
		function countVisitors()
		{
		    var inputsIWant = document.querySelectorAll('[name^="first_name"]');
            var inputsIWantLn = inputsIWant.length;
            
            var numberOfVisibleInputs = 0;
            for (var i = 0; i < inputsIWantLn; i++) {
            
                // Goes through each input to see if display is set to none
                if (inputsIWant[i].value != "") {
                    numberOfVisibleInputs++;
                }
            }
            return numberOfVisibleInputs++;
		}
		function onKeyUpButton()
		{
		    document.getElementById('num_visitors').value=countVisitors();
		    document.getElementById('total_number').value=+document.getElementById('num_visitors').value+ +document.getElementById('num_members').value;
		}
		function clearButton(num)
		{
		    document.querySelector("[name='status\["+num+"\]']").innerHTML='';
		    document.querySelector("[name='first_name\["+num+"\]']").value='';
		    document.querySelector("[name='first_name\["+num+"\]']").removeAttribute('readonly');
		    document.querySelector("[name='first_name\["+num+"\]']").style.removeProperty("color");
		    document.querySelector("[name='last_name\["+num+"\]']").value='';
		    document.querySelector("[name='last_name\["+num+"\]']").removeAttribute('readonly');
		    document.querySelector("[name='last_name\["+num+"\]']").style.removeProperty("color");
		    document.querySelector("[name='phone\["+num+"\]']").value='';
		    document.querySelector("[name='phone\["+num+"\]']").removeAttribute('readonly');
		    document.querySelector("[name='phone\["+num+"\]']").style.removeProperty("color");
		    document.getElementById('num_visitors').value=countVisitors();
		    document.getElementById('total_number').value=+document.getElementById('num_visitors').value+ +document.getElementById('num_members').value;
		}

		function checkData() {
			var form = document.adminForm ;
			if (form.distance.value == "") {
				alert("Actual Distance is required");
				form.distance.focus();
				return false;
			}						
			if (form.grade.value == "Leader Led Events") {
				alert("Please choose a grade");
				form.grade.focus();
				return false;
			}						
			if (form.event_name.value == "") {
				alert("Please enter event name");
				form.event_name.focus();
				return false;
			}						
			if (form.num_members.value == "") {
				alert("Please enter number of members");
				form.num_members.focus();
				return false;
			}						
			if (form.num_cancellations.value == "") {
				alert("Please enter number of cancellations");
				form.num_cancellations.focus();
				return false;
			}						
			if (form.event_date.value == "") {
				alert("Please enter start date");
				form.event_date.focus();
				return false;
			}
			for (i=0;i<10;i++)
			{
			    var name='first_name['+i+']';
			    var phone='phone['+i+']';
				if (form.elements[name] && form.elements[name].value && !form.elements[phone].value) {
				    alert("Please enter visitor phone number");
				    form.elements[phone].focus();
				    return false;
				}
			}
			form.submit();
		}
	</script>	
</form></p>
   </div>
</section>


</div>
