<?php
/**
 * @version		1.6.1
 * @package		Joomla
 * @subpackage	Event Booking
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
defined('_JEXEC') or die ;
error_reporting(0);
require_once JPATH_ROOT.'/components/com_eventbooking/helper/helper.php';
require_once JPATH_ROOT.'/components/com_eventbooking/helper/route.php';
jimport('joomla.log.log');
EventbookingHelper::loadLanguage() ;
$app = JFactory::getApplication() ;	
$db = JFactory::getDBO();
$itemId = (int) $params->get('item_id', 0);
if (!$itemId)
    $itemId = EventBookingHelper::getItemid() ;

$user = & JFactory::getUser() ;    	
$numberEvents = $params->get('number_events', 6);
$categoryIds = $params->get('category_ids', '');
$showCategory = $params->get('show_category', 1);
$showLocation = $params->get('show_location') ;		
$layout = $params->get('layout', 'lastsumbitted');
$where = array() ;
$where[] = 'a.published =1 ' ;
//$where[] = 'DATE(event_date) >= CURDATE()' ;
$where[] = 'a.parent_id = 0 ' ;
if ($categoryIds != '') {
	$where[] = 'a.id not IN (SELECT event_id FROM #__eb_event_categories WHERE category_id not IN ('.$categoryIds.'))';
	$where[] = 'a.id IN (SELECT event_id FROM #__eb_event_categories WHERE category_id IN ('.$categoryIds.')) ' ;	
}
if ($user->id)
{
  $where[] = ' a.access IN ('.implode(',', $user->getAuthorisedViewLevels()).')' ;
}
if ($app->getLanguageFilter()) {
	$where[] = ' a.language IN (' . $db->Quote(JFactory::getLanguage()->getTag()) . ',' . $db->Quote('*') . ')';
}
if ($layout == 'meetings')
{
   $where[] = "a.published=1";
   $where[] = "DATE(a.event_date) >= CURDATE()";
}
if ($layout == 'print')
{
   $where[] = 'DATE(event_date) >= CURDATE()' ;
}
if ($layout == 'publicupcoming' || $layout == 'print')
{
   $where[] = "a.published=1";
   $where[] = "a.registration_type!=3";
   $where[] = "(a.created_date is null or DATE_ADD(a.created_date, INTERVAL 3 DAY) <= CURDATE())";
   $where[] = "DATE(a.cut_off_date) >= CURDATE()";
}
if ($layout == 'publicupcoming')
{
   $where[] = 'DATE(a.event_date) >= CURDATE()' ;
   $where[] = "DATE(a.event_date) <= DATE_ADD(CURDATE(), INTERVAL 28 DAY)";
}
if ($layout == 'today')
{
   $where[] = "DATE(a.event_date) = CURDATE()";
   $where[] = "a.published=1";
}
if ($layout === 'mynextevent')
{
    $where[] = 'DATE(a.event_end_date) >= CURDATE()' ;
    $where[]="EXISTS (select 1 from #__eb_registrants as b where a.id=b.event_id and b.is_group_billing=0 and b.published=1 and (b.user_id=".$user->get('id')." or (b.email='".$user->get('email')."' and REPLACE(concat(b.first_name,' ',b.last_name),'''','')='".str_replace("'","",$user->get('name'))."')))";
    $sql = 'SELECT a.* FROM #__eb_events AS a '
	 . ' WHERE '.implode(' AND ', $where);
}
else if ($layout == 'multiday')
{
		$sql = "select f.* from (select a.*, concat_ws(',',
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id3')))) as leader_name, c.name as location_name, IFNULL(SUM(b.number_registrants), 0) AS total_registrants from jos_eb_events as a"
	 . ' LEFT JOIN #__eb_registrants AS b '
	 . ' ON (a.id = b.event_id AND b.group_id=0 AND (b.published = 1 OR b.published = 4)) '
	 . ' LEFT JOIN #__eb_locations AS c '
	 . ' ON a.location_id = c.id '
	 . ' WHERE DATE(a.event_date) != DATE(a.Event_end_date) and a.event_end_date != "0000-00-00 00:00:00" and a.published=1 and date(a.event_date) >= curdate() group by a.id'
	 . ' ) as f ';
	 if ($numberEvents > 0)
	 {
	   $sql =  $sql . ' where (f.event_capacity > f.total_registrants or f.event_capacity=0) ';
	 }
	 $sql = $sql . ' order by f.event_date';
}
else if ($layout != 'meetings')
{
		$sql = "select a.*, concat_ws(',',
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id1'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id2'))),
		(select name from jos_users as b where b.id=JSON_UNQUOTE(JSON_EXTRACT(a.custom_fields,'$.field_leader_id3')))) as leader_name, c.name as location_name, IFNULL(SUM(b.number_registrants), 0) AS total_registrants from jos_eb_events as a"
	 . ' LEFT JOIN #__eb_registrants AS b '
	 . ' ON (a.id = b.event_id AND b.group_id=0 AND (b.published = 1 OR b.published = 4)) '
	 . ' LEFT JOIN #__eb_locations AS c '
	 . ' ON a.location_id = c.id '
	 . ' WHERE '.implode(' AND ', $where)
	 . ' GROUP BY a.id';
}
else
{
    $sql = 'SELECT a.* FROM #__eb_events AS a '
	 . ' WHERE '.implode(' AND ', $where);
}
if ($layout == 'lastsumbitted')
{
	 $sql = $sql . ' ORDER BY a.id desc ';
}
else if ($layout != 'multiday')
{
	 $sql = $sql . ' ORDER BY a.event_date ';
}
if ($numberEvents > 0)
{
    $sql = $sql .  ' LIMIT '.$numberEvents;
}

$db->setQuery($sql) ;	
$rows = $db->loadObjectList();

for ($i = 0 , $n = count($rows) ; $i < $n ; $i++) {
	$row = $rows[$i] ;
	//Get all categories
	$sql = 'SELECT a.id, a.name FROM #__eb_categories AS a INNER JOIN #__eb_event_categories AS b ON a.id = b.category_id WHERE b.event_id='.$row->id;
	$db->setQuery($sql) ;
	$categories = $db->loadObjectList() ;
	if (count($categories)) {
		$itemCategories = array() ;
		foreach ($categories as  $category) {
			$itemCategories[] = '<a href="'.EventbookingHelperRoute::getCategoryRoute($category->id, $itemId).'"><strong>'.$category->name.'</strong></a>';
		}
		$row->categories = implode('&nbsp;|&nbsp;', $itemCategories) ;
	}
    $row->paramData = new JRegistry($row->custom_fields);
}
$config = \EventBookingHelper::getConfig();
$config->latest=true;
$config->Itemid=$itemId;
$document = JFactory::getDocument() ;
$document->addStyleSheet(JUri::base(true).'/modules/mod_mbwc_events/css/style.css');

if ($layout == 'publicupcoming')
{
	JLog::addLogger(
        array(
             // Sets file name
            'text_file' => 'visitors.log.php',
            'text_entry_format' => '{DATETIME} {CLIENTIP} {MESSAGE}'
       ),
        JLog::ALL,
        array('visitors')
    );

    JLog::add('Visitor viewing event list', JLog::INFO, 'visitors');  
}
if ($layout == 'publicupcoming' || $layout == 'print')
{
    $config->readOnly=true;
}

if ($config->calendar_theme)
{
    $theme = $config->calendar_theme ;
}
else
{
    $theme = 'default' ;
}

require (JModuleHelper::getLayoutPath('mod_mbwc_events', $layout));