<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2023 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\Registry\Registry;

/**
 * Layout variables
 * -----------------
 * @var   EventbookingTableEvent $item
 */
$db = Factory::getDbo();

$sql = "select count(*) from jos_eb_event_categories as d join jos_eb_categories as e on d.category_id=e.id join jos_mbwc_categoryextras as f on f.category_id=e.id where f.external_event=1 and d.event_id=".$item->id;
$db->setQuery($sql);
$external_event = $db->loadResult();

/*
$carpool_cost=0;
$driving_distance=0;
$driving_duration=0;
if (!defined("PROP_ADDRESS1"))
{
    define("PROP_ADDRESS1", 'address1');
}
if (!defined("PROP_ADDRESS2"))
{
    define("PROP_ADDRESS2", 'address2');
}
if (property_exists($item,PROP_ADDRESS1) && property_exists($item,PROP_ADDRESS2))
{
    $myadd1=$item->address1;
    if (preg_match_all( "/[0-9]/", $myadd1 ) >= 5)
    {
        $myadd1=str_replace('%2C',',',str_replace('%20', '',$myadd1));
        $polyArray1=explode(',',$myadd1);
            // average opposite sides
        $myadd1=str_replace(' ', '',$polyArray1[1]).','.str_replace(' ', '',$polyArray1[0]);
    }
    else
    {
        $url='https://api.openrouteservice.org/geocode/search?api_key=5b3ce3597851110001cf6248634bfcb8521544d58f6b7c9cbf9a1eaf&text='.rawurlencode($myadd1);
        $response = @file_get_contents($url,0, stream_context_create(["http"=>["timeout"=>10]]));
        if ($response !== false  && strpos($response,"error") === FALSE)
        {
           $obj=json_decode($response);
           $myadd1 = ($obj->bbox[0] + $obj->bbox[2])/2 . "," . ($obj->bbox[1]+$obj->bbox[2])/2;
        }
        
    }
    $myadd2=$item->address2;
    if (preg_match_all( "/[0-9]/", $myadd2 ) >= 5)
    {
        $myadd2=str_replace('%2C',',',str_replace('%20', '',$myadd2));
        $polyArray2=explode(',',$myadd2);
            // average opposite sides
        $myadd2=str_replace(' ', '',$polyArray2[1]).','.str_replace(' ', '',$polyArray2[0]);
    }
    else
    {
        $url='https://api.openrouteservice.org/geocode/search?api_key=5b3ce3597851110001cf6248634bfcb8521544d58f6b7c9cbf9a1eaf&text='.rawurlencode($myadd2);
        $response = @file_get_contents($url,0, stream_context_create(["http"=>["timeout"=>10]]));
        if ($response !== false && strpos($response,"error") === FALSE)
        {
           $obj=json_decode($response);
           $myadd2= ($obj->bbox[0] + $obj->bbox[2])/2 . "," . ($obj->bbox[1]+$obj->bbox[2])/2;
        }
    }
    $url='https://api.openrouteservice.org/v2/directions/driving-car?api_key=5b3ce3597851110001cf6248634bfcb8521544d58f6b7c9cbf9a1eaf&start='.$myadd1.'&end='.$myadd2;
    $response = @file_get_contents($url,0, stream_context_create(["http"=>["timeout"=>10]]));
    if ($response !== false && strpos($response,"error") === FALSE)
    {
        $obj=json_decode($response);

        if ($obj->features[0]->properties->summary && property_exists($obj->features[0]->properties->summary,'distance'))
        {
            $driving_distance=round($obj->features[0]->properties->summary->distance/1000);
        }
        if ($obj->features[0]->properties->summary && property_exists($obj->features[0]->properties->summary,'duration'))
        {
          $driving_duration=round($obj->features[0]->properties->summary->duration/60);
        }
    }
    $petrol_cost=rawurlencode($item->paramData['field_petrol_cost']['value']);
    if ($petrol_cost)
    {
        $carpool_cost=round(($driving_distance*2*11.11*$petrol_cost/100+$driving_distance*2*.1)/3);
    }	
}
*/
foreach ($item->paramData as $key => $param)
{
	if ($param['value'] && empty($param['hide']))
	{
		$paramValue = $param['value'];

		// Make the link click-able
		if (filter_var($paramValue, FILTER_VALIDATE_URL))
		{
			$paramValue = '<a href="' . $paramValue . '" target="_blank">' . $paramValue . '<a/>';
		}
 		if ($key === 'field_leader_id1' || $key === 'field_leader_id2' || $key === 'field_leader_id3')
		{
		    if ($external_event)
		    {
		        continue;
		    }
		    if ($paramValue)
		    {
    		    $sql = 'select name from jos_users where id='.$paramValue;
    		    $db->setQuery($sql) ;
    		    $paramValue  = $db->loadResult();
		    }
		}
		?>
		<tr class="eb-event-property">
			<td class="eb-event-property-label">
				<?php echo Text::_($param['title']); ?>
			</td>
			<td class="eb-event-property-value">
				<?php echo Text::_($paramValue); ?>
			</td>
		</tr>
		<?php
	}
}
$fieldextras = new Registry($item->custom_fields);
if ($fieldextras['driving_distance'])
{
?>
		<tr class="eb-event-property">
			<td class="eb-event-property-label">
				Estimated Distance from Carpool to Walk start
			</td>
			<td class="eb-event-property-value">
				<?php echo $fieldextras['driving_distance'] . ' km' ?>
			</td>
		</tr>
<?php
}
if ($fieldextras['driving_duration'])
{
?>
		<tr class="eb-event-property">
			<td class="eb-event-property-label">
				Estimated Duration from Carpool to Walk start
			</td>
			<td class="eb-event-property-value">
				<?php echo $fieldextras['driving_duration'] . ' min' ?>
			</td>
		</tr>
<?php
}
if ($fieldextras['carpool_cost'])
{
?>
		<tr class="eb-event-property">
			<td class="eb-event-property-label">
				Estimated Carpool cost<br> This may change on the day depending upon petrol cost
			</td>
			<td class="eb-event-property-value">
				<?php echo "$".$fieldextras['carpool_cost']  ?>
			</td>
		</tr>
<?php
}
