<?php
/**
 * @package        	Joomla
 * @subpackage		Event Booking
 * @author  		Tuan Pham Ngoc
 * @copyright    	Copyright (C) 2010 - 2023 Ossolution Team
 * @license        	GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;
use Joomla\CMS\Router\Route;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;

$rowEvent    = EventbookingHelperDatabase::getEvent($this->rowRegistrant->event_id);
$leaderName=MBWCHelper::getLeaderName($this->rowRegistrant->event_id);
$leaderPh = MBWCHelper::getLeaderPhone($this->rowRegistrant->event_id);
$this->message = str_replace('[FIELD_LEADER_NAME]', $leaderName, $this->message);
$this->message = str_replace('[FIELD_MOBILE_PH]', $leaderPh, $this->message);
?>
<div id="eb-registration-complete-page" class="eb-container">
	<h1 class="eb-page-heading"><?php echo Text::_('EB_REGISTRATION_COMPLETE'); ?>
		<?php
		if ($this->showPrintButton === '1' &&  !$this->print)
		{
			$uri = Uri::getInstance();
			$uri->setVar('tmpl', 'component');
			$uri->setVar('print', '1');
		?>
			<div id="pop-print" class="btn hidden-print">
				<a href="<?php echo $uri->toString(); ?>" target="_blank" title="<?php echo Text::_('EB_PRINT_THIS_PAGE'); ?>" rel="nofollow">
					<span class="<?php echo $this->bootstrapHelper->getClassMapping('icon-print'); ?>"></span>
				</a>
			</div>
		<?php
		}
		?>
	</h1>
	<div id="eb-message" class="eb-message"><?php echo HTMLHelper::_('content.prepare', $this->message); ?></div>
 
	<a href="<?php echo Route::_(EventbookingHelperRoute::getEventRoute($this->rowRegistrant->event_id, $rowEvent->main_category_id, $this->Itemid) . '&layout=default');?>" 
	  type="button" name="btn-back" id="btn-back" class="btn btn-primary">Back</a>

</div>
<?php
if ($this->print)
{
?>
	<script type="text/javascript">
		window.print();
	</script>
<?php
}

echo $this->conversionTrackingCode;