<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2023 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

use Joomla\CMS\Editor\Editor;
use Joomla\CMS\Factory;
use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Toolbar\Toolbar;
use Joomla\CMS\Uri\Uri;
use MBWC\Component\MBWC\Site\Helper\MBWCHelper;
use Joomla\Utilities\ArrayHelper;

HTMLHelper::_('bootstrap.tooltip');
Factory::getDocument()->getWebAssetManager()->useScript('keepalive');
$document = Factory::getDocument();
if ($this->item->title)
{
    $document->setTitle($this->item->title);
}
else
{
    $document->setTitle("Submit Event");
}

if (EventbookingHelper::isJoomla4())
{
	EventbookingHelperJquery::colorbox('a.modal');
}
else
{
	HTMLHelper::_('behavior.modal');
}

?>
<link
  rel="stylesheet"
  href="https://cdnjs.cloudflare.com/ajax/libs/selectize.js/0.15.2/css/selectize.default.min.css"
  integrity="sha512-pTaEn+6gF1IeWv3W1+7X7eM60TFu/agjgoHmYhAfLEU8Phuf6JKiiE8YmsNC0aCgQv4192s4Vai8YZ6VNM6vyQ=="
  crossorigin="anonymous"
  referrerpolicy="no-referrer"
/>
<script
  src="https://cdnjs.cloudflare.com/ajax/libs/selectize.js/0.15.2/js/selectize.min.js"
  integrity="sha512-IOebNkvA/HZjMM7MxL0NYeLYEalloZ8ckak+NDtOViP7oiYzG5vn6WVXyrJDiJPhl4yRdmNAG49iuLmhkUdVsQ=="
  crossorigin="anonymous"
  referrerpolicy="no-referrer"
></script>
<div>
<script type="text/javascript">
jQuery(document).ready(function(){
    jQuery("#created_by").selectize({
          sortField: 'text',
          placeholder: 'Select Creator’s Name'
    });
    var leader1=jQuery("#params_field_leader_id1").selectize({
          sortField: 'text',
          placeholder: 'Select Leader’s Name'
    });
    jQuery("#params_field_leader_id2").selectize({
          sortField: 'text',
          placeholder: 'Select Leader’s Name (Optional)'
    });
    jQuery("#params_field_leader_id3").selectize({
          sortField: 'text',
          placeholder: 'Select Leader’s Name (Optional)'
    });
    jQuery('#main_category_id').on('change', function(e) {
        set_event_capacity_validation();
    });
    // Don't allow unselecting the main leader
    var selectize = leader1[0].selectize;
        selectize.on('blur', function() {
            if (selectize.getValue() === '') {
                var defaultOption = selectize.options[Object.keys(selectize.options)[0]];
                selectize.setValue(defaultOption.value);
            }
        });
    set_event_capacity_validation();
    var d = document.getElementById("event_end_date");
    d.setAttribute('data-errormessage-type-mismatch',"* Event End Date must be after Event Date");
});
function set_event_capacity_validation() {
	var external = false ;
	var meeting = false;
	var categoryIds = document.getElementById("main_category_id");
	for (var i = 0 ; i < categoryIds.length ; i++) {
		if (categoryIds.options[i].selected) {
		    if (categoryIds.options[i].getAttribute('data-external') == 1) {
			    external = true ;
		    }
		    if (categoryIds.options[i].getAttribute('data-meeting') == 1) {
			    meeting = true ;
		    }
		    break;
		}
	}
	if (!external && !meeting)
	{
	    var d = document.getElementById("event_capacity");
        d.className = "input-medium form-control validate[required,min[4]]";
	}
	else
	{
 	    var d = document.getElementById("event_capacity");
 	    d.className = "input-medium form-control";
  	}
}

function checkEndDate(field, rules, i, options){
	var multiday = false ;
	var categoryIds = document.getElementById("main_category_id");

	for (var i = 0 ; i < categoryIds.length ; i++) {
		if (categoryIds.options[i].selected) {
		    if (categoryIds.options[i].getAttribute('data-multi') == 1) {
			    multiday = true ;
		    }
		    break;
		}
	}
	var d = document.getElementById("event_date");
    if (field.val() !== d.value && !multiday) {
      return "* Start date and End date must be the same. Only Multiday categories allow the date to be different.";
    }
}
function hideHelp(){
    jQuery(".form-text").hide();
    jQuery("#hideHelp").hide();
    jQuery("#showHelp").show();
    jQuery('#adminForm').validationEngine('hide');
}
function showHelp(){
    jQuery(".form-text").show();
    jQuery("#showHelp").hide();
    jQuery("#hideHelp").show();
    jQuery('#adminForm').validationEngine('hide');
}
</script>
    	<script src="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.13.2/jquery-ui.min.js" type="text/javascript"></script>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/jqueryui/1.13.2/themes/base/jquery-ui.min.css">
    <script type="text/javascript">
        jQuery(document).ready(function () {
         jQuery(".form-text").hide();
         jQuery("#hideHelp").hide();
         jQuery("#params_field_address").autocomplete({
                source: function (request, response) {
                    jQuery.ajax({
                        url: "https://geocode.arcgis.com/arcgis/rest/services/World/GeocodeServer/suggest",
                        data: {
                            f: "json",
                            text: request.term,
                            countryCode:"AUS",
                            maxSuggestions:5,
                            category:"Address"
                        },
                        jsonp: "jsonp",
                        success: function (data) {
                            if (data && data.suggestions) {
                                    response(jQuery.map(data.suggestions, function (item) {
                                        return {
                                            data: item.magicKey,
                                            label: item.text,
                                            value: item.text
                                        }
                                    }));
                            }
                        }
                    });
                },
                minLength: 1,
                change: function (event, ui) {
                    //if (!ui.item)
                        //jQuery("#params_field_address").val('');
                },
                select: function (event, ui) {
                    displaySelectedItem("#params_field_address",ui.item);
                }
            });
            jQuery("#params_field_address_start").autocomplete({
                source: function (request, response) {
                    jQuery.ajax({
                        url: "https://geocode.arcgis.com/arcgis/rest/services/World/GeocodeServer/suggest",
                        data: {
                            f: "json",
                            text: request.term,
                            countryCode:"AUS",
                            maxSuggestions:5,
                            category:"Address"
                        },
                        jsonp: "jsonp",
                        success: function (data) {
                            if (data && data.suggestions) {
                                    response(jQuery.map(data.suggestions, function (item) {
                                        return {
                                            data: item.magicKey,
                                            label: item.text,
                                            value: item.text
                                        }
                                    }));
                            }
                        }
                    });
                },
                minLength: 1,
                change: function (event, ui) {
                    //if (!ui.item)
                        //jQuery("#params_field_address_start").val('');
                },
                select: function (event, ui) {
                    displaySelectedItem("#params_field_address_start",ui.item);
                }
            });
        });

        function displaySelectedItem(what,item) {
            jQuery(what).empty().append(item.value);
        }
    </script>

<?php

$user = Factory::getUser();
$db = Factory::getDbo();
$sql = "select distinct a.* from jos_users as a join jos_user_usergroup_map as b where (b.group_id=9 or b.group_id=25 or b.group_id=81) and b.user_id=a.id order by a.name";
$db->setQuery($sql);
$this->leaders = $db->loadObjectList();
$this->eventCoordinator=MBWCHelper::isEventCoordinator();

$editor = Editor::getInstance(Factory::getApplication()->get('editor', 'none'));
EventbookingHelperJquery::validateForm();

$bootstrapHelper   = EventbookingHelperBootstrap::getInstance();
$controlGroupClass = $bootstrapHelper->getClassMapping('control-group');
$controlLabelClass = $bootstrapHelper->getClassMapping('control-label');
$controlsClass     = $bootstrapHelper->getClassMapping('controls');
$iconCalendar      = $bootstrapHelper->getClassMapping('icon-calendar');
$rowFluidClass     = $bootstrapHelper->getClassMapping('row-fluid');
$btnPrimary        = $bootstrapHelper->getClassMapping('btn btn-primary');
$formHorizontal    = $bootstrapHelper->getClassMapping('form form-horizontal');

$dateFields = [
	'event_date',
	'event_end_date',
	'registration_start_date',
	'cut_off_date',
];

foreach ($dateFields as $dateField)
{
	if ($this->item->{$dateField} == $this->nullDate)
	{
		$this->item->{$dateField} = '';
	}
}

$useTabs = $this->isMultilingual || count($this->plugins);

EventbookingHelperHtml::addOverridableScript('media/com_eventbooking/js/site-event-simple.min.js');

$message     = EventbookingHelper::getMessages();
$fieldSuffix = EventbookingHelper::getFieldSuffix();

$toolbarButtons = Toolbar::getInstance('toolbar')->render();
$helpButton = '<button style="margin-left: 10px; height: 41px" id="showHelp" class="btn btn-primary" type="button" onclick="showHelp()">
    <span class="icon-help" aria-hidden="true"></span>
    Show Help</button><button style="margin-left: 10px; height: 41px" id="hideHelp" class="btn btn-primary" type="button" onclick="hideHelp()">
    <span class="icon-help" aria-hidden="true"></span>
    Hide Help</button>';

if ($fieldSuffix && EventbookingHelper::isValidMessage($message->{'submit_event_form_message' . $fieldSuffix}))
{
	$msg = $message->{'submit_event_form_message' . $fieldSuffix};
}
elseif(EventbookingHelper::isValidMessage($message->submit_event_form_message))
{
	$msg = $message->submit_event_form_message;
}
else
{
	$msg = '';
}

?>
<h1 class="eb-page-heading"><?php echo $this->escape(Text::_('EB_ADD_EDIT_EVENT')); ?></h1>
<?php
if ($msg)
{
?>
	<div class="<?php echo $rowFluidClass; ?> eb-submit-event-form-message">
		<?php echo $msg; ?>
	</div>
<?php
}
?>
<div id="eb-submit-event-simple" class="<?php echo $rowFluidClass; ?>">
    <?php
	if (in_array($this->config->get('submit_event_toolbar', 'top'), ['top', 'both']))
	{
	?>
        <div class="btn-toolbar subhead" id="btn-toolbar" style="top:80px; z-index:3;">
		    <?php echo $toolbarButtons . $helpButton;?>
        </div>
	<?php
	}
	?>
	<form action="<?php echo Route::_('index.php?option=com_eventbooking&view=events&Itemid=' . $this->Itemid); ?>" method="post" name="adminForm" id="adminForm" enctype="multipart/form-data" class="<?php echo $formHorizontal; ?>">
		<div class="clearfix"></div>
		<?php
		if ($useTabs)
		{
			echo HTMLHelper::_('bootstrap.startTabSet', 'event', ['active' => 'basic-information-page', 'recall' => true]);
			echo HTMLHelper::_('bootstrap.addTab', 'event', 'basic-information-page', Text::_('EB_BASIC_INFORMATION'));
		}

		if (EventbookingHelper::isValidMessage($this->params->get('intro_text')))
		{
		?>
            <div class="eb-submit-event-intro-text <?php echo $bootstrapHelper->getClassMapping('control-group clearfix'); ?>">
				<?php echo $this->params->get('intro_text'); ?>
            </div>
		<?php
		}
	    if ($this->eventCoordinator)
	    {
				    if (!$this->item->created_by)
				    {
				       $this->item->created_by = $user->id;
				    }
	        ?>
 		<div class="<?php echo $controlGroupClass;  ?>">
			<div class="<?php echo $controlLabelClass; ?>">Walk Owner</div>
			<div class="<?php echo $controlsClass; ?>">
                		<select name="created_by" id="created_by" class="input-xlarge" aria-describedby="createdbyhelp"> 	
		                <option></option>
                		<?php
                		foreach ($this->leaders as $row) 
                		{
                		?>			
                			<option value="<?php echo $row->id; ?>" <?php if ($row->id == $this->item->created_by) echo " selected"; ?> > <?php echo $row->name; ?> </option>	  
                		<?php
                		}
                		?>
                		</select>	
<div id="createdbyhelp" class="form-text">The owner is the person who submitted the walk. Only Event Coordinators can see this field.<br> The person who is the owner gets the Event in their "My Submitted Events" view, along with each leader. 
This doesn't have to be the leader.<br>
This is for the use of the Event Coordinator to submit events for leaders who do not have computer access.<br>
<br>The Walk Owner is responsible for filling in the trip report.</div>	                </div>
                     </div>

                		<?php
				    }
				    ?>
		<div class="<?php echo $controlGroupClass;  ?>">
			<div class="<?php echo $controlLabelClass; ?>"><?php echo Text::_('EB_TITLE') ; ?></div>
			<div class="<?php echo $controlsClass; ?>">
				<input type="text" name="title" value="<?php echo $this->escape($this->item->title); ?>" class="validate[required] input-xlarge form-control" size="70" aria-describedby="titlehelp"/>
				<div id="titlehelp" class="form-text">
				If this is a walk by a new leader, prepend *NEW LEADER* to the title.<br>
				If you are changing the leader, prepend "LEADER CHANGED* to the title.
				</div>
			</div>
		</div>
		<?php
		if ($this->config->get('fes_show_alias', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>"><?php echo Text::_('EB_ALIAS') ; ?></div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="text" name="alias" value="<?php echo $this->item->alias; ?>" class="input-xlarge form-control" size="70" />
				</div>
			</div>
		<?php
		}

		$db    = Factory::getDbo();
        $user = Factory::getUser();
        $levels = implode(',', $user->getAuthorisedViewLevels());
        $query = $db->getQuery(true)
			->select('a.id, a.parent AS parent_id, a.name AS title, (select 1 from #__eb_categories as b where b.id=a.id and b.access not in (' . $levels . ')) as disabled, b.multi_day, b.club_meeting,b.external_event')
			->from('#__eb_categories as a')
			->join('','#__mbwc_categoryextras as b on b.category_id=a.id')
			->where('a.published=1')
			->order('a.ordering');

		$db->setQuery($query);

		$categories= $db->loadObjectList();

		$children = [];

		// first pass - collect children
		foreach ($categories as $v)
		{
			$pt            = $v->parent_id;
			$list          = $children[$pt] ?? [];
			$list[]        = $v;
			$children[$pt] = $list;
		}

		$list      = HTMLHelper::_('menu.treerecurse', 0, '', [], $children, 9999, 0, 0);
		$options   = [];
		$option = HTMLHelper::_('select.option', 0, "Select a category");
		$option->disable=1;
		$options[]=$option;

		foreach ($list as $item)
		{
			$option = HTMLHelper::_('select.option', $item->id, '&nbsp;&nbsp;&nbsp;' . $item->treename);
		    $option->disable=$item->disabled;
			$option->optionattr = array(
                'data-external' => $item->external_event,
                'data-meeting' => $item->club_meeting,
                'data-multi' => $item->multi_day
                );			
			$options[] = $option;
		}

		$this->lists['main_category_id'] = HTMLHelper::_('select.genericlist', $options, 'main_category_id', [
			'option.attr' => 'optionattr',
			'option.text.toHtml' => false,
			'option.text'        => 'text',
			'option.value'       => 'value',
			'list.attr'          => 'class="advancedSelect input-xlarge validate[required] form-select"',
			'list.select'        => (int) $this->item->main_category_id,
		]);

		$options = \EventbookingHelper::callOverridableHelperMethod('Html', 'getCategoryOptions', [$categories, '']);

		if ($this->item->id)
		{
			$query->clear()
				->select('category_id')
				->from('#__eb_event_categories')
				->where('event_id = ' . $this->item->id)
				->where('main_category = 0');
			$db->setQuery($query);
			$additionalCategories = $db->loadColumn();
		}
		else
		{
			$additionalCategories = $this->input->post->get('category_id', [], 'array');
			$additionalCategories = ArrayHelper::toInteger($additionalCategories);
		}
		$this->lists['category_id'] = HTMLHelper::_('select.genericlist', $options, 'category_id[]', [
			'option.text.toHtml' => false,
			'option.text'        => 'text',
			'option.value'       => 'value',
			'list.attr'          => 'class="advancedSelect input-xlarge form-select"  size="5" multiple="multiple"',
			'list.select'        => $additionalCategories,
		]);

		?>
		<div class="<?php echo $controlGroupClass;  ?>">
			<div class="<?php echo $controlLabelClass; ?>"><?php echo Text::_('EB_MAIN_EVENT_CATEGORY') ; ?></div>
			<div class="<?php echo $controlsClass; ?>">
				<?php echo $this->lists['main_category_id'] ; ?>
			</div>
		</div>
		<?php
		if ($this->config->get('fes_show_additional_categories', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>"><?php echo Text::_('EB_ADDITIONAL_CATEGORIES') ; ?></div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $this->lists['category_id'] ; ?>
					<?php echo '      ' . Text::_('EB_SELECT_MULTIPLE_CATEGORIES'); ?>
					<div id="categoryhelp" class="form-text"><b>Note:</b> Its optional to choose extra categories. You may want to if for example you are doing a recce, and you want to also let people know how difficult it will be.</div>
				</div>
			</div>
		<?php
		}
		if ($this->config->event_custom_field)
		{
			foreach ($this->form->getFieldset('basic') as $field)
			{
				$submitEventAccess = $field->getAttribute('submit_event_access');

				if ($submitEventAccess !== null && !in_array($submitEventAccess, $user->getAuthorisedViewLevels()))
				{
					continue;
				}
				if (strpos($field->label,"Distance") !== false) {
			?>
				<div class="<?php echo $controlGroupClass;  ?>">
					<div class="<?php echo $controlLabelClass; ?>">
						<?php echo $field->label;?>
					</div>
					<div class="<?php echo $controlsClass; ?>">
						<?php echo $field->input; ?>
					</div>
				</div>
			<?php
				}
			}
		}
		
		if ($this->config->get('fes_show_capacity'))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo EventbookingHelperHtml::getFieldLabel('event_capacity', Text::_('EB_EVENT_CAPACITY'), Text::_('EB_CAPACITY_EXPLAIN')); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="number" min="0" step="1" name="event_capacity" id="event_capacity" class="input-medium form-control" size="10" value="<?php echo $this->item->event_capacity; ?>" />
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_thumb_image', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>"><?php echo Text::_('EB_THUMB_IMAGE') ; ?></div>
				<div class="<?php echo $controlsClass; ?>">
					<?php
						if ($this->config->get('use_media_manager')
						&& ($user->authorise('core.manage', 'com_media') || $user->authorise('core.create', 'com_media')))
						{
							echo EventbookingHelperHtml::getMediaInput($this->item->image, 'image');
						?>
							<input type="hidden" name="use_media_manager" value="1" />
						<?php
						}
						else
						{
						?>
							<input type="file" class="form-control" name="thumb_image" size="60" />
							<?php
							if ($this->item->thumb && file_exists(JPATH_ROOT . '/media/com_eventbooking/images/thumbs/' . $this->item->thumb))
							{
								$baseUri = Uri::base(true);

								if ($this->item->image && file_exists(JPATH_ROOT . '/' . $this->item->image))
								{
									$largeImageUri = $baseUri . '/' . $this->item->image;
								}
								elseif (file_exists(JPATH_ROOT . '/media/com_eventbooking/images/' . $this->item->thumb))
								{
									$largeImageUri = $baseUri . '/media/com_eventbooking/images/' . $this->item->thumb;
								}
								else
								{
									$largeImageUri = $baseUri . '/media/com_eventbooking/images/thumbs/' . $this->item->thumb;
								}
								?>
								<a href="<?php echo $largeImageUri; ?>" class="modal"><img src="<?php echo $baseUri . '/media/com_eventbooking/images/thumbs/' . $this->item->thumb; ?>" class="img_preview" /></a>
								<input type="checkbox" name="del_thumb" value="1" /><?php echo Text::_('EB_DELETE_CURRENT_THUMB'); ?>
								<?php
							}
							?>
						<?php
						}
					?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_image_alt', 0))
		{
		?>
			<div class="<?php echo $controlGroupClass;?>">
				<div class="<?php echo $controlLabelClass; ?>"><?php echo Text::_('EB_IMAGE_ALT') ; ?></div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="text" name="image_alt" value="<?php echo $this->item->image_alt; ?>" class="input-xlarge form-control" size="70" />
				</div>
			</div>
		<?php
		}

		?>
		<div class="<?php echo $controlGroupClass;  ?>">
			<div class="<?php echo $controlLabelClass; ?>">
				<?php echo Text::_('EB_EVENT_START_DATE'); ?>
			</div>
			<div class="<?php echo $controlsClass; ?>">
				<?php echo str_replace('icon-calendar', $iconCalendar, HTMLHelper::_('calendar', $this->item->event_date, 'event_date', 'event_date', $this->datePickerFormat, ['class' =>  'validate[required]', 'onChange' => "if (document.getElementById('event_date')) { var d=document.getElementById('event_date').value; document.getElementById('event_end_date').value = d;
						document.getElementById('event_end_date').setAttribute('data-alt-value',d); 
						var dt = new Date(Date.parse(d) - 24*60*60*1000); document.getElementById('cut_off_date').value = dt.toLocaleDateString('sv'); document.getElementById('cut_off_date').setAttribute('data-alt-value',dt.toLocaleDateString('sv')); document.getElementById('cancel_before_date').value = dt.toLocaleDateString('sv'); document.getElementById('cancel_before_date').setAttribute('data-alt-value',dt.toLocaleDateString('sv'));}"])); ?>
				<?php echo $this->lists['event_date_hour'] . ' ' . $this->lists['event_date_minute']; ?>
				<?php if (!$this->item->event_date)
				{
				    ?><script>jQuery("select[name='event_date_hour'] option[value='9']").prop('selected', true);</script>
				<?php } ?>
		</div>
		</div>
		<?php
		if ($this->config->get('fes_show_event_end_date'))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_EVENT_END_DATE'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo str_replace('icon-calendar', $iconCalendar, HTMLHelper::_('calendar', $this->item->event_end_date, 'event_end_date', 'event_end_date', $this->datePickerFormat, ['class' => 'validate[funcCall[checkEndDate],future[#event_date]]'])); ?>
					<?php echo $this->lists['event_end_date_hour'] . ' ' . $this->lists['event_end_date_minute'] ; ?>
				<?php if (!$this->item->event_end_date)
				{
				    ?><script>jQuery("select[name='event_end_date_hour'] option[value='15']").prop('selected', true);</script>
				<?php } ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_registration_start_date'))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_REGISTRATION_START_DATE'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo str_replace('icon-calendar', $iconCalendar, HTMLHelper::_('calendar', $this->item->registration_start_date, 'registration_start_date', 'registration_start_date', $this->datePickerFormat)) ; ?>
					<?php echo $this->lists['registration_start_hour'] . ' ' . $this->lists['registration_start_minute'] ; ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_registration_type', 1))
		{
    		$options   = [];
    		$options[] = HTMLHelper::_('select.option', 0, Text::_('EB_INDIVIDUAL_GROUP'));
    		$options[] = HTMLHelper::_('select.option', 1, Text::_('EB_INDIVIDUAL_ONLY'));
    		$options[] = HTMLHelper::_('select.option', 2, Text::_('EB_GROUP_ONLY'));
    		$options[] = HTMLHelper::_('select.option', 3, Text::_('EB_DISABLE_REGISTRATION'));
     		$options[] = HTMLHelper::_('select.option', 4, "Phone Bookings Only");
   
    		$this->lists['registration_type'] = HTMLHelper::_(
    			'select.genericlist',
    			$options,
    			'registration_type',
    			' class="input-xlarge form-select" ',
    			'value',
    			'text',
    			$this->item->registration_type
    		);
		    
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>"><?php echo Text::_('EB_REGISTRATION_TYPE'); ?></div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $this->lists['registration_type'] ; ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_cut_off_date'))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo EventbookingHelperHtml::getFieldLabel('cut_off_date', Text::_('EB_CUT_OFF_DATE'), Text::_('EB_CUT_OFF_DATE_EXPLAIN')); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo str_replace('icon-calendar', $iconCalendar, HTMLHelper::_('calendar', $this->item->cut_off_date, 'cut_off_date', 'cut_off_date', $this->datePickerFormat)) ; ?>
					<!-- <?php echo $this->lists['cut_off_hour'] . ' ' . $this->lists['cut_off_minute'] ; ?> -->
					<div id="cutoffhelp" class="form-text">This value defaults to the day before the event. You can change it here.<br>If someone tries to book on your event after this date, they will only be able to go on the waiting list. You can "Promote" them from the waiting list if you want to.</div>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_publish_up', 0))
		{
		?>
			<div class="<?php echo $controlGroupClass; ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_PUBLISH_UP'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo HTMLHelper::_('calendar', $this->item->publish_up, 'publish_up', 'publish_up', $this->datePickerFormat . ' %H:%M:%S', ['class' => 'input-medium']); ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_publish_down', 0))
		{
		?>
			<div class="<?php echo $controlGroupClass; ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_PUBLISH_DOWN'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo HTMLHelper::_('calendar', $this->item->publish_down, 'publish_down', 'publish_down', $this->datePickerFormat . ' %H:%M:%S', ['class' => 'input-medium']); ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_price', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_PRICE'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="number" name="individual_price" id="individual_price" class="input-medium form-control" size="10" value="<?php echo $this->item->individual_price; ?>" />
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_price_text'))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo EventbookingHelperHtml::getFieldLabel('price_text', Text::_('EB_PRICE_TEXT'), Text::_('EB_PRICE_TEXT_EXPLAIN')); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="text" name="price_text" id="price_text" class="input-xlarge form-control" value="<?php echo $this->escape($this->item->price_text); ?>" />
				</div>
			</div>
		<?php
		}

		if ($this->config->get('activate_simple_tax') && $this->config->get('fes_show_tax_rate', 1))
		{
		?>
            <div class="<?php echo $controlGroupClass;?>">
                <div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_TAX_RATE'); ?>
                </div>
                <div class="<?php echo $controlsClass; ?>">
                    <input type="number" name="tax_rate" id="tax_rate" class="input-medium form-control" size="10" value="<?php echo $this->item->tax_rate; ?>" />
                </div>
            </div>
		<?php
		}

		if ($this->config->get('fes_show_private_booking_count'))
		{
		?>
			<div class="<?php echo $controlGroupClass;?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo EventbookingHelperHtml::getFieldLabel('private_booking_count', Text::_('EB_PRIVATE_BOOKING_COUNT'), Text::_('EB_PRIVATE_BOOKING_COUNT_EXPLAIN')); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="number" min="0" step="1" name="private_booking_count" id="private_booking_count" class="input-medium form-control" size="10" value="<?php echo $this->item->private_booking_count; ?>" />
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_waiting_list_capacity'))
		{
		?>
			<div class="<?php echo $controlGroupClass;?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo EventbookingHelperHtml::getFieldLabel('waiting_list_capacity', Text::_('EB_WAITING_LIST_CAPACITY')); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="number" min="0" step="1" name="waiting_list_capacity" id="waiting_list_capacity" class="input-medium form-control" size="10" value="<?php echo $this->item->waiting_list_capacity; ?>" />
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_custom_registration_handle_url', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo EventbookingHelperHtml::getFieldLabel('registration_handle_url', Text::_('EB_CUSTOM_REGISTRATION_HANDLE_URL'), Text::_('EB_CUSTOM_REGISTRATION_HANDLE_URL_EXPLAIN')); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="url" name="registration_handle_url" id="registration_handle_url"
						   class="input-xxlarge form-control" size="10" value="<?php echo $this->item->registration_handle_url; ?>" />
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_attachment', 0))
		{
		?>
			<div class="<?php echo $controlGroupClass;?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo EventbookingHelperHtml::getFieldLabel('attachment', Text::_('EB_ATTACHMENT'), Text::_('EB_ATTACHMENT_EXPLAIN')); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="file" name="attachment" />
					<?php
					if ($user->authorise('core.admin', 'com_eventbooking'))
					{
						echo $this->lists['available_attachment'];
					}

					if ($this->item->attachment)
					{
						Text::_('EB_CURRENT_ATTACHMENT');

						$attachmentRootLink = Uri::root(true) . '/' . ($this->config->attachments_path ?: 'media/com_eventbooking') . '/';

						$attachments = explode('|', $this->item->attachment);

						for ($i = 0, $n = count($attachments); $i < $n; $i++)
						{
							$attachment = $attachments[$i];

							if ($i > 0)
							{
								echo '<br />';
							}
							?>
							<a href="<?php echo $attachmentRootLink . $attachment; ?>" target="_blank"><?php echo $attachment; ?></a>
							<?php
						}
					?>
						<input type="checkbox" name="del_attachment" value="1"/><?php echo Text::_('EB_DELETE_CURRENT_ATTACHMENT'); ?>
					<?php
					}
					?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_notification_emails', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_NOTIFICATION_EMAILS'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="text" name="notification_emails" class="form-control" size="70" value="<?php echo $this->item->notification_emails ; ?>" />
				</div>
			</div>
		<?php
		}

		if ($this->config->activate_deposit_feature)
		{
		?>
			<div class="<?php echo $controlGroupClass; ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_DEPOSIT_AMOUNT'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="number" name="deposit_amount" id="deposit_amount" class="input-medium form-control d-inline-block" size="5" value="<?php echo $this->item->deposit_amount; ?>"/>&nbsp;&nbsp;<?php echo $this->lists['deposit_type']; ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_paypal_email', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_PAYPAL_EMAIL'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="text" name="paypal_email" class="form-control" size="50" value="<?php echo $this->item->paypal_email ; ?>" />
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_members_discount_apply_for'))
		{
		?>
			<div class="<?php echo $controlGroupClass; ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_MEMBERS_DISCOUNT_APPLY_FOR'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $this->lists['members_discount_apply_for']; ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_activate_waiting_list'))
		{
		?>
			<div class="<?php echo $controlGroupClass; ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_ENABLE_WAITING_LIST'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $this->lists['activate_waiting_list']; ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_collect_member_information'))
		{
		?>
			<div class="<?php echo $controlGroupClass; ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_COLLECT_MEMBER_INFORMATION'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $this->lists['collect_member_information']; ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_prevent_duplicate_registration'))
		{
		?>
			<div class="<?php echo $controlGroupClass; ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_PREVENT_DUPLICATE'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $this->lists['prevent_duplicate_registration']; ?>
				</div>
			</div>
		<?php
		}
		if ($this->config->event_custom_field)
		{
			foreach ($this->form->getFieldset('basic') as $field)
			{
				$submitEventAccess = $field->getAttribute('submit_event_access');

				if ($submitEventAccess !== null && !in_array($submitEventAccess, $user->getAuthorisedViewLevels()))
				{
					continue;
				}
				if (strpos($field->label,"Main Leader") !== false) {
				    
				    if (!$field->value)
				    {
				        $field->value = $user->id;
				    }
			    ?>
				<div class="<?php echo $controlGroupClass;  ?>">
					<div class="<?php echo $controlLabelClass; ?>">
						<?php echo $field->label;?>
					</div>
					<div class="<?php echo $controlsClass; ?>">
					    <select name="params[field_leader_id1]" id="params_field_leader_id1" class="input-xlarge"> 	
                  		<?php if ($this->eventCoordinator) { 
                    		foreach ($this->leaders as $row) 
                    		{
                    		?>			
                    			<option value="<?php echo $row->id; ?>" <?php if ($row->id == $field->value) echo " selected"; ?>> <?php echo $row->name; ?> </option>	  
                    		<?php
                    		}
                  		}
                  		else
                  		{
                     		foreach ($this->leaders as $row) 
                    		{
                    		    if ($row->id==$field->value)
                    		    {
                 		   ?> <option value="<?php echo $row->id; ?>" selected> <?php echo  $row->name; ?> </option> 
                  		   <?php
                  		           break;
                    		    }
                    		}
                  		}
                		?>
                		</select>
					</div>
				</div>
			<?php
				}
				if (strpos($field->label,"Co-Leader 1 (optional)") !== false) {
			    ?>
				<div class="<?php echo $controlGroupClass;  ?>">
					<div class="<?php echo $controlLabelClass; ?>">
						<?php echo $field->label;?>
					</div>
					<div class="<?php echo $controlsClass; ?>">
					    <select name="params[field_leader_id2]" id="params_field_leader_id2" class="input-xlarge"> 	
		                <option></option>
                		<?php
                		foreach ($this->leaders as $row) 
                		{
                		?>			
                			<option value="<?php echo $row->id; ?>" <?php if ($row->id == $field->value) echo " selected"; ?>> <?php echo $row->name; ?> </option>	  
                		<?php
                		}
                		?>
                		</select>
                		<div id="leader2help" class="form-text">Optional second leader. If you add someone here, they will be added as a registrant too.</div>
					</div>
				</div>
			<?php
				}
				if (strpos($field->label,"Co-Leader 2 (optional)") !== false) {
			    ?>
				<div class="<?php echo $controlGroupClass;  ?>">
					<div class="<?php echo $controlLabelClass; ?>">
						<?php echo $field->label;?>
					</div>
					<div class="<?php echo $controlsClass; ?>">
					    <select name="params[field_leader_id3]" id="params_field_leader_id3" class="input-xlarge" > 	
		                <option></option>
                		<?php
                		foreach ($this->leaders as $row) 
                		{
                		?>			
                			<option value="<?php echo $row->id; ?>" <?php if ($row->id == $field->value) echo " selected"; ?>> <?php echo $row->name; ?> </option>	  
                		<?php
                		}
                		?>
                		</select>
                		<div id="leader3help" class="form-text">Optional third leader. If you add someone here, they will be added as a registrant too.</div>
					</div>
				</div>
			<?php
				}
			}
		}

		if ($this->config->event_custom_field)
		{
			foreach ($this->form->getFieldset('basic') as $field)
			{
				$submitEventAccess = $field->getAttribute('submit_event_access');

				if ($submitEventAccess !== null && !in_array($submitEventAccess, $user->getAuthorisedViewLevels()))
				{
					continue;
				}
				if (strpos($field->label,"Cancel Reason") == false && strpos($field->label,"Distance") == false && strpos($field->label,"Main Leader") == false && strpos($field->label,"Co-Leader 1 (optional)") == false && strpos($field->label,"Co-Leader 2 (optional)") == false) {
				    

			?>
				<div class="<?php echo $controlGroupClass;  ?>">
					<div class="<?php echo $controlLabelClass; ?>">
						<?php echo $field->label;?>
					</div>
					<div class="<?php echo $controlsClass; ?>">
						<?php echo $field->input; ?>
			<?php
    			if (strpos($field->label,"Address for walk"))
				{
				    
				    ?><div id="addresshelp" class="form-text">You can enter either <ol><li>a melway reference e.g. 32 H8 (just the reference. Don't add any words or spaces before or after the reference)</li><li>
				    an address (Type a bit and wait for the autocomplete)</li><li>
				    Latitude, Longitude e.g.  -37.806428,145.381924 (comma separated, no spaces)</li></0l>
				    The system will try to generate a Latitude, Longitude from the address and melway ref in order to display the location on a google map on the event page.</div>
				    
				    <?php
				}
    			if (strpos($field->label,"Petrol Cost/Litre"))
				{
				    ?><div id="petrolhelp" class="form-text">Enter a price here, and the system will automatically calculate the distance from Address for car pool point to Address for walk start, and then calculate the car pool cost per person.
				    </div><?php
				}
				if (strpos($field->label,"Address for car pool"))
				{
				    ?>
				    <select name="location" onchange="document.getElementById('params_field_address').value=this.value" id="location" class="form-select">
				        <option value="" selected>Stored locations</option>
				        <?php
                        $db = JFactory::getDbo();
				        $sql="select name, lat, `long` from #__eb_locations order by name asc";
                        $db->setQuery($sql);
                        $rows=$db->loadObjectList();
                        foreach ($rows as $v)
                        {
                            echo "<option value='".$v->lat.",".$v->long."'>".$v->name."</option>";
                        }
                        ?>
				    </select><div id="carpoolhelp" class="form-text">Selecting a location will copy in the Latitude, Longitude for that location into this field. This will then show the exact location on a google map on the event page.
				    Please contact <a href="contactwebadmin2">webadmin</a> if you would like to add a location to this list.</div>
				    <?php
				}
				?> </div>	</div> <?php
				}
			}
		}

		if ($this->config->get('fes_show_event_password', 0))
		{
		?>
			<div class="<?php echo $controlGroupClass; ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo EventbookingHelperHtml::getFieldLabel('event_password', Text::_('EB_EVENT_PASSWORD'), Text::_('EB_EVENT_PASSWORD_EXPLAIN')); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<input type="text" name="event_password" id="event_password" class="input-small" value="<?php echo $this->item->event_password; ?>"/>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_access', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo EventbookingHelperHtml::getFieldLabel('access', Text::_('EB_ACCESS'), Text::_('EB_ACCESS_EXPLAIN')); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $this->lists['access']; ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_registration_access', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo EventbookingHelperHtml::getFieldLabel('registration_access', Text::_('EB_REGISTRATION_ACCESS'), Text::_('EB_REGISTRATION_ACCESS_EXPLAIN')); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $this->lists['registration_access']; ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_published', 1) && EventbookingHelperAcl::canChangeEventStatus($this->item->id))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo Text::_('EB_PUBLISHED'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php
						if (isset($this->lists['published']))
						{
							echo $this->lists['published'];
						}
						else
						{
							echo EventbookingHelperHtml::getBooleanInput('published', $this->item->published);
						}
					?>
<div id="publishedHelp" class="form-text">Your event will not be listed until you select Yes. This can be handy if you
have to stop half way through entering information. You can save what you
have done, but it will not be ‘visible’ to other members until you select Yes</div>
              </div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_short_description', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo  Text::_('EB_SHORT_DESCRIPTION'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $editor->display('short_description', $this->item->short_description, '100%', '400', '90', '6') ; ?>
				</div>
			</div>
		<?php
		}

		if ($this->config->get('fes_show_description', 1))
		{
		?>
			<div class="<?php echo $controlGroupClass;  ?>">
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo  Text::_('EB_DESCRIPTION'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $editor->display('description', $this->item->description, '100%', '400', '90', '10') ; ?>
                <div id="descriptionhelp" class="form-text">Should include sufficient information, given that leader
may not actually be talking to club members. Note that email addresses and
phone numbers will be filtered out in the visitors view </div>
				</div>
			</div>
		<?php
		}

		if ($this->showCaptcha)
		{
			if ($this->captchaPlugin == 'recaptcha_invisible')
			{
				$style = ' style="display:none;"';
			}
			else
			{
				$style = '';
			}
		?>
			<div class="<?php echo $controlGroupClass;  ?>"<?php echo $style; ?>>
				<div class="<?php echo $controlLabelClass; ?>">
					<?php echo  Text::_('EB_CAPTCHA'); ?>
				</div>
				<div class="<?php echo $controlsClass; ?>">
					<?php echo $this->captcha; ?>
				</div>
			</div>
		<?php
		}

		if ($useTabs)
		{
			echo HTMLHelper::_('bootstrap.endTab');
		}

		if ($this->isMultilingual)
		{
			echo $this->loadTemplate('translation', ['editor' => $editor]);
		}

		if (count($this->plugins))
		{
			$count = 0;

			foreach ($this->plugins as $plugin)
			{
				$count++;
				echo HTMLHelper::_('bootstrap.addTab', 'event', 'tab_' . $count, Text::_($plugin['title']));
				echo $plugin['form'];
				echo HTMLHelper::_('bootstrap.endTab');
			}

		}

		if ($useTabs)
		{
			echo HTMLHelper::_('bootstrap.endTabSet');
		}
		?>
		<input type="hidden" name="id" value="<?php echo (int) $this->item->id; ?>"/>
		<input type="hidden" name="task" value="" />
		<input type="hidden" name="return" value="<?php echo $this->return; ?>" />
		<input type="hidden" name="activate_tickets_pdf" value="<?php echo $this->item->activate_tickets_pdf; ?>"/>
		<input type="hidden" name="send_tickets_via_email" value="<?php echo empty($this->item->send_tickets_via_email) ? 0 : 1; ?>"/>
		<input type="hidden" name="form_layout" value="form" />
	    <input type="hidden" id="cancel_before_date" name="cancel_before_date" value="<?php echo $this->item->cancel_before_date; ?>" />
		<?php echo HTMLHelper::_('form.token'); ?>
	</form>
	<?php
	if (in_array($this->config->get('submit_event_toolbar', 'top'), ['bottom', 'both']))
	{
	?>
        <div class="btn-toolbar" id="btn-toolbar-bottom">
			<?php echo $toolbarButtons; ?>
        </div>
	<?php
	}
	?>
</div>