<?php
/**
 * @package        	Joomla
 * @subpackage		Event Booking
 * @author  		Tuan Pham Ngoc
 * @copyright    	Copyright (C) 2010 - 2023 Ossolution Team
 * @license        	GNU/GPL, see LICENSE.php
 */

use Joomla\CMS\HTML\HTMLHelper;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Router\Route;
use Joomla\CMS\Factory;
use Joomla\Registry\Registry;

/* @var  $this EventbookingViewRegisterHtml */

$bootstrapHelper     = $this->bootstrapHelper;
$controlGroupClass   = $bootstrapHelper->getClassMapping('control-group');
$controlLabelClass   = $bootstrapHelper->getClassMapping('control-label');
$controlsClass       = $bootstrapHelper->getClassMapping('controls');
$btnPrimaryClass     = $bootstrapHelper->getClassMapping('btn btn-primary');

if ($this->config->get('form_layout') == 'stacked')
{
	$formClass = $bootstrapHelper->getClassMapping('form');
}
else
{
	$formClass = $bootstrapHelper->getClassMapping('form form-horizontal');
}

$memberFields = [];

foreach ($this->rowFields as $rowField)
{
	$memberFields[] = $rowField->name;
}

$memberFields = json_encode($memberFields);

if ($this->fieldSuffix && EventbookingHelper::isValidMessage($this->message->{'member_information_form_message' . $this->fieldSuffix}))
{
	$msg = $this->message->{'member_information_form_message' . $this->fieldSuffix};
}
else
{
	$msg = $this->message->member_information_form_message;
}

if (strlen($msg))
{
	$replaces = EventbookingHelperRegistration::buildEventTags($this->event, $this->config);

	foreach ($replaces as $key => $value) {
		$key = strtoupper($key);
		$msg = str_replace("[$key]", $value, $msg);
	}
?>
    <div class="eb-message"><?php echo HTMLHelper::_('content.prepare', $msg); ?></div>
<?php
}
EventbookingHelperJquery::loadjQuery();
EventbookingHelperJquery::validateForm();
?>
<script language="javascript">
    function checkDuplicates(numrows) {
        var form = document["eb-form-group-members"] ;
        if (document.getElementById('first_name_1').value == document.getElementById('first_name_2').value &&
            document.getElementById('last_name_1').value == document.getElementById('last_name_2').value)
        {
            alert('Member 1 and Member 2 need to be different');
            return false;
        }
        if (numrows == 3)
        {
            if (document.getElementById('first_name_1').value == document.getElementById('first_name_3').value &&
                document.getElementById('last_name_1').value == document.getElementById('last_name_3').value)
            {
                alert('Member 1 and Member 3 need to be different');
                return false;
            }
            if (document.getElementById('first_name_2').value == document.getElementById('first_name_3').value &&
                document.getElementById('last_name_2').value == document.getElementById('last_name_3').value)
            {
                alert('Member 2 and Member 3 need to be different');
                return false;
            }
        }
        return true;
      }
</script>
<script type="text/javascript">
jQuery(document).ready(function(){
   jQuery('input[type="radio"]').click(function(){
        var inputValue =jQuery(this).attr("value");
        var targetBox = jQuery("." + inputValue);
        jQuery(".box").not(targetBox).hide();
        jQuery(targetBox).show();
    });
    jQuery(".box").not(".red").hide();
    for (i = 1 ; i <= <?php echo $this->numberRegistrants;?>; i++)
    {
        jQuery("#selectBlue_"+i).selectize({
              sortField: 'text',
              placeholder: 'Select Member’s Name',
              render: {
                option: function (data, escape) {
                    return "<div data-kin='" + escape(data.data.kin) + 
                              "' data-relationship='" + escape(data.data.relationship) +
                              "' data-mobile='" + escape(data.data.mobile) + 
                              "' data-home='" + escape(data.data.home) + 
                              "' data-cb_next_of_kin_2_name='" + escape(data.data.cb_next_of_kin_2_name) + 
                             "' data-cb_next_of_kin_2_relationship='" + escape(data.data.cb_next_of_kin_2_relationship) + 
                             "' data-cb_next_of_kin_2_mobile='" + escape(data.data.cb_next_of_kin_2_mobile) + 
                             "' data-cb_next_of_kin_2_home='" + escape(data.data.cb_next_of_kin_2_home) + 
                             "' data-cb_firstaid='" + escape(data.data.cb_firstaid) + 
                             "' data-cb_firstaidlevel='" + escape(data.data.cb_firstaidlevel) + 
                             "' data-firstname='" + escape(data.data.firstname) + 
                             "' data-lastname='" + escape(data.data.lastname) + 
                             "' data-cb_homephone='" + escape(data.data.cb_homephone) + 
                             "' data-cb_mobphone='" + escape(data.data.cb_mobphone) + 
                             "' data-email='" + escape(data.data.email) + 
                             "'>" + escape(data.text) + "</div>"
                }
            }
        });
       jQuery("#selectBlue_"+i).on('change', function(event) {
        	var selectedValue = jQuery(this).val();
        	var id = jQuery(this).data('id');
        	var noteblue=document.getElementById('noteblue_'+id);
        	if (noteblue)
        	{
        	    noteblue.innerHTML='';
        	}
        	var selectedOption = jQuery(this)[0].selectize.getOption(selectedValue);
        	document.getElementById('kin_name_'+id).value = selectedOption.data('kin');
        	document.getElementById('kin_relationship_'+id).value = selectedOption.data('relationship');
        	document.getElementById('kin_mobile_phone_'+id).value = selectedOption.data('mobile');
        	document.getElementById('kin_home_phone_'+id).value = selectedOption.data('home');
        	document.getElementById('kin_name_2_'+id).value = selectedOption.data('cb_next_of_kin_2_name');
        	document.getElementById('kin_relationship_2_'+id).value = selectedOption.data('cb_next_of_kin_2_relationship');
        	document.getElementById('kin_mobile_phone_2_'+id).value = selectedOption.data('cb_next_of_kin_2_mobile');
        	document.getElementById('kin_home_phone_2_'+id).value = selectedOption.data('cb_next_of_kin_2_home');
        	document.getElementById('eb_Firstaid_'+id).value = selectedOption.data('cb_firstaid');
        	document.getElementById('eb_firstaidlevel_'+id).value = selectedOption.data('cb_firstaidlevel');
        	document.getElementById('first_name_'+id).value = selectedOption.data('firstname');
        	document.getElementById('last_name_'+id).value = selectedOption.data('lastname');
        	document.getElementById('phone_'+id).value = selectedOption.data('cb_homephone');
        	document.getElementById('eb_Mobile_'+id).value = selectedOption.data('cb_mobphone');
        	document.getElementById('email_'+id).value = selectedOption.data('email');
        });
    }
     
});
</script>

<?php 	$user = Factory::getUser();
	$userId = $user->get('id');
	$db = Factory::getDbo();
	$sql = "select 1 from jos_user_usergroup_map where (group_id = 59 or group_id = 8) and user_id = " .$userId;
	$db->setQuery($sql);
	$emergency_test=$db->loadResult();
	$sql = "select * from jos_comprofiler where user_id = " .$userId;
	$db->setQuery($sql);
	$kin=$db->loadObject();
	
	$fieldextras = new Registry($this->event->custom_fields);
    $carpool = $fieldextras->get('field_address');

?>
<form name="eb-form-group-members" id="eb-form-group-members" action="<?php echo Route::_('index.php?option=com_eventbooking&Itemid=' . $this->Itemid); ?>" autocomplete="off" class="<?php echo $formClass; ?>" method="post">
<?php
$dateFields = [];

for ($i = 1 ; $i <= $this->numberRegistrants; $i++)
{
	$headerText = Text::_('EB_MEMBER_REGISTRATION') ;
	$headerText = str_replace('[ATTENDER_NUMBER]', $i, $headerText);

	if ($this->config->allow_populate_group_member_data)
	{
	?>
		<div class="<?php echo $controlGroupClass; ?> clearfix">
			<h3 class="eb-heading">
				<?php echo $headerText ?>
			</h3>
		</div>
	<?php
	}
	else
	{
	?>
		<h3 class="eb-heading">
			<?php echo $headerText ?>
		</h3>
	<?php
	}
	
	$currentMemberFields = EventbookingHelperRegistration::getGroupMemberFields($this->rowFields, $i);

	$form = new RADForm($currentMemberFields);
	$form->setFieldSuffix($i);
	
	if ($i==1)
	{
	    $uid=$userId;
	}
	else
	{
	    if (array_key_exists('first_name_'.$i,$this->membersData))
	    {
       	    $db = Factory::getDbo();
        	$sql = "select id from jos_users where name='".$this->membersData['first_name_'.$i]." ".$this->membersData['last_name_'.$i]."'";
        	$db->setQuery($sql);
        	$uid=$db->loadResult();
        	if (!$uid)
        	{
        	    $uid=$userId;
        	}
	    }
	}
	
	// Get first user from current user
	$data = EventbookingHelperRegistration::getFormData($this->rowFields, $this->event->id, $uid);
	foreach ($data as $key => $data_value)
	{
	    if (($i==1 && $key !== 'first_name' && $key !== 'last_name') || ($i==2))
	    {
 		    $this->membersData[$key . '_'.$i] = $data_value;
	    }
	} 
     $user = Factory::getUser();
	if ($user->id && !isset($data['email']))
	{
		$this->membersData['email_'.$i] = $user->email;
	}

	$form->bind($this->membersData, $this->useDefaultValueForFields);

	$form->buildFieldsDependency();

	if (!$this->waitingList)
	{
		$form->setEventId($this->event->id);
	}

	$fields = $form->getFields();
	
    $db = Factory::getDBO();
    $query = "SELECT b.id, b.name, a.firstname, a.lastname, a.cb_firstaid, a.cb_firstaidlevel, a.cb_homephone, a.cb_mobphone, b.email, a.cb_next_of_kin_1_name, a.cb_next_of_kin_1_relationship,a.cb_next_of_kin_1_mobile,a.cb_next_of_kin_1_home,
    a.cb_next_of_kin_2_name, a.cb_next_of_kin_2_relationship,a.cb_next_of_kin_2_mobile,a.cb_next_of_kin_2_home FROM  #__users as b join #__comprofiler as a on a.user_id=b.id where b.id not in (select c.user_id from #__eb_registrants as c where c.user_id is not null and (c.published=1) and c.is_group_billing=0 and c.event_id = " . $this->event->id . " ) 
    and b.id in (select user_id from jos_user_usergroup_map where group_id=2) order by b.name" ;
    $db->setQuery($query);
    $rows = $db->loadObjectList();
    
    
    $query = "select count(user_id) from #__eb_registrants where is_group_billing=0 and (published=1) and user_id = " . $user->id . " and first_name is not null and event_id = " . $this->event->id ;
    $db->setQuery($query);
    $alreadyMe = $db->loadResult();
    
    $member1isme=false;
    if ($this->membersData['first_name_1'] .' '. $this->membersData['last_name_1'] === $user->name)
    {
        $member1isme=true;
    }
    
    if (!$alreadyMe && $i==1 && $member1isme)
    {
	?>
	  <label><input type="radio" name="colorRadio" value="red" checked> Add Me</label>
	  <label><input type="radio" name="colorRadio" value="blue"> Add Member</label>
	<hr>
     <div class="blue box">
    <?php
    }
    ?>

	<select name="selectBlue_<?php echo $i?>" id="selectBlue_<?php echo $i?>" data-id="<?php echo $i?>"> 	
	<option></option>
	<?php

    $selected=false;
	foreach ($rows as $row) 
	{
	?>			
		<option value="<?php echo $row->id; ?>" data-data='{"kin":"<?php echo $row->cb_next_of_kin_1_name;?>",
		"firstname":"<?php echo $row->firstname;?>",
		"lastname":"<?php echo $row->lastname;?>",
		"cb_firstaid":"<?php echo $row->cb_firstaid;?>",
		"cb_homephone":"<?php echo $row->cb_homephone;?>",
		"cb_mobphone":"<?php echo $row->cb_mobphone;?>",
		"cb_firstaidlevel":"<?php echo $row->cb_firstaidlevel;?>",
		"email":"<?php echo $row->email;?>",
		"cb_next_of_kin_2_name":"<?php echo $row->cb_next_of_kin_2_name;?>",
		"cb_next_of_kin_2_relationship":"<?php echo $row->cb_next_of_kin_2_relationship;?>",
		"cb_next_of_kin_2_mobile":"<?php echo $row->cb_next_of_kin_2_mobile;?>",
		"cb_next_of_kin_2_home":"<?php echo $row->cb_next_of_kin_2_home;?>",
		"relationship":"<?php echo $row->cb_next_of_kin_1_relationship;?>",
		"mobile":"<?php echo $row->cb_next_of_kin_1_mobile;?>",
		"home":"<?php echo $row->cb_next_of_kin_1_home;?>"}' <?php if ($this->membersData['first_name_'.$i] == $row->firstname && $this->membersData['last_name_'.$i] == $row->lastname) { $selected=true; echo 'selected';} ?>> 
		<?php echo $row->name; ?> </option>	  
	<?php
	}
	?>
	</select>
	<?php if ($selected) echo "<div id='noteblue_".$i."'><b>Note:</b> This data has been prefilled from previous registrations.</div>"; ?>
	<hr>
<?php
    if (!$alreadyMe && $i==1 && $member1isme)
    {
?>
	</div>
	<?php
	}
	//We don't need to use ajax validation for email field for group members
	if (isset($fields['email']))
	{
		/* @var RADFormField $emailField */
		$emailField = $fields['email'];
		$cssClass = $emailField->getAttribute('class');
		$cssClass = str_replace(',ajax[ajaxEmailCall]', '', $cssClass);
		$emailField->setAttribute('class', $cssClass);
	}
	// clear out member 1 if it is not me
    if ($i==1 && ($alreadyMe || !$member1isme))
    {
    	foreach ($fields as $field)
    	{
            $field->value='';
    	}
    }

	foreach ($fields as $field)
	{
        if ($field->name==="first_name_".$i || $field->name==="last_name_".$i || $field->name==="eb_Firstaid_".$i || $field->name==="eb_firstaidlevel_".$i || $field->name==="phone_".$i || 
            $field->name==="eb_Mobile_".$i || $field->name==="email_".$i || $field->title==="Cancel Reason" || $field->title==="Experience" || $field->name==="kin_name_2_".$i || 
            $field->name==="kin_relationship_2_".$i || $field->name==="kin_mobile_phone_2_".$i || $field->name==="kin_home_phone_2_".$i)
        {
            echo "<input type='hidden' name='".$field->name."' id='".$field->name."' value='".$field->value."'>";
            continue;
        }
	    if ($field->name == "eb_Areyouwillingtodrive_".$i && $carpool)
	    {
 	        $cssClass = $field->getAttribute('class');
	        $field->setAttribute('class', $cssClass.' validate[required]');
		    $field->setAttribute('data-errormessage-value-missing','As the leader has specified a car pool location, please indicate your driving preference.');
	    }
		$cssClass = $field->getAttribute('class');
		$cssClass = str_replace('equals[email]', 'equals[email_' . $i . ']', $cssClass);
		$field->setAttribute('class', $cssClass);

		echo $field->getControlGroup($bootstrapHelper);

		if ($field->type == 'Date')
		{
			$dateFields[] = $field->name;
		}
	}
	echo '<div class="form-text">Press space to bypass the area code</div><br>';

}
?>
	<div class="form-actions">
		<?php
			if (!$this->bypassNumberMembersStep)
			{
			?>
				<input type="button" id="btn-group-members-back" name="btn-group-members-back" class="<?php echo $btnPrimaryClass; ?>" value="<?php echo Text::_('EB_BACK'); ?>"/>
			<?php
			}
		?>
		<input onclick="return checkDuplicates(<?php echo $this->numberRegistrants;?>);" type="<?php echo $this->showBillingStep ? 'button' : 'submit';?>" id="btn-process-group-members" name="btn-process-group-members" class="<?php echo $btnPrimaryClass; ?>" value="<?php echo $this->showBillingStep ? Text::_('EB_NEXT'): Text::_('EB_PROCESS_REGISTRATION'); ?>" />
	</div>
	<input type="hidden" name="task" value="<?php echo $this->showBillingStep ? 'register.validate_and_store_group_members_data' : 'register.store_group_members_data'; ?>" />
	<input type="hidden" name="event_id" value="<?php echo $this->eventId; ?>" />
	<input type="hidden" name="number_registrants" value="<?php echo $this->numberRegistrants; ?>" />
</form>
